unit App_def;
interface

{$I options.pp}

uses
{$IFDEF Design}
 File_win,
{$ELSE}
 User_Win,
{$ENDIF}
 TV_box,
 App, Drivers, Views;

type
 TSRDBApp = object(TSApplication)
  FileWindow:PFilesWindow;
  constructor Init;
  destructor Done; virtual;
  function  GetPalette: PPalette; virtual;
  procedure InitMenuBar; virtual;
  procedure InitStatusLine; virtual;
  procedure Idle; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure UseFile;
  procedure DesFile;
  procedure DoAboutBox;
 end;

var
 SRDBApp: TSRDBApp;

implementation

uses
 Trace, Date_lib, crt,
 Info_def, Menu_cmd, Str_Def,
 DataFile, Records, Designer, Brousers,
 Objects, Menus;

constructor TSRDBApp.Init;
 begin
  WrLogStr(CurDateTime+'SRDB initialization starts ...');
  inherited Init;
  New(CountWindow,Init);
  InsertWindow(CountWindow);
  FreshCounter;
  InsertWindow(New(POpenWindow,Init));
  New(FileWindow,Init);
  InsertWindow(FileWindow);
  DisableCommands(TCommandSet(UseCmdSet)+TCommandSet(DesCmdSet));
  Message(Application,evBroadcast,cmOpenDataMsg,Nil);
  WrLogStr(CurDateTime+'SRDB initialization OK ...');
 end;
destructor TSRDBApp.Done;
 begin
  inherited Done;
 end;

const
  CSkeletColor =
        { Menu & Status line colors }{     Blue Window Colors      }
        #$71#$70#$78#$74#$4F#$46#$4E#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
     {     Brown Window Colors      }{     Gray Window Colors      }
    #$67#$6F#$6A#$13#$13#$6E#$4E#$3F#$70#$7F#$7A#$13#$13#$70#$4E#$7E +
     {   Dialog boxes colors - gray, blue, cyan ( $20 for each )   }
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

function TSRDBApp.GetPalette: PPalette;
 const
  P: array[apColor..apMonochrome] of string[Length(CAppColor)] =
    (CSkeletColor, CAppBlackWhite, CAppMonochrome);
 begin
  GetPalette := @P[AppPalette];
 end;

{$IFDEF Cir}
procedure TSRDBApp.InitMenuBar;
 var R: TRect;
 begin
  GetExtent(R); R.B.Y := R.A.Y + 1;
  MenuBar := New(PSMenuBar, Init(R, NewMenu(
    NewSubMenu('~1~ ', hcNoContext, NewMenu(
      NewItem('~1~ ','Enter',kbEnter,cmUse,  hcNoContext,
      NewItem('~2~ ',    'F4',kbF4,cmOrder,hcNoContext,
      NewItem('~3~ ',   'F5',kbF5,cmPart, hcNoContext,
      NewLine(
      NewItem('~4~ ','F2',kbF2,cmDesign, hcNoContext,
      NewItem('~5~  ','F1',kbF1,cmNewFile,hcNoContext,
      NewItem('~6~ ','',kbNoKey,cmRenFile,hcNoContext,
      NewSubMenu('~7~  ',hcNoContext,NewMenu(
       NewItem('~1~  ','',kbNoKey,cmDupFile,hcNoContext,
       NewItem('~2~  ', '',kbNoKey,cmDelFile,hcNoContext,
       NewItem('~3~  DBF-','',kbNoKey,cmImportDBF,hcNoContext,
       Nil)))),
      NewLine(
      NewItem('~8~ ','Alt-X',kbAltX,cmQuit,hcNoContext,
      nil))))))))))
      ),
    NewSubMenu('~2~ ',hcNoContext, NewMenu(
      NewItem('~1~  ','F1',kbF1,cmNewRec, hcNoContext,
      NewItem('~2~ ',  'F2',kbF2,cmEditRec,hcNoContext,
      NewItem('~3~ ', 'F8',kbF8,cmDupRec, hcNoContext,
      NewLine(
      NewItem('~4~ ','F3',kbF3,cmDelRec,hcNoContext,
      NewItem('~5~ ','F7',kbF7,cmMixRec,hcNoContext,
      NewLine(
      NewItem('~6~ ','F6',kbF6,cmRecLinks,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~3~ ',hcNoContext, NewMenu(
      NewItem('~1~   ', 'F9',kbF9,cmFullSel, hcNoContext,
      NewItem('~2~   ',   'F10',kbF10,cmQuerySel,hcNoContext,
      NewItem('~3~  ()','Shift-F6',kbShiftF6,cmLinksSel,hcNoContext,
      NewItem('~4~  ()','Shift-F7',kbShiftF7,cmProjectSel,hcNoContext,
      NewLine(
      NewItem('~5~ ','Shift-F4',kbShiftF4,cmSortSel, hcNoContext,
      NewItem('~6~   ()','Shift-F1',kbShiftF1,cmPrintSel,hcNoContext,
      NewItem('~7~  ','Shift-F2',kbShiftF2,cmCountSumm,hcNoContext,
      NewLine(
      NewItem('~8~  ','Shift-F3',kbShiftF3,cmEraseSel,hcNoContext,
      NewItem('~9~  ','Shift-F9',kbShiftF9,cmChangeSel,hcNoContext,
      nil)))))))))))
     ),
    NewSubMenu('~4~ ', hcNoContext, NewMenu(
      NewItem('~1~ ','F2',kbF2,cmEditFld,hcNoContext,
      NewItem('~2~ ',   'F1',kbF1,cmNewFld, hcNoContext,
      NewItem('~3~ ', 'F3',kbF3,cmDelFld, hcNoContext,
      NewLine(
      NewItem('~4~  ','',kbNoKey,cmMvUpFld,hcNoContext,
      NewItem('~5~  ','',kbNoKey,cmMvDnFld,hcNoContext,
      NewLine(
      NewItem('~6~  ','',kbNoKey,cmExpandFld,hcNoContext,
      NewItem('~7~   ','',kbNoKey,cmColapsFld,hcNoContext,
      nil)))))))))
     ),
    NewSubMenu('~5~ ',hcNoContext,NewMenu(
      NewItem('~1~  ','',kbNoKey,cmAbout,hcNoContext,
      nil)),
    nil)))))
  )));
 end;
{$ENDIF} {$IFDEF Lat}
procedure TSRDBApp.InitMenuBar;
 var R: TRect;
 begin
  GetExtent(R); R.B.Y := R.A.Y + 1;
  MenuBar := New(PSMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~U~se',  'Enter',kbEnter,cmUse,hcNoContext,
      NewItem('~O~rder','F4',   kbF4, cmOrder,hcNoContext,
      NewItem('~P~art', 'F5',   kbF5, cmPart, hcNoContext,
      NewLine(
      NewItem('~D~esign',  'F2',kbF2, cmDesign, hcNoContext,
      NewItem('~N~ew file','F1',kbF1, cmNewFile,hcNoContext,
      NewItem('Parameters','',kbNoKey,cmRenFile,hcNoContext,
      NewSubMenu('Dreadful jobs',hcNoContext,NewMenu(
       NewItem('Duplicate file','',kbNoKey,cmDupFile,hcNoContext,
       NewItem('Terminate file','',kbNoKey,cmDelFile,hcNoContext,
       NewItem('Import DBF-file','',kbNoKey,cmImportDBF,hcNoContext,
       Nil)))),
      NewLine(
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))))))))
      ),
    NewSubMenu('~R~ecord',hcNoContext, NewMenu(
      NewItem('~N~ew',   'F1',  kbF1, cmNewRec, hcNoContext,
      NewItem('~E~dit',  'F2',  kbF2, cmEditRec,hcNoContext,
      NewItem('~D~uplicate','F8',kbF8,cmDupRec, hcNoContext,
      NewLine(
      NewItem('E~r~ase',   'F3',kbF3,cmDelRec,hcNoContext,
      NewItem('~M~ix with','F7',kbF7,cmMixRec,hcNoContext,
      NewLine(
      NewItem('~L~inks','F6',kbF6,cmRecLinks,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~S~election',hcNoContext, NewMenu(
      NewItem('create ~F~ull',  'F9', kbF9, cmFullSel, hcNoContext,
      NewItem('by ~Q~uery',     'F10',kbF10,cmQuerySel,hcNoContext,
      NewItem('by ~L~inks',     'Shift-F6',kbShiftF6,cmLinksSel,  hcNoContext,
      NewItem('by P~r~ojection','Shift-F7',kbShiftF7,cmProjectSel,hcNoContext,
      NewLine(
      NewItem('~S~ort',         'Shift-F4',kbShiftF4,cmSortSel,  hcNoContext,
      NewItem('~T~ext output',  'Shift-F1',kbShiftF1,cmPrintSel, hcNoContext,
      NewItem('~C~olumn counts','Shift-F2',kbShiftF2,cmCountSumm,hcNoContext,
      NewLine(
      NewItem('~E~rase all',    'Shift-F3',kbShiftF3,cmEraseSel, hcNoContext,
      NewItem('C~h~ange field value','Shift-F9',kbShiftF9,cmChangeSel,hcNoContext,
      nil)))))))))))
     ),
    NewSubMenu('F~i~eld', hcNoContext, NewMenu(
      NewItem('~E~dit', 'F2',kbF2,cmEditFld,hcNoContext,
      NewItem('~N~ew',  'F1',kbF1,cmNewFld, hcNoContext,
      NewItem('E~r~ase','F3',kbF3,cmDelFld, hcNoContext,
      NewLine(
      NewItem('Move ~u~p','',kbNoKey,cmMvUpFld,hcNoContext,
      NewItem('Move ~d~n','',kbNoKey,cmMvDnFld,hcNoContext,
      NewLine(
      NewItem('E~x~pand pointer',    '',kbNoKey,cmExpandFld,hcNoContext,
      NewItem('~C~olapse to pointer','',kbNoKey,cmColapsFld,hcNoContext,
      nil)))))))))
     ),
    NewSubMenu('~H~elp',hcNoContext,NewMenu(
      NewItem('~A~bout...','',kbNoKey,cmAbout,hcNoContext,
      nil)),
    nil)))))
  )));
 end;
{$ENDIF}

procedure TSRDBApp.InitStatusLine;
 var R: TRect;
{$IFDEF Cir}
 function New_Esc(P:PStatusItem): PStatusItem;
  begin New_Esc:=NewStatusKey('~Esc~ ', kbEsc, cmClose,P) end;
 function New_Can(P:PStatusItem): PStatusItem;
  begin New_Can:=NewStatusKey('~Esc~ ', kbEsc, cmCancel,P) end;
 function New_Sel(P:PStatusItem): PStatusItem;
  begin New_Sel:=New_Can(NewStatusKey('~Enter~ ',kbEnter,cmClose,P)) end;
 function New_ER(P:PStatusItem): PStatusItem;
  begin New_ER:=New_Can(NewStatusKey('~F1~ ',kbF1,cmOK,P)) end;
 function New_CanClose(P:PStatusItem): PStatusItem;
  begin New_CanClose:=New_Can(NewStatusKey('~F1~ ',kbF1,cmClose,P)) end;
{$ENDIF} {$IFDEF Lat}
 function New_Esc(P:PStatusItem): PStatusItem;
  begin New_Esc:=NewStatusKey('~Esc~ Close', kbEsc, cmClose,P) end;
 function New_Can(P:PStatusItem): PStatusItem;
  begin New_Can:=NewStatusKey('~Esc~ Cancel', kbEsc, cmCancel,P) end;
 function New_Sel(P:PStatusItem): PStatusItem;
  begin New_Sel:=New_Can(NewStatusKey('~Enter~ Select',kbEnter,cmClose,P)) end;
 function New_ER(P:PStatusItem): PStatusItem;
  begin New_ER:=New_Can(NewStatusKey('~F1~ Accept',kbF1,cmOK,P)) end;
 function New_CanClose(P:PStatusItem): PStatusItem;
  begin New_CanClose:=New_Can(NewStatusKey('~F1~ Accept',kbF1,cmClose,P)) end;
{$ENDIF}
 function QuerySortList(P:PStatusItem): PStatusItem;
  begin QuerySortList:=New_CanClose(
{$IFDEF Cir}
   NewStatusKey('~F2~ ',kbF2,cmAddSortEl,
   NewStatusKey('~F3~ ',kbF3,cmDelSortEl,
{$ENDIF} {$IFDEF Lat}
   NewStatusKey('~F2~ Add',kbF2,cmAddSortEl,
   NewStatusKey('~F3~ Del',kbF3,cmDelSortEl,
{$ENDIF}
   P)))
  end;
 function NextPrevWinKeys: PStatusItem;
  begin NextPrevWinKeys:=
   NewStatusKey('', kbTab,      cmNext,
   NewStatusKey('', kbShiftTab, cmPrev, nil))
  end;
 const
  uskBrouse = 0;
  uskSelect = 1;
  uskInclud = 2;
  uskSetBrs = 3;
 function UseStatusKeys(usk:byte):PStatusItem;
  function Tail_0:PStatusItem;
   begin Tail_0:=
{$IFDEF Cir}
    NewStatusKey('~F7~ ',    kbF7,cmMixRec,
    NewStatusKey('~F8~ ',kbF8,cmDupRec,
{$ENDIF} {$IFDEF Lat}
    NewStatusKey('~F7~ Mix',kbF7,cmMixRec,
    NewStatusKey('~F8~ Dup',kbF8,cmDupRec,
{$ENDIF}
    NextPrevWinKeys))
   end;
  function Tail_1:PStatusItem;
   var Tail:PStatusItem;
   begin
    case usk of
     uskBrouse,uskInclud,uskSetBrs:Tail:=
{$IFDEF Cir}
     NewStatusKey('~F6~ ',kbF6,cmRecLinks,Tail_0);
{$ENDIF} {$IFDEF Lat}
     NewStatusKey('~F6~ Links', kbF6,cmRecLinks,Tail_0);
{$ENDIF}
     uskSelect:Tail:=Tail_0;
    end;
    case usk of
     uskBrouse,uskSelect:Tail_1:=
{$IFDEF Cir}
     NewStatusKey('~F4~ ', kbF4, cmOrder,
     NewStatusKey('~F5~ ',  kbF5, cmPart,
{$ENDIF} {$IFDEF Lat}
     NewStatusKey('~F4~ Order', kbF4, cmOrder,
     NewStatusKey('~F5~ Part',  kbF5, cmPart,
{$ENDIF}
     Tail));
     uskInclud,uskSetBrs:Tail_1:=Tail;
    end;
   end;
  begin
   UseStatusKeys:=
{$IFDEF Cir}
    NewStatusKey('~F1~ ',   kbF1, cmNewRec,
    NewStatusKey('~F2~ ',  kbF2, cmEditRec,
    NewStatusKey('~F3~ ',   kbF3, cmDelRec,
{$ENDIF} {$IFDEF Lat}
    NewStatusKey('~F1~ New',   kbF1, cmNewRec,
    NewStatusKey('~F2~ Edit',  kbF2, cmEditRec,
    NewStatusKey('~F3~ Del',   kbF3, cmDelRec,
{$ENDIF}
    Tail_1)))
  end;
 begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(1800, 1899, { Colapse File List }
    New_CanClose(
{$IFDEF Cir}
     NewStatusKey('~F2~   ',kbF2,cmSetSorsFld,
     NewStatusKey('~F3~  ', kbF3,cmSetFldValue,nil))),
{$ENDIF} {$IFDEF Lat}
     NewStatusKey('~F2~ equvalent field',kbF2,cmSetSorsFld,
     NewStatusKey('~F3~ initial value', kbF3,cmSetFldValue,nil))),
{$ENDIF}
   NewStatusDef(1700, 1799, { Edit Query List }
{$IFDEF Cir}
    QuerySortList(
     NewStatusKey('~F4~ ',kbF4,cmToggle,
     NewStatusKey('~F5~ ', kbF5,cmChFldVal,Nil))),
{$ENDIF} {$IFDEF Lat}
    QuerySortList(
     NewStatusKey('~F4~ Relation',kbF4,cmToggle,
     NewStatusKey('~F5~ Value',   kbF5,cmChFldVal,Nil))),
{$ENDIF}
   NewStatusDef(1600, 1699, { Edit Sort List }
{$IFDEF Cir}
    QuerySortList(NewStatusKey('~F4~  ',kbF4,cmToggle,Nil)),
{$ENDIF} {$IFDEF Lat}
    QuerySortList(NewStatusKey('~F4~ Toggle',kbF4,cmToggle,Nil)),
{$ENDIF}
   NewStatusDef(1500, 1599, { Field select }
{$IFDEF Cir}
    New_Sel(NewStatusKey('~F2~ /',kbF2,cmExpColaps,Nil)),
{$ENDIF} {$IFDEF Lat}
    New_Sel(NewStatusKey('~F2~ Expand/Colapse',kbF2,cmExpColaps,Nil)),
{$ENDIF}
   NewStatusDef(1450, 1499, { Included Brouser }
    New_Esc(UseStatusKeys(uskInclud)),
   NewStatusDef(1400, 1449, { Selection brouser }
    New_Esc(UseStatusKeys(uskSetBrs)),
   NewStatusDef(1350, 1399, { Record selector }
    New_Sel(UseStatusKeys(uskSelect)),
   NewStatusDef(1300, 1349, { Record brouser }
    New_Esc(UseStatusKeys(uskBrouse)),
   NewStatusDef(1200, 1299, { Field brouser }
    New_Esc(
{$IFDEF Cir}
     NewStatusKey('~F1~ ',  kbF1, cmNewFld,
     NewStatusKey('~F2~ ', kbF2, cmEditFld,
     NewStatusKey('~F3~ ', kbF3, cmDelFld,
{$ENDIF} {$IFDEF Lat}
     NewStatusKey('~F1~ New',  kbF1, cmNewFld,
     NewStatusKey('~F2~ Edit', kbF2, cmEditFld,
     NewStatusKey('~F3~ Erase', kbF3, cmDelFld,
{$ENDIF}
     NextPrevWinKeys)))),
   NewStatusDef(1000, 1009, { Edit record part of record }
    New_ER(nil),
   NewStatusDef(1010, 1019, { Edit pointer part of record }
{$IFDEF Cir}
    New_ER(NewStatusKey('~F2~ ', kbF2, cmEditPtr,Nil)),
{$ENDIF} {$IFDEF Lat}
    New_ER(NewStatusKey('~F2~ Edit', kbF2, cmEditPtr,Nil)),
{$ENDIF}
   NewStatusDef(1020, 1029, { File brouser }
{$IFDEF Cir}
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,
    NewStatusKey('~Enter~ ',kbEnter,cmUse,
    NewStatusKey('~F1~ ', kbF1,cmNewFile,
    NewStatusKey('~F2~ ',kbF2,cmDesign,
{$ENDIF} {$IFDEF Lat}
    NewStatusKey('~Alt-X~ Exit',kbAltX,cmQuit,
    NewStatusKey('~Enter~ Use',kbEnter,cmUse,
    NewStatusKey('~F1~ New',kbF1, cmNewFile,
    NewStatusKey('~F2~ Design', kbF2,cmDesign,
{$ENDIF}
    NextPrevWinKeys)))),
   NewStatusDef(1100, 1110, { Simple chois }
    New_Sel(Nil),
   NewStatusDef($0000, $FFFF,
{$IFDEF Cir}
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,Nil),
{$ENDIF} {$IFDEF Lat}
    NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,Nil),
{$ENDIF}
   nil))))))))))))))));
 end;

procedure TSRDBApp.DoAboutBox;
begin MessageBox(
  #3+ErrStr(esDoAboutBox0)+#13+
  #3+ErrStr(esDoAboutBox1)+#13+
  #3+ErrStr(esDoAboutBox2)+#13+
  #3+ErrStr(esDoAboutBox3),
  nil, mfInformation or mfOKButton);
end;

procedure TSRDBApp.UseFile;
 var FId:byte;
 begin
  SetUseMode;
  with FileWindow^ do begin
   FId:=GetFileId(WinCursor);
   if DFArr[FId]^.Fields^.Length>0
    then InsertWindow(New(PStdBrouse,Init(FId)))
    else ErrNum(esMissFields0);
  end;
 end;
procedure TSRDBApp.DesFile;
 begin
  SetDesignMode;
  with FileWindow^ do
   InsertWindow(New(PDesignBrouse,Init(GetFileId(WinCursor))));
 end;

procedure TSRDBApp.Idle;
 begin
  inherited Idle;
  FreshCounter;
  Delay(20); { Leave resources } 
{ if CountEnabled then Message(Application,evBroadcast,cmCount,Nil); }
 end;

procedure TSRDBApp.HandleEvent(var Event: TEvent);
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evBroadcast:case Event.Command of
    cmUseFile:UseFile;
    cmDesFile:DesFile;
    else Exit;
   end;
   evCommand:case Event.Command of
    cmAbout:DoAboutBox;
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

end.