unit brousers;
interface
{$I options.pp}

uses
 selector, datafile,
 win_def,
 Views, Drivers;

type
 PFileBrouser = ^TFileBrouser;
 TFileBrouser = object (TBrouseWindow)
  MyId:byte; PDF:PDataFile;
  AfterY:byte; SummCounted:boolean;
  PatInd,LastInd:longint; ExFld:byte;
  constructor Init(
   aPFS:PFileVirtSel; aMyId,aExFld,aBrType,aVstart,aVafter:byte);
  destructor Done; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  function LastLine:longint; virtual;
  procedure ShowWCursor; virtual;
  procedure SetICursor(Ind:longint); virtual;
  procedure ShowCnt; virtual;
  procedure ShowCnt_1; virtual;
  procedure ShowCnt_2; virtual;
  function Line(l:longint):string; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure CorrectEnable; virtual;
  function  RecOK(l:longint):boolean; virtual;
  procedure EraseSel;
 private
  procedure ModifyRec(old,dup:boolean);
  procedure EraseOrMix(EInd,NInd:longint; OK:boolean);
  procedure EraseRecU;
  procedure EraseRec;
  procedure MixRec;
  procedure SetOrder;
  procedure SetPart;
  procedure RecLinks;
  procedure FullSel;
  procedure QuerySel;
  procedure LinksSel;
  procedure ProjectSel;
  procedure WriteSummLine(s:string);
  function  EvalSummLine:string;
  procedure ShowSumm(Eval:boolean);
  procedure SortSel;
  procedure PrintSel;
  procedure ChangeSel;
 end;
 PStdBrouse = ^TStdBrouse;
 TStdBrouse = object (TFileBrouser)
  constructor Init(aFId:byte);
 end;
 PStdIncluded = ^TStdIncluded;
 TStdIncluded = object (TFileBrouser)
  constructor Init(aFId:byte; aInd:longint; aExFld:byte);
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure ShowCnt_1; virtual;
 end;
 PStdSelectOne = ^TStdSelectOne;
 TStdSelectOne = object (TFileBrouser)
  PPtr:^longint;
  constructor Init(aFId:byte; var Ind:longint);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;
 PStdSelection = ^TStdSelection;
 TStdSelection = object (TFileBrouser)
  constructor Init(aFId:byte; aPFS:PFileVirtList; aInd:longint);
  procedure SetICursor(Ind:longint); virtual;
 end;
 TPReport = object
  PFB:PFileBrouser;
  Tab:string[20]; t:text; LPP:byte;
  constructor Run(aPFB:PFileBrouser; OutFName, StdFName:string);
  procedure Head; virtual;
  procedure Body; virtual;
  procedure Tail; virtual;
  function DoPrint:boolean; virtual;
 end;

procedure PrintFile0(var tx:text; LPP:word);
procedure PrintFile (var tx:text);

implementation

uses
{$IFDEF Turbo} Printer, Dos, Skl_defs, {$ENDIF}
{$IFDEF FPC} Printer, Linux, Sk_types, {$ENDIF}
 File_win, Records, Menu_cmd, Info_def, TV_box, Str_Def,
 App, Objects;

constructor TFileBrouser.Init(
 aPFS:PFileVirtSel; aMyId,aExFld,aBrType,aVstart,aVafter:byte);
 var
  s:string; R:TRect; aDX,aAY,aVS:byte; SLen:longint; aSLE:boolean;
 begin
  aAY:=aVafter; if aAY>0 then inc(aAY);
  s:=DFArr[aMyId]^.StdHeaderLine(aExFld,aSLE);
  aDX:=min(79,Length(s)); aDX:=max(20,aDX);
  if (aVafter>0) or (aExFld<>$FF) then aDX:=max(50,aDX);
  with aPFS^ do SLen:=CurEnd-CurStart;
  aVS:=max(4+(ord(aSLE) shl 1),
        min(SLen+2+(ord(aSLE) shl 1),22-aVStart-aAY));
  R.Assign(0,0,aDX+1,aVS+aVStart+aAY+1);
  case aBrType of
   bwUChois:R.Move(79-aDX,0);
   bwUIncl,bwUSet:R.Move((80-aDX) div 2,0);
  end;
  inherited Init(aBrType,aPFS,R,aVStart,aVS,copy(s,1,aDX-1),aSLE);
  ExFld:=aExFld; AfterY:=aAY; MyId:=aMyId; PDF:=DFArr[MyId];
  MyCmdSet:=TCommandSet(UseCmdSet+[cmClose,cmCancel,cmPrev,cmNext]);
  case bwCase of
   bwURoot,bwUChois:
    PFileStdSel(PData)^.SetIndexId(PDF^.SelectFIndex);
  end;
  inc(UseCount);
 end;
destructor TFileBrouser.Done;
 begin
  case bwCase of
   bwURoot,bwUChois:PDF^.LastUsedIndex:=PFileStdSel(PData)^.GetIndexId;
  end;
  Dec(UseCount); inherited Done; Dispose(PFileVirtSel(PData),Done);
 end;
function TFileBrouser.GetTitle(MaxSize: Integer): TTitleStr;
 var sd:string[80]; L:longint; s:string;
 begin
  L:=PDF^.Data^.Length; Str(L,sd);
{$IFDEF Cir}
  sd:=sd+' '; if L<>1 then sd:=sd+'';
  s:=PDF^.LName+': '+sd; Str(PDF^.RecSize,sd);
  sd:=sd+' '; if PDF^.RecSize<>1 then sd:=sd+'';
  if L<>1 then sd:='  '+sd else sd:='  '+sd;
{$ENDIF}{$IFDEF Lat}
  sd:=sd+' record'; if L<>1 then sd:=sd+'s';
  s:=PDF^.LName+': '+sd; Str(PDF^.RecSize,sd);
  sd:=sd+' byte'; if PDF^.RecSize<>1 then sd:=sd+'s';
  sd:=', each is '+sd+' long';
{$ENDIF}
  GetTitle:=copy(s+sd,1,MaxSize);
 end;
function TFileBrouser.LastLine:longint;
 var Sel:PFileVirtSel absolute PData;
 begin with Sel^ do LastLine:=CurEnd-CurStart end;
procedure TFileBrouser.ShowCnt_1;
 var Sel:PFileVirtSel absolute PData;
 begin
  WriteStr(DrawPos.x,1,JustStr(Sel^.LimitStr,Size.X-2),1);
 end;
procedure TFileBrouser.WriteSummLine(s:string);
 begin WriteStr(DrawPos.x,DrawPos.y+DrawSize.Y+1,JustStr(s,Size.X-2),1) end;
function TFileBrouser.EvalSummLine:string;
 var
  Sel:PFileVirtSel absolute PData;
  PB:PBlock; i,Ind:longint; MaxFld,j:byte;
  FPos:array[0..FldMaxCnt] of word;
  FTyp:array[0..FldMaxCnt] of byte;
  FFlg:array[0..FldMaxCnt] of boolean;
 procedure Prepare;
  var c:word; j:byte; Fld:TFldRec;
  begin with PDF^ do begin
   MaxFld:=Fields^.Length-1; c:=1;
   for j:=0 to MaxFld do begin
    Fields^.GetRec(j,Fld);
    FPos[j]:=c; FTyp[j]:=Fld.FType;
    FFlg[j]:=FldGetFlags(Fld,ffCntSumm);
    inc(c,Fld.Size);
   end;
  end end;
 procedure AddNum(t:byte; var s,d);
  var rs:real absolute s; rd:real absolute d;
      ls:longint absolute s; ld:longint absolute d;
  begin case t of CFReal:rd:=rd+rs; CFLong:ld:=ld+ls; end end;
 begin
  GetMem(PB,PDF^.RecSize); PDF^.RecClear(PB^); Prepare;
  if LastLine>0 then for i:=0 to LastLine-1 do begin
   if RecOK(i) then
    for j:=0 to MaxFld do if (j<>ExFld) and FFlg[j]
     then AddNum(FTyp[j],Sel^.PR^[FPos[j]],PB^[FPos[j]]);
   if (i and $1F)=0
    then WriteSummLine(PDF^.StdBrouseLine(-1,i,PB^,ExFld,True));
  end;
  EvalSummLine:=PDF^.StdBrouseLine(-1,-1,PB^,ExFld,True);
  FreeMem(PB,PDF^.RecSize);
 end;
procedure TFileBrouser.ShowSumm(Eval:boolean);
 begin
  if Eval
   then WriteSummLine(EvalSummLine)
   else WriteSummLine(PDF^.StdSummLine(ExFld));
  SummCounted:=Eval;
 end;
procedure TFileBrouser.ShowCnt_2;
 var s:string; c,i:byte;
 begin
  if GetState(sfDragging) then c:=3
   else if GetState(sfActive) then c:=2 else c:=1;
  Str(LastLine,s);
{$IFDEF Cir}
  s:=Copy(' '+s+'  ',1,Size.X-3);
{$ENDIF}{$IFDEF Lat}
  s:=Copy(' '+s+' selected ',1,Size.X-3);
{$ENDIF}
  for i:=length(s)+1 to Size.X-3 do
   if (HeadLine[i+1]=VLChar) and (AfterY=0) then s:=s+'' else s:=s+'';
  WriteStr(2,Size.Y-1,s,c);
 end;
procedure TFileBrouser.ShowCnt;
 var s:string[10];
 begin
  ShowCnt_1; ShowCnt_2;
  if SummLineExist then ShowSumm(LastLine<50);
 end;
procedure TFileBrouser.ShowWCursor;
 var i,j,v0:byte; Fld:TFldRec;
 begin
  inherited ShowWCursor;
  LastInd:=PFileVirtSel(PData)^.FPtr(WinCursor);
  v0:=DrawPos.y+DrawSize.Y; if SummLineExist then Inc(v0,2);
  if AfterY>0 then if WinCursor=LastLine
   then for i:=1 to AfterY-1 do
    WriteStr(DrawPos.x,v0+i,Blank(Size.X-2),1)
   else with PDF^ do begin
    i:=0;
    for j:=0 to Fields^.Length-1 do
     if FldULin(j) and (j<>ExFld) then begin
      inc(i); Fields^.GetRec(j,Fld);
      WriteStr(DrawPos.x,v0+i,
       JustStr(FldName(j)+': '+
       FldStdString(Fld,PFileVirtSel(PData)^.PR^[FldPos(j)],5),Size.X-2),1);
     end;
   end;
 end;
function TFileBrouser.Line(l:longint):string;
 var s:string;
 begin with PFileVirtSel(PData)^ do if RecOK(l)
  then Line:=PDF^.StdBrouseLine(WrkInd,l,PR^,ExFld,false)
  else if WrkInd<>-1
   then begin s:=BlankLine; ReplStr(s,
{$IFDEF Cir} '<  >' {$ENDIF}{$IFDEF Lat} '< erased >' {$ENDIF}
    ,3); Line:=s end
   else if l=LastLine
    then begin
     s:=PDF^.StdBrouseLine(WrkInd,-1,PR^,ExFld,false);
     ReplStr(s,
{$IFDEF Cir} '<  >' {$ENDIF} {$IFDEF Lat} '< nobody >' {$ENDIF}
    ,2); Line:=s;
    end
    else Line:=BlankLine;
 end;
procedure TFileBrouser.SetICursor(Ind:longint);
 var OK:boolean;
 begin with PFileStdSel(PData)^ do begin
  InitLimits;
  if Ind=-1
   then WinCursor:=LastLine
   else if GetIndexId<>$FF then begin
    OK:=True; WinCursor:=PDF^.IndArr[GetIndexId]^.Find(Ind,OK);
    if OK
     then if WinCursor<CurStart
      then WinCursor:=0 else if WinCursor>CurEnd
       then WinCursor:=LastLine else Dec(WinCursor,CurStart)
     else WinCursor:=LastLine;
   end else WinCursor:=Ind;
  SetWCursor(WinCursor);
 end end;
procedure TFileBrouser.CorrectEnable;
 begin
  if not RecOK(WinCursor) then DisableCommands(TCommandSet(UseCmdSet1));
  case bwCase of
   bwUIncl,bwUSet:DisableCommands(TCommandSet([cmOrder,cmPart]));
  end;
  case bwCase of
   bwURoot,bwUChois,bwUIncl:DisableCommands(TCommandSet([cmSortSel]));
  end;
  case bwCase of
   bwUChois:DisableCommands(TCommandSet(UseCmdSet2));
  end;
  if PDF^.FLCnt=0
   then DisableCommands(TCommandSet([cmRecLinks,cmLinksSel]));
  if SummCounted or (not SummLineExist)
   then DisableCommands(TCommandSet([cmCountSumm]));
 end;
procedure TFileBrouser.HandleEvent(var Event: TEvent);
 var PFB:PFileBrouser;
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evBroadcast:case Event.Command of
    cmRecErased:begin { clear erased record from brouse list }
     PFB:=Event.InfoPtr;
     if MyId=PFB^.MyId then PFileVirtSel(PData)^.DelInd(PFB^.LastInd);
     Exit
    end;
    cmSetCursor:begin SetICursor(LastInd); Exit end;
    {              Only one window for file:                }
    { cmUseFile:if Event.InfoPtr=PDF then Select else Exit; }
    else Exit;
   end;
   evCommand:case Event.Command of
    cmNewRec:ModifyRec(false,false);
    cmEditRec,cmBrouseDouble:
     if RecOK(WinCursor) then ModifyRec(true,false);
    cmDupRec:ModifyRec(false,true);
    cmDelRec:EraseRec;
    cmMixRec:MixRec;
    cmOrder:SetOrder;
    cmPart:SetPart;
    cmRecLinks:RecLinks;
    cmFullSel:FullSel;
    cmLinksSel:LinksSel;
    cmProjectSel:ProjectSel;
    cmQuerySel:QuerySel;
    cmSortSel:SortSel;
    cmPrintSel:PrintSel;
    cmCountSumm:ShowSumm(True);
    cmEraseSel:EraseSel;
    cmChangeSel:ChangeSel;
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

{------------------------------------------------------}

function TFileBrouser.RecOK(l:longint):boolean;
 begin with PFileVirtSel(PData)^ do begin
  WrkInd:=FPtr(l);
  if WrkInd<>-1
   then begin
    PCF^.GetRec(WrkInd,PR^);
    RecOK:=PR^[0]<>$FF
   end
   else RecOK:=False;
 end end;

procedure TFileBrouser.EraseOrMix(EInd,NInd:longint; OK:boolean);
 begin
  if OK then begin
   LastInd:=EInd;
   Message(Owner,evBroadcast,cmRecErased,@Self);
   LastInd:=NInd;
  end;
  Message(Owner,evBroadcast,cmSetCursor,@Self);
 end;
procedure TFileBrouser.EraseRecU;
 begin
  EraseOrMix(LastInd,PFileVirtSel(PData)^.FPtr(WinCursor+1),
   PDF^.RecErase(LastInd,-1))
 end;
procedure TFileBrouser.EraseRec;
 begin if YN_Num2(esEraseRecMsg,esAreYouShure) then EraseRecU end;
procedure TFileBrouser.MixRec;
 var Sors,Dest:longint;
 begin
  Sors:=LastInd; Dest:=-1; LepkaNumEdit(MyId,Sors,Dest);
  if (Sors>=0) and (Dest>=0) and (Sors<>Dest)
   then EraseOrMix(Sors,Dest,PDF^.RecErase(Sors,Dest))
 end;

procedure TFileBrouser.ModifyRec(old,dup:boolean);
 var
  PB:PBlock; LI,Ind:longint; Sucess:boolean;
 begin
  GetMem(PB,PDF^.RecSize); Ind:=LastInd; Sucess:=True;
  if old or dup
   then PDF^.Data^.GetRec(Ind,PB^)
   else begin
    PDF^.RecClear(PB^);
    if ExFld<>$FF then Move(PatInd,PB^[PDF^.FldPos(ExFld)],4);
   end;
  if not old then begin LI:=PDF^.Data^.Length; Ind:=LI end;
  if InputLayout(PB^,MyId,Ind,bwCase,ExFld) then begin
   PDF^.RecUpdate(Ind,PB^,old,false);
   if (not old) and (Ind>=LI)
    then PFileVirtSel(PData)^.AddInd(Ind,Sucess);
   LastInd:=Ind; Message(Owner,evBroadcast,cmSetCursor,@Self);
  end;
  FreeMem(PB,PDF^.RecSize);
 end;

procedure TFileBrouser.FullSel;
 begin
  Application^.Insert(New(PCreateSelWindow,Init(@Self,$ff)));
  Message(Application,evBroadcast,cmCreateFullSel,Nil);
 end;

procedure TFileBrouser.QuerySel;
 var PQL:PQueryList;
 begin
  if SelectQueryList(@Self,PQL) then begin
   Application^.Insert(New(PCreateSelWindow,Init(@Self,$ff)));
   Message(Application,evBroadcast,cmCreateQuerSel,PQL);
  end;
  Dispose(PQL,Done);
 end;

procedure TFileBrouser.LinksSel;
 var i:byte;
 begin
  i:=PDF^.LinkChois;
  if i<PDF^.FLCnt then begin
   Application^.Insert(New(PCreateSelWindow,Init(@Self,i)));
   Message(Application,evBroadcast,cmCreateLinkSel,Nil);
  end;
 end;

procedure TFileBrouser.ProjectSel;
 var i:byte;
 begin
  i:=PDF^.PntrChois;
  if i<>$FF then begin
   Application^.Insert(New(PCreateSelWindow,Init(@Self,i)));
   Message(Application,evBroadcast,cmCreateProjSel,Nil);
  end;
 end;

procedure TFileBrouser.SetOrder;
 var i:byte;
 begin with PFileStdSel(PData)^ do begin
  i:=GetIndexId; PDF^.SelectIndex(i);
  SetIndexId(i); SetICursor(LastInd);
 end end;
procedure TFileBrouser.SetPart;
 begin with PFileStdSel(PData)^ do if GetIndexId<>$FF then begin
  ChangeLimits; SetICursor(LastInd);
 end end;

procedure TFileBrouser.RecLinks;
 var i:byte;
 begin
  i:=PDF^.LinkChois;
  if i<PDF^.FLCnt then begin
   PDF^.LastFileLink:=i;
   with PDF^.FLArr[i] do if DFArr[FileId]^.Fields^.Length>1
    then Application^.InsertWindow(
     New(PStdIncluded,Init(FileId,LastInd,FldId)));
  end;
 end;

procedure TFileBrouser.SortSel;
 begin
  if SelectSortList(@Self) then SetICursor(LastInd);
 end;

procedure TFileBrouser.EraseSel;
 var i:longint;
 begin if LastLine>0 then if YN_Num2(esEraseSelMsg,esAreYouShure)
  then for i:=LastLine-1 downto 0 do
   begin SetWCursor(i); if RecOK(i) then EraseRecU end
 end;

procedure TFileBrouser.ChangeSel;
 function SelectInd:byte;
  var P:PChoisList; i,k:byte; A:Small;
  begin with PDF^ do begin
   New(P,Init); k:=0; SelectInd:=$FF;
   for i:=0 to Fields^.Length-1 do if PFileVirtSel(PData)^.GetIndexId<>i
   {$IFDEF Cyr}
    then begin A[k]:=i; P^.Insert('  '+FldName(i)); Inc(k) end;
   A[k]:=$FF; P^.Insert('  '); P^.SetCursor(k);
   {$ENDIF}
   {$IFDEF Lat}
    then begin A[k]:=i; P^.Insert('change '+FldName(i)); Inc(k) end;
   A[k]:=$FF; P^.Insert('cancel changes'); P^.SetCursor(k);
   {$ENDIF}
   {$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
   {$IFDEF FPC} P^.Chois(i); {$ENDIF}
   if i<k then SelectInd:=A[i];
  end end;
 var
  IndId:byte; Fld:TFldRec; Value:small;
  i:longint; s:string;
 begin
  IndId:=SelectInd;
  if IndId<>$FF then begin
   PDF^.Fields^.GetRec(IndId,Fld);
   FldStdClear(Fld,Value); EditFirstFldValue(Fld,Value,1);
   Str(LastLine,s);
   {$IFDEF Cyr}
   s:='  '+s+'  !';
   {$ENDIF}
   {$IFDEF Lat}
   s:='I will change '+s+' records !';
   {$ENDIF}
   if LastLine>0 then with PDF^ do begin
    if YN_Win2(s,ErrStr(esAreYouShure)) then for i:=0 to LastLine-1 do begin
     Str(i,s);
     {$IFDEF Cyr}
     WriteStr(2,Size.Y-1,Copy('   '+s+' ',1,Size.X-3),0{1});
     {$ENDIF}
     {$IFDEF Lat}
     WriteStr(2,Size.Y-1,Copy(' changing line '+s+' ',1,Size.X-3),0{1});
     {$ENDIF}
     if RecOK(i) then with PFileVirtSel(PData)^ do begin
      Move(Value,PR^[FldPos(IndId)],Fld.Size);
      RecUpdate(WrkInd,PR^,true,true);
     end;
    end;
    SetICursor(LastInd);
   end;
  end;
 end;

{------------------------------------------------------}

constructor TStdBrouse.Init(aFId:byte);
 Const Y0 = 5;
 begin
  inherited Init(New(PFileStdSel,Init(DFArr[aFId])),
   aFId,$FF,bwURoot,Y0,DFArr[aFId]^.FullShowCount);
  HelpCtx:=hcUseFile; LastInd:=-1; SetICursor(LastInd);
 end;

{------------------------------------------------------}

constructor TStdIncluded.Init(aFId:byte; aInd:longint; aExFld:byte);
 var PSS:PFileStdSel; Fld:TFldRec; y0,aYH:byte; Sm:Small;
 begin
  DFArr[aFId]^.Fields^.GetRec(aExFld,Fld);
  if FldGetFlags(Fld,ffFulShow) then y0:=1 else y0:=0;
  aYH:=4+DFArr[Fld.FPtr]^.Fields^.Length;
  New(PSS,Init(DFArr[aFId]));
  PSS^.SetLimits(aExFld,@aInd);
  inherited Init(PSS,aFId,
   aExFld,bwUIncl,aYH,DFArr[aFId]^.FullShowCount-y0);
  PatInd:=aInd; HelpCtx:=hcIncluded;
  LastInd:=-1; SetICursor(LastInd);
 end;
function TStdIncluded.GetTitle(MaxSize: Integer): TTitleStr;
 begin
{$IFDEF Cyr}
  GetTitle:=copy(PDF^.LName+';  '+PDF^.FldName(ExFld)+'   ',1,MaxSize);
{$ENDIF}
{$IFDEF Lat}
  GetTitle:=copy(PDF^.LName+'; field '+PDF^.FldName(ExFld)+' fixed ',1,MaxSize);
{$ENDIF}
 end;
procedure TStdIncluded.ShowCnt_1;
 var s1:string[FldMaxLen+2]; Fld:TFldRec; i:byte; c:word; PB:PBlock;
 begin
  PDF^.Fields^.GetRec(ExFld,Fld);
  s1:=' '+PDF^.FldName(ExFld)+'.';
  with DFArr[Fld.FPtr]^ do begin
   GetMem(PB,RecSize); Data^.GetRec(PatInd,PB^); c:=1;
   if PB^[0]=$FF
    then { Close fails }
{$IFDEF Cyr}
     WriteStr(DrawPos.x,1,'  ',2)
{$ENDIF}
{$IFDEF Lat}
     WriteStr(DrawPos.x,1,' Erased record',2)
{$ENDIF}
    else for i:=0 to Fields^.Length-1 do begin
     Fields^.GetRec(i,Fld); if i=1 then s1:=Blank(length(s1));
     WriteStr(DrawPos.x,1+i,
      JustStr(s1+FldName(i)+': '+FldStdString(Fld,PB^[c],4),Size.X-2),2);
     inc(c,Fld.Size);
    end;
   FreeMem(PB,RecSize);
  end;
 end;

{------------------------------------------------------}

constructor TStdSelectOne.Init(aFId:byte; var Ind:longint);
 Const Y0 = 5;
 begin
  inherited Init(New(PFileStdSel,Init(DFArr[aFId])),
   aFId,$FF,bwUChois,Y0,DFArr[aFId]^.FullShowCount);
  HelpCtx:=hcSelOne; PPtr:=addr(Ind); LastInd:=PPtr^;
  if LastInd=-1 then SetWCursor(0) else SetICursor(LastInd);
 end;
procedure TStdSelectOne.HandleEvent(var Event: TEvent);
 var Handled:boolean;
 procedure CloseSelf(Command:word);
  begin
   EndModal(Command); Handled:=True;
   if Command=cmClose then if RecOK(WinCursor)
    then PPtr^:=PFileStdSel(PData)^.WrkInd else PPtr^:=-1;
  end;
 begin
  Handled:=False;
  case Event.What of
   evCommand:case Event.Command of
     cmCancel,cmClose:CloseSelf(Event.Command);
    end;
  end;
  if Handled
   then ClearEvent(Event)
   else inherited HandleEvent(Event);
 end;

{------------------------------------------------------}

constructor TStdSelection.Init(aFId:byte; aPFS:PFileVirtList; aInd:longint);
 Const Y0 = 5;
 begin
  inherited Init(aPFS,aFId,$FF,bwUSet,Y0,DFArr[aFId]^.FullShowCount);
  HelpCtx:=hcSelection; LastInd:=aInd; SetICursor(LastInd);
 end;
procedure TStdSelection.SetICursor(Ind:longint);
 var i:word;
 begin with PFileVirtList(PData)^ do begin
  InitLimits; WinCursor:=LastLine;
  if (Ind<>-1) and (LastLine>0) then for i:=0 to LastLine-1 do
   if FPtr(i)=Ind then WinCursor:=i;
  SetWCursor(WinCursor);
 end end;

{------------------------------------------------------------}

procedure PrintFile0(var tx:text; LPP:word);
 var ch:Char; LineCt:word;
 begin
  if YN_Num2(esPrFileReady,esPrFileOKQst)
   then begin
    MsgNum(esPrFilePaper);
    reset(tx); LineCt:=0;
    while not eof(tx) do begin
     Read(tx,ch); write(lst,ch);
     if ch=chr(10) then begin
      inc(LineCt);
      if LineCt mod LPP = 0 then begin
       write(lst,chr(12)); MsgNum(esPrFileNewPp);
      end;
     end;
    end;
    close(tx);
   end;
 end;
procedure PrintFile(var tx:text); begin PrintFile0(tx,55) end;

{----------------------------------------------------}

constructor TPReport.Run(aPFB:PFileBrouser; OutFName, StdFName:string);
 var FlOK,RpOK:boolean; fname:string; n:text;
 begin
  PFB:=aPFB; LPP:=0;
  if FileExists(OutFName)
   then begin assign(n,OutFName); reset(n); readln(n,fname); System.close(n) end
   else fname:=FExpand(StdFName);
  repeat
   FlOK:=False;
   EditSomeString(ErrStr(esEntDos_Name),fname,50);
   RpOK:=EditStringOK;
   if RpOK then begin
    {$I-} assign(t,fname); rewrite(t); {$I+}
    if IOResult=0 then begin
     Head; Body; Tail;
     System.close(t); FlOK:=True;
     assign(n,OutFName); rewrite(n); writeln(n,fname); System.close(n);
    {$IFDEF Cyr}
    end else LifeError('   ');
    {$ENDIF}
    {$IFDEF Lat}
    end else LifeError('Imposible access to file');
    {$ENDIF}
   end else FlOK:=True;
  until FlOK;
  if RpOK then if DoPrint then if LPP=0
   then PrintFile(t)
   else PrintFile0(t,LPP);
 end;

procedure TPReport.Head; begin end;
procedure TPReport.Body; begin end;
procedure TPReport.Tail; begin end;
function TPReport.DoPrint:boolean; begin DoPrint:=True end;

{------------------------------------------------------------}

type
 TPrintSel = object (TPReport)
  DoPr:boolean; Dlm:char;
  s0,s1,LL:string;
  SetPt:boolean;
  constructor Run(aPFB:PFileBrouser; aDlm:char; aDoPr:boolean);
  procedure Head; virtual;
  procedure Body; virtual;
  procedure Tail; virtual;
  function DoPrint:boolean; virtual;
  procedure Convert(Pt:char);
 end;

const TabCh=#9; SpcCh=#32;

constructor TPrintSel.Run(aPFB:PFileBrouser; aDlm:char; aDoPr:boolean);
 begin
  Dlm:=aDlm; DoPr:=aDoPr;
  inherited Run(aPFB,'OutFile.Nam','Report.TXT');
 end;
function TPrintSel.DoPrint:boolean; begin DoPrint:=DoPr end;
procedure TPrintSel.Convert(Pt:char);
 var W:string; l:byte;
 begin with PFB^ do begin
  s1:='';
  repeat
   l:=pos(VLChar,s0);
   if l>0
    then begin w:=copy(s0,1,l-1); System.Delete(s0,1,l) end
    else begin w:=s0; s0:='' end;
   if Dlm=TabCh then w:=ClearSp(w);
   SetPt:=(s1='') and (PDF^.CntSize>0);
   s1:=s1+Dlm+w; if SetPt then s1:=s1+Pt;
  until s0='';
 end end;
procedure TPrintSel.Head;
 procedure WrOuner;
  var so1:string[FldMaxLen+2]; Fld:TFldRec; i:byte; c:word; PB:PBlock;
  begin with PFB^ do begin
{$IFDEF Cyr}
   WriteLn(t,Tab+'  '+PDF^.FldName(ExFld)+'  .');
{$ENDIF}
{$IFDEF Lat}
   WriteLn(t,Tab+' Field '+PDF^.FldName(ExFld)+' fixed.');
{$ENDIF}
   PDF^.Fields^.GetRec(ExFld,Fld);
   so1:=PDF^.FldName(ExFld)+'.';
   with DFArr[Fld.FPtr]^ do begin
    GetMem(PB,RecSize); Data^.GetRec(PatInd,PB^); c:=1;
    if PB^[0]=$FF
     then
{$IFDEF Cyr}
      WriteLn(t,Tab+'       ')
{$ENDIF}
{$IFDEF Lat}
      WriteLn(t,Tab+' Erased record')
{$ENDIF}
     else for i:=0 to Fields^.Length-1 do begin
      Fields^.GetRec(i,Fld); if i=1 then so1:=Blank(length(so1));
      WriteLn(t,Tab+' '+
       JustStr(so1+FldName(i)+': '+FldStdString(Fld,PB^[c],4),70));
      inc(c,Fld.Size);
     end;
    FreeMem(PB,RecSize);
   end;
  end end;
 var Dummy:boolean;
 begin with PFB^ do begin
  if bwCase=bwUIncl
   then Tab:=Blank(3)+Dlm
   else Tab:=Blank(10)+Dlm;
{$IFDEF Cyr}
  writeln(t,Tab+'  '+PDF^.LName);
{$ENDIF}
{$IFDEF Lat}
  writeln(t,Tab+' File '+PDF^.LName);
{$ENDIF}
  writeln(t);
  if bwCase=bwUIncl
   then WrOuner
   else writeln(t,Tab+PFileVirtSel(PData)^.LimitStr);
  writeln(t);
  s0:=PDF^.StdHeaderLine(ExFld,Dummy); Convert(' ');
  LL:=''; RExpandStr(LL,Length(s1),'-');
  writeln(t,LL); Writeln(t,s1); writeln(t,LL);
 end end;
procedure TPrintSel.Body;
 var i:longint; s:string[10];
 begin with PFB^ do begin
  if LastLine>0 then for i:=0 to LastLine-1 do if RecOK(i) then begin
   with PFileVirtSel(PData)^
    do s0:=PDF^.StdBrouseLine(WrkInd,i,PR^,ExFld,false);
   Convert('.'); Writeln(t,s1);
   if i and $07=0 then begin
 {$IFDEF Cyr}
    Str(i,s); WriteStr(2,Size.Y-1,Copy('   '+s+' ',1,Size.X-3),0);
 {$ENDIF}
 {$IFDEF Lat}
    Str(i,s); WriteStr(2,Size.Y-1,Copy(' printing line '+s+' ',1,Size.X-3),0);
 {$ENDIF}
   end;
  end;
 end end;
procedure TPrintSel.Tail;
 begin with PFB^ do begin
  writeln(t,LL);
  if SummLineExist then begin
   s0:=EvalSummLine; WriteSummLine(s0); SummCounted:=True;
   Convert(' '); Writeln(t,s1); writeln(t,LL);
  end;
  ShowCnt_2;
 end end;

{------------------------------------------------------------}

procedure TFileBrouser.PrintSel;
 var P:PChoisList; i:byte; TPS:TPrintSel;
 begin
  New(P,Init);
  P^.Insert(ErrStr(esAllgSpcPrnt));
  P^.Insert(ErrStr(esAllgSpcFile));
  P^.Insert(ErrStr(esAllgTabFile));
  P^.SetCursor(0);
  {$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
  {$IFDEF FPC} P^.Chois(i); {$ENDIF}
  case i of
   0:TPS.Run(@Self,SpcCh,true);
   1:TPS.Run(@Self,SpcCh,false);
   2:TPS.Run(@Self,TabCh,false);
  end;
 end;

{------------------------------------------------------------}

end.

