unit date_lib;

{$I options.pp}

{$IFDEF Turbo} {$D-,I-,S-} {$ENDIF}

interface

function SIntStr(L:word):string;
function CurDateTime:string;

type
 DateRec = record d,m,y:byte; end;
 TimeRec = record h,m,s:byte; end;
 Interval= record d,h,m:byte; end;

procedure DateClear(var dt:DateRec);
function  DateStr_0(dt:DateRec):string;        { dd.mm       }
function  DateStr_1(dt:DateRec):string;        { dd.mm.yy    }
function  DateStr_2(dt:DateRec):string;        { dd.mm.yyyy  }
function  DateStr_3(dt:DateRec):string;        { dd.mm.yyyy.}
function  DateDayOfWeek(dt:DateRec):byte;
function  DateDay_of_week(dt:DateRec):string;  { leters      }
function  DateMonth(dt:DateRec):string;        { leters      }
function  DateYear_0(dt:DateRec):string;       { yyyy        }
function  DateYear_1(dt:DateRec):string;       { yyyy .     }
procedure DateGetd(var dt:DateRec);
procedure DateSetd(dt:DateRec);
function  DateLess(dt0,dt:DateRec):boolean;    { dt0<=dt ? }
function  DateEqu(dt0,dt:DateRec):boolean;
procedure DateSet_last_day_of_month(var dt:DateRec);
procedure DateDec_day(var dt:DateRec);
procedure DateIncDay(var dt:DateRec; n:word);

function  TimeStr_0(tm:TimeRec):string;   { hh:mm    }
function  TimeStr_1(tm:TimeRec):string;   { hh:mm:ss }
function  TimeEqu(tm,t:TimeRec):boolean;
function  TimeLess(tm,t:TimeRec):boolean; { tm<=t ? }
procedure TimeIncSec(var tm:TimeRec; w:word);
procedure TimeDecSec(var tm:TimeRec; w:word);
procedure TimeGetT(var tm:TimeRec);
procedure TimeClear(var tm:TimeRec);

procedure IntervalClear(var int:Interval);
function  IntervalStr_0(int:Interval):string;  { dd/hh    }
function  IntervalStr_1(int:Interval):string;  { dd/hh:mm }
function  IntervalEqu(int,I:Interval):boolean;

implementation

{$IFDEF Turbo} uses dos; {$ENDIF}
{$IFDEF FPC} uses linux; {$ENDIF}

function CurDateTime:string;
 var D:DateRec; T:TimeRec;
 begin
  DateGetD(D); TimeGetT(T);
  CurDateTime:=DateStr_2(D)+' '+TimeStr_1(T)+' ';
 end;

function ThoDig(b:byte):string;
 var s:string[2];
 begin str(b:2,s); if s[1]=' ' then s[1]:='0'; ThoDig:=s end;

function SIntStr(L:word):string;
 var w:word; s1,s0:string[5];
 begin
  w:=(L div 60) mod 100;
  str(L mod 60,s0); if length(s0)<2 then s0:='0'+s0;
  str(w:2,s1); SIntStr:=s1+':'+s0;
 end;

function  DateStr_0(dt:DateRec):string;        { dd.mm       }
 begin DateStr_0:=ThoDig(dt.d)+'.'+ThoDig(dt.m) end;
function  DateStr_1(dt:DateRec):string;        { dd.mm.yy    }
 begin DateStr_1:=DateStr_0(dt)+'.'+ThoDig(dt.y mod 100) end;
function  DateStr_2(dt:DateRec):string;        { dd.mm.yyyy  }
 begin DateStr_2:=DateStr_0(dt)+'.'+DateYear_0(dt) end;
function  DateStr_3(dt:DateRec):string;        { dd.mm.yyyy.}
 begin DateStr_3:=DateStr_0(dt)+'.'+DateYear_1(dt) end;
function  DateYear_0(dt:DateRec):string;       { yyyy        }
 var s:string; w:integer;
 begin w:=1900+dt.y; str(w:4,s); DateYear_0:=s end;
function  DateYear_1(dt:DateRec):string;       { yyyy .     }
 begin DateYear_1:=DateYear_0(dt)+'.' end;
function m_len(m,y:byte):byte;
 begin
  case m of
   1,3,5,7,8,10,12:m_len:=31; 4,6,9,11:m_len:=30;
   2:if (y mod 4 = 0) and (y<>100) then m_len:=29 else m_len:=28;
  end;
 end;
procedure DateSet_last_day_of_month(var dt:DateRec);
 begin with dt do d:=M_len(m,y) end;
function  DateDayOfWeek(dt:DateRec):byte;
 var doy,dom,i:integer;
 begin with dt do begin {  day_of_week  }
  doy:=(y+(y+3) div 4) mod 7;
  dom:=0; i:=1;
  while i<m do begin Inc(dom,M_len(i,y) mod 7); inc(i) end;
  doy:=(doy + dom + d-1) mod 7;
  DateDayOfWeek:=doy;
 end end; {  day_of_week  }
function  DateDay_of_week(dt:DateRec):string;  { leters      }
 begin {  day_of_week  }
  case DateDayOfWeek(dt) of
   0 : DateDay_of_week := '';
   1 : DateDay_of_week := '';
   2 : DateDay_of_week := '';
   3 : DateDay_of_week := '';
   4 : DateDay_of_week := '';
   5 : DateDay_of_week := '';
   6 : DateDay_of_week := '';
  end; { case }
 end; {  day_of_week  }
function  DateMonth(dt:DateRec):string;        { leters      }
 begin
  DateMonth:='';
  case dt.m of
   1 :DateMonth:='';
   2 :DateMonth:='';
   3 :DateMonth:='';
   4 :DateMonth:='';
   5 :DateMonth:='';
   6 :DateMonth:='';
   7 :DateMonth:='';
   8 :DateMonth:='';
   9 :DateMonth:='';
   10:DateMonth:='';
   11:DateMonth:='';
   12:DateMonth:='';
  end;
 end;
procedure DateGetd(var dt:DateRec);
 var wy,wm,wd {$IFDEF Turbo},dw{$ENDIF} :word;
 begin with dt do begin
  {$IFDEF Turbo} GetDate(wy,wm,wd,dw); {$ENDIF}
  {$IFDEF FPC}   GetDate(wy,wm,wd);    {$ENDIF}
  d:=wd; m:=wm; y:=wy-1900;
 end end;
procedure DateSetd(dt:DateRec);
 var wy,wm,wd:word;
 begin with dt do begin
  wy:=y+1900; wm:=m; wd:=d;
  { Set date & time is very difficult under Linux !!! }
  {$IFDEF Turbo} SetDate(wy,wm,wd); {$ENDIF}
 end end;
procedure DateDec_day(var dt:DateRec);
 begin
  with dt do if d>1 then dec(d) else begin
   if m>1 then dec(m) else begin dec(y); m:=12 end;
   DateSet_last_day_of_month(dt)
  end;
 end;
procedure DateIncDay(var dt:DateRec; n:word);
 var d1:DateRec; w:byte;
 begin with dt do begin
  d1:=dt; DateSet_last_day_of_month(d1);
  w:=d1.d-d;
  if w>=n
   then inc(d,n)
   else begin
    d:=1; if m<12 then Inc(m) else begin Inc(y); m:=1 end;
    if w<n-1 then DateIncDay(dt,n-1-w);
   end;
 end end;
function  DateEqu(dt0,dt:DateRec):boolean;
 begin with dt0 do DateEqu:=(dt.d=d) and (dt.m=m) and (dt.y=y) end;
function  DateLess(dt0,dt:DateRec):boolean; { dt0<=dt ? }
 begin with dt0 do
  if y<dt.y then DateLess:=true
  else if y>dt.y then DateLess:=false
  else if m<dt.m then DateLess:=true
  else if m>dt.m then DateLess:=false
  else DateLess:=(d<=dt.d)
 end;
procedure DateClear(var dt:DateRec);
 begin with dt do begin y:=0; m:=0; d:=0 end end;

function  TimeStr_0(tm:TimeRec):string;   { hh:mm    }
 begin with tm do TimeStr_0:=ThoDig(h)+':'+ThoDig(m) end;
function  TimeStr_1(tm:TimeRec):string;   { hh:mm:ss }
 begin TimeStr_1:=TimeStr_0(tm)+':'+ThoDig(tm.s) end;
function  TimeEqu(tm,t:TimeRec):boolean;
 begin with tm do TimeEqu:=(T.h=h) and (T.m=m) and (T.s=s) end;
function  TimeLess(tm,t:TimeRec):boolean; { tm<=t ? }
 begin with tm do
  if h<T.h then TimeLess:=true
  else if h>T.h then TimeLess:=false
  else if m<T.m then TimeLess:=true
  else if m>T.m then TimeLess:=false else TimeLess:=(s<=T.s)
 end;
procedure TimeIncSec(var tm:TimeRec; w:word);
 var cs,cm:word;
 begin with tm do begin
  cs:=(s+w) div 60; s:=(s+w) mod 60;
  cm:=(m+cs) div 60; m:=(m+cs) mod 60;
  inc(h,cm);
 end end;
procedure TimeDecSec(var tm:TimeRec; w:word);
 var cs,cm,ch:word;
 begin with tm do begin
  ch:=w div 3600; cm:=w mod 3600 div 60; cs:=w mod 60;
  if cs>s then begin
   s:=60+s-cs; inc(cm); inc(ch,cm div 60); cm:=cm mod 60;
  end else Dec(s,cs);
  if cm>m then begin
   m:=60+m-cm; inc(ch); ch:=ch mod 24;
  end else Dec(m,cm);
  if ch>h then h:=24+h-ch else Dec(h,ch);
 end end;
procedure TimeGetT(var tm:TimeRec);
 var wh,wm,ws {$IFDEF Turbo} ,ws0 {$ENDIF} :word;
 begin with tm do begin
  {$IFDEF Turbo} GetTime(wh,wm,ws,ds0); {$ENDIF}
  {$IFDEF FPC}   GetTime(wh,wm,ws);    {$ENDIF}
  h:=wh; m:=wm; s:=ws;
 end end;
procedure TimeClear(var tm:TimeRec);
 begin with tm do begin h:=0; m:=0; s:=0 end end;

procedure IntervalClear(var int:Interval);
 begin with int do begin h:=0; m:=0; d:=0 end end;
function  IntervalStr_0(int:Interval):string;  { dd/hh    }
 begin IntervalStr_0:=ThoDig(int.d)+'/'+ThoDig(int.h) end;
function  IntervalStr_1(int:Interval):string;  { dd/hh:mm }
 begin IntervalStr_1:=IntervalStr_0(int)+':'+ThoDig(int.m) end;
function  IntervalEqu(int,I:Interval):boolean;
 begin with int do IntervalEqu:=(I.d=d) and (I.h=h) and (I.m=m) end;

end.
