unit designer;
interface
{$I options.pp}

uses
 Records,
 Win_def,
 Drivers, Views;

type
 PDesignBrouse = ^TDesignBrouse;
 TDesignBrouse = object (TBrouseWindow)
  FileId:byte;
  constructor Init(aFileId:byte);
  function LastLine:longint; virtual;
  procedure ShowCnt; virtual;
  function Line(l:longint):string; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure CorrectEnable; virtual;
  destructor Done; virtual;
 private
  function  EditAll(Ind:byte; var Fld,Fld1:TFldRec):boolean;
  procedure EditFld;
  procedure CreateFld;
  procedure EraseFld;
  procedure ExchFlds(i:byte; Dn:boolean);
  procedure MoveUpFld;
  procedure MoveDnFld;
  procedure ColapsToPtr;
  procedure ExpandPtr;
 end;

implementation

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC} Sk_types, Trace, {$ENDIF}
 File_win, Disk_Rec, DataFile, Date_lib,
 Menu_cmd, Tv_box, Lines, Str_def, Info_def,
 App, Dialogs, Objects;

{-------------------------------------------}

const
 fnName  = 0;
 fnType  = 1;
 fnSSize = 2;
 fnCName = 3;
 fnIndex = 4;
 fnUTest = 5;
 fnIRoot = 6;
 fnULine = 7;
 fnCSumm = 8;
 fnPSumm = 9;

{-------------------------------------------}

type
 PDesFType = ^TDesFType;
 TDesFType = object (TSInputPntr)
  FT,FP,SZ:byte;
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
  procedure Draw; virtual;
  procedure EditData; virtual;
 end;

procedure TDesFType.Draw;
 var s,s1:string[25];
 begin
  s:=' '+FldTStr(FT);
  case FT of
   CFStr,CFName:begin Str(SZ,s1); s:=s+'['+s1+']' end;
{$IFDEF Cyr}
   CFPntr:if FP<>$FF then s:=s+'  '+DFArr[FP]^.LName;
{$ENDIF}
{$IFDEF Lat}
   CFPntr:if FP<>$FF then s:=s+' to '+DFArr[FP]^.LName;
{$ENDIF}
  end;
  RExpandStr(s,Size.X,' ');
  writeStr(0,0,s,1+ord(GetState(sfFocused)));
 end;
procedure TDesFType.SetData(var Rec);
 var Fld:TFldRec absolute Rec;
 begin FT:=Fld.FType; FP:=Fld.Fptr; SZ:=Fld.Size end;
procedure TDesFType.GetData(var Rec);
 var Fld:TFldRec absolute Rec;
 begin
  Fld.FType:=FT; Fld.Fptr:=FP; Fld.Size:=SZ;
  if FT=CFPntr
   then Fld.FPName:=DFArr[FP]^.FName
   else Fld.FPName:=''
 end;
procedure TDesFType.EditData;
 var
  O:PSRecDialog absolute Owner; Fld:TFldRec;
  P:PChoisList; i,fp0:byte; s:string; j,k:integer; bool:boolean;
 begin
  if FT=CFPntr then fp0:=FP else fp0:=$FF;
  New(P,Init);
  for i:=0 to CFMax do P^.Insert(FldTStr(i));
  P^.SetCursor(FT); 
  {$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
  {$IFDEF FPC} P^.Chois(i); {$ENDIF}
  if i<=CFMax then begin
   FT:=i; FP:=$FF;
   case FT of
    CFStr,CFName:
     begin
      Str(SZ,s); EditSomeString(ErrStr(esLengInBytes),s,3);
      Val(s,k,j); SZ:=Min(254,max(1,k));
     end;
    CFPntr:
     begin
      i:=SelectFileId(fp0);
      if i<>$FF then FP:=i else begin FT:=CFStr; SZ:=5 end;
     end;
   end;
   case FT of
    CFList:SZ:=1;
    CFWord:SZ:=2;
    CFDate:SZ:=SizeOf(DateRec);
    CFTime:SZ:=SizeOf(TimeRec);
    CFLong,CFPntr:SZ:=SizeOf(longint);
    CFReal:SZ:=SizeOf(real);
   end;
   { set ShowSize }
   GetData(Fld); i:=FldStdStrLen(Fld);
   with O^.CArr[fnSSize]^ do begin SetData(i); DrawView end;
   { set FullShow }
   bool:=FT=CFPntr;
   with O^.CArr[fnULine]^ do begin SetData(bool); DrawView end;
   { set CntSumm }
   bool:=FT=CFReal;
   with O^.CArr[fnCSumm]^ do begin SetData(bool); DrawView end;
   with O^.CArr[fnPSumm]^ do begin SetData(bool); DrawView end;
   DrawView;
  end;
 end;

{-------------------------------------------}

type
 PDesFldWin = ^TDesFldWin;
 TDesFldWin = object (TSRecDialog)
  constructor Init;
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

constructor TDesFldWin.Init;
{$IFDEF Cir}
{
 const
  ALabName  = '~1~ :';
  ALabType  = '~2~ :';
  ALabSSize = '~3~   :';
  ALabCName = '~4~   :';
  ALabIndex = '~5~ :';
  ALabUTest = '~6~   :';
  ALabIRoot = '~7~  :';
  ALabULine = '~8~   :';
  ALabCSumm = '~9~   :';
}
{$ENDIF}
{$IFDEF Lat}
{
 const
  ALabName = '~N~ame:';
  ALabType = '~T~ype:';
  ALabSSize = 'S~h~ow size:';
  ALabCName = '~C~ount name:';
  ALabIndex = '~I~ndexed:';
  ALabUTest = '~U~nique test:';
  ALabULine = '~F~ull show:';
  ALabIRoot = '~R~oot index:';
  ALabCSumm = 'Summ co~l~umn:';
}
{$ENDIF}
 var R:TRect;
 begin
  R.Assign(2,6,42,22); inherited Init(R,'FieldWin');

  AddNewLine(ErrStr(esALabName),FldMaxLen,true);
  AddNewView(ErrStr(esALabType),New(PDesFType,Init(25)));
  AddNewByte(ErrStr(esALabSSize));
  AddNewLine(ErrStr(esALabCName),6,true);
  AddBoolNum(esALabIndex);
  AddBoolNum(esALabUTest);
  AddBoolNum(esALabIRoot);
  AddBoolNum(esALabULine);
  AddBoolNum(esALabCSumm);
  AddBoolNum(esALabPSumm);

  AddOKCancelButtons;
 end;

procedure TDesFldWin.SetData(var Rec);
 var Fld:TFldRec absolute Rec; b:boolean;
 begin
  CArr[fnName]^.SetData(Fld.Name);
  CArr[fnType]^.SetData(Fld);
  CArr[fnSSize]^.SetData(Fld.ShowSize);
  CArr[fnCName]^.SetData(Fld.CntName);
  b:=FldGetFlags(Fld,ffIndexed); CArr[fnIndex]^.SetData(b);
  b:=FldGetFlags(Fld,ffUniTest); CArr[fnUTest]^.SetData(b);
  b:=FldGetFlags(Fld,ffRootInd); CArr[fnIRoot]^.SetData(b);
  b:=FldGetFlags(Fld,ffFulShow); CArr[fnULine]^.SetData(b);
  b:=FldGetFlags(Fld,ffCntSumm); CArr[fnCSumm]^.SetData(b);
  b:=FldGetFlags(Fld,ffCntPntr); CArr[fnPSumm]^.SetData(b);
 end;
procedure TDesFldWin.GetData(var Rec);
 var Fld:TFldRec absolute Rec; b:boolean;
 begin
  CArr[fnName]^.GetData(Fld.Name);
  CArr[fnType]^.GetData(Fld);
  CArr[fnSSize]^.GetData(Fld.ShowSize);
  CArr[fnCName]^.GetData(Fld.CntName);
  CArr[fnIndex]^.GetData(b); FldSetFlags(Fld,ffIndexed,b);
  CArr[fnUTest]^.GetData(b); FldSetFlags(Fld,ffUniTest,b);
  CArr[fnIRoot]^.GetData(b); FldSetFlags(Fld,ffRootInd,b);
  CArr[fnULine]^.GetData(b); FldSetFlags(Fld,ffFulShow,b);
  CArr[fnCSumm]^.GetData(b); FldSetFlags(Fld,ffCntSumm,b);
  CArr[fnPSumm]^.GetData(b); FldSetFlags(Fld,ffCntPntr,b);
  with Fld do begin
   case FType of
    CFDate:if ShowSize>0 then if ShowSize<9
     then ShowSize:=FldStdStrLen(Fld) else ShowSize:=10;
    CFTime:if ShowSize>0 then ShowSize:=FldStdStrLen(Fld);
    CFStr,CFName:ShowSize:=min(ShowSize,Size);
   end;
   if FType<>CFPntr then StrRec('',CntName,6);
  end;
 end;

procedure TDesFldWin.HandleEvent(var Event: TEvent);
 var
  Barr:array[0..FldMaxCnt] of PCheckBox absolute Carr;
  Spec:array[0..fnType] of PDesFType absolute Carr;
 begin
  inherited HandleEvent(Event);
  if (not Barr[fnIndex]^.Mark) then { force Index }
   if Barr[fnIRoot]^.Mark or
      Barr[fnUTest]^.Mark or
      (Spec[fnType]^.FT=CFPntr) then
    with Barr[fnIndex]^ do begin Press; DrawView end;
  if (not (Spec[fnType]^.FT in [CFReal,CFLong])) then begin
   with Barr[fnCSumm]^ do if Mark then begin Press; DrawView end;
   with Barr[fnPSumm]^ do if Mark then begin Press; DrawView end;
  end;
 end;

{-------------------------------------------}

constructor TDesignBrouse.Init(aFileId:byte);
 var R:TRect;
 begin
  R.Assign(12,0,68,13); R.Move(DesCount,DesCount);
  inherited
   Init(bwDesign, DFArr[aFileId],R,5,7,ErrStr(esDesBrowHead),false);
  FileId:=aFileId; inc(DesCount);
  HelpCtx:=hcDesignFile;
  MyCmdSet:=TCommandSet(DesCmdSet)+TCommandSet([cmClose]);
 end;
function TDesignBrouse.GetTitle(MaxSize: Integer): TTitleStr;
 var PDF:PDataFile absolute PData;
 begin
{$IFDEF Cir}
  GetTitle:=copy('  '+PDF^.LName,1,MaxSize);
{$ENDIF}
{$IFDEF Lat}
  GetTitle:=copy('Structure of '+PDF^.LName,1,MaxSize);
{$ENDIF}
 end;
procedure TDesignBrouse.ShowCnt;
 var PDF:PDataFile absolute PData; sn,sd:string[30]; L:longint;
 begin
  Str(PDF^.RecSize,sn);
{$IFDEF Cir}
  sn:=sn+' '; if PDF^.RecSize<>1 then sn:=sn+'';
  L:=PDF^.Data^.Length; Str(L,sd); sd:=sd+' ';
  if L<>1 then sd:=sd+',  ' else sd:=sd+', ';
  WriteStr(2,1,' '+sd+' '+sn,1);
{$ENDIF}
{$IFDEF Lat}
  sn:=sn+' byte'; if PDF^.RecSize<>1 then sn:=sn+'s';
  L:=PDF^.Data^.Length; Str(L,sd); sd:=sd+' record';
  if L<>1 then sd:=sd+'s';
  WriteStr(2,1,'Contains '+sd+', each is '+sn+' long',1);
{$ENDIF}
 end;
function TDesignBrouse.Line(l:longint):string;
 var Fld:TFldRec;
 begin
  if l<LastLine
   then begin
    PDataFile(PData)^.Fields^.GetRec(l,Fld);
    Line:=FieldStr(Fld);
   end
   else Line:=BlankLine
 end;
function TDesignBrouse.LastLine:longint;
 begin LastLine:=PDataFile(PData)^.Fields^.Length end;
procedure TDesignBrouse.CorrectEnable;
 var Fld:TFldRec;
 begin
  if WinCursor=LastLine then DisableCommands(TCommandSet(DesCmdSet1));
  if LastLine<2 then DisableCommands(TCommandSet([cmMvUpFld,cmMvDnFld]));
  if WinCursor=0 then DisableCommands(TCommandSet([cmMvUpFld]));
  if WinCursor+1=LastLine then DisableCommands(TCommandSet([cmMvDnFld]));
  if WinCursor<LastLine then begin
    PDataFile(PData)^.Fields^.GetRec(WinCursor,Fld);
    if Fld.FType<>CFPntr then DisableCommands(TCommandSet([cmExpandFld]));
  end;
 end;
procedure TDesignBrouse.HandleEvent(var Event: TEvent);
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evBroadcast:case Event.Command of
    cmDesFile:if Event.InfoPtr=PData then Select else Exit;
    else Exit;
   end;
   evCommand:case Event.Command of
    cmNewFld:CreateFld;
    cmEditFld,cmBrouseDouble:if WinCursor<LastLine then EditFld;
    cmDelFld:EraseFld;
    cmMvUpFld:MoveUpFld;
    cmMvDnFld:MoveDnFld;
    cmExpandFld:ExpandPtr;
    cmColapsFld:begin
     MessageBox(#3+ErrStr(esColapsFldW0)+#13+#3+ErrStr(esColapsFldW1)+#13+
                #3+ErrStr(esColapsFldW2)+#13+#3+ErrStr(esColapsFldW3),
                nil, mfWarning or mfOKButton);
     ColapsToPtr;
    end;
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;
destructor TDesignBrouse.Done;
 begin dec(DesCount); inherited Done end;

function TDesignBrouse.EditAll(Ind:byte; var Fld,Fld1:TFldRec):boolean;
 var
  PDF:PDataFile absolute PData;
  P:PDesFldWin; Result:word; OK:boolean;
 procedure FldNameOK;
  var i:byte; Fld2:TFldRec;
  begin
   OK:=True;
   if LastLine>0 then for i:=0 to LastLine-1 do if i<>Ind then begin
    with PDF^.Fields^ do GetRec(i,Fld2);
    if equ(Fld1.Name,Fld2.Name,FldMaxLen) then OK:=False;
   end;
  end;
 begin
{ Fld1:=Fld; }
  repeat
   New(P,Init); P^.SetData(Fld);
   Result:=DeskTop^.ExecView(P);
   if Result=cmOK then begin
    P^.GetData(Fld1); FldNameOK;
    if not OK then ErrNum(esDupFldNames)
   end;
   Dispose(P,Done);
  until OK or (Result<>cmOK);
  EditAll:=Result=cmOK;
 end;


procedure TDesignBrouse.CreateFld;
 var Fld,Fld1:TFldRec; PDF:PDataFile absolute PData;
 begin if LastLine>FldMaxCnt
  then ErrNum(esManyFldDefs)
  else if YN_Num2(esNewFldCreat,esAreYouShure)
   then begin
    FldClear(Fld,LastLine);
    if EditAll(LastLine,Fld,Fld1) then begin
     FldSetFlags(Fld1,ffRootInd,LastLine=0);
     if LastLine=0 then FldSetFlags(Fld1,ffIndexed,True);
     PDF^.AppendField(LastLine,Fld1); SetWCursor(LastLine-1);
    end;
   end;
 end;

procedure TDesignBrouse.EditFld;
 var
  PDF:PDataFile absolute PData;
  Fld,Fld1,Fld2:TFldRec; j:byte;
  IndCh, TypeCh, SizeCh, Possible, NoCh:boolean;
 procedure PutFld; begin PDF^.Fields^.PutRec(WinCursor,Fld) end;
 const ffEasyFl = ffFulShow + ffUniTest + ffCntSumm + ffCntPntr;
 var DFlags:byte;
 begin
  PDF^.Fields^.GetRec(WinCursor,Fld);
  if EditAll(WinCursor,Fld,Fld1) then begin
   if not equ(Fld.Name,Fld1.Name,FldMaxLen) then
    begin Move(Fld1.Name,Fld.Name,FldMaxLen); PutFld end;
   if not equ(Fld.CntName,Fld1.CntName,6) then
    begin Move(Fld1.CntName,Fld.CntName,6); PutFld end;
   if Fld.ShowSize<>Fld1.ShowSize then
    begin Fld.ShowSize:=Fld1.ShowSize; PutFld end;
   DFlags:=Fld.Flags xor Fld1.Flags;
   if (DFlags and ffEasyFl)>0 then begin
    Fld.Flags:=(Fld.Flags  and ($FF xor ffEasyFl)) or
               (Fld1.Flags and ffEasyFl);
    PutFld;
   end;
   if (DFlags and ffRootInd)>0 then if FldGetFlags(Fld1,ffRootInd)
    then with PDF^ do begin
     LastUsedIndex:=$ff; j:=SelectFIndex;
     if j<>$FF then begin
      Fields^.GetRec(j,Fld2); FldSetFlags(Fld2,ffRootInd,False);
      Fields^.PutRec(j,Fld2);
     end;
     FldSetFlags(Fld,ffRootInd,FldGetFlags(Fld1,ffRootInd));
     PutFld; SetWCursor(WinCursor);
    end
    else begin
     FldSetFlags(Fld1,ffRootInd+ffIndexed,True);
     ErrNum(esSelNewRtInd);
    end;
   TypeCh:=Fld.FType<>Fld1.FType; SizeCh:=Fld.Size<>Fld1.Size;
   NoCh:=(not TypeCh) and (not SizeCh) and (Fld.Fptr=Fld1.Fptr);
   if TypeCh
    then case Fld1.FType of
     CFPntr,CFDate,CFTime:Possible:=False;
     CFLong,CFReal,CFList,CFWord:
      Possible:=Fld.FType in [CFList,CFWord,CFReal,CFLong];
     CFName,CFStr:Possible:=Fld.FType in [CFName,CFStr];
    end
    else Possible:=Fld.FType in [CFStr,CFName];
   IndCh:=FldGetFlags(Fld,ffIndexed)<>FldGetFlags(Fld1,ffIndexed);
   if IndCh and NoCh then begin
    FldSetFlags(Fld,ffIndexed,FldGetFlags(Fld1,ffIndexed)); PutFld;
    if FldGetFlags(Fld1,ffIndexed)
     then PDF^.CreateIndex(WinCursor) else PDF^.EraseIndex(WinCursor)
   end;
   if (not NoCh) then if (not Possible)
    then ErrNum(esFldChngInps) else PDF^.ChangeField(WinCursor,Fld,Fld1);
   ChangeWCursor(WinCursor);
  end;
 end;

procedure TDesignBrouse.EraseFld;
 var PDF:PDataFile absolute PData; OK:boolean; Fld:TFldRec;
 begin
  if PDF^.Data^.length=0 then OK:=true
   else OK:=YN_Num2(esErasFldData,esAreYouShure);
  if OK then begin
   PDF^.Fields^.GetRec(WinCursor,Fld);
   if FldGetFlags(Fld,ffRootInd) and (LastLine>1)
    then ErrNum(esSelNewRtInd)
    else begin PDF^.EraseField(WinCursor); SetWCursor(WinCursor) end;
  end;
 end;

procedure TDesignBrouse.ExchFlds(i:byte; Dn:boolean);
 var PDF:PDataFile absolute PData;
 begin with PDF^ do if YN_Win2(
   ErrStr(esWillChnFlds)+FldName(i)+'" '+
{$IFDEF Cir}''{$ENDIF}{$IFDEF Lat}'and'{$ENDIF},
   '"'+FldName(i+1)+'". '+ErrStr(esAreYouShure))
  then begin SwapField(i); SetWCursor(i+ord(Dn)) end;
 end;

procedure TDesignBrouse.MoveUpFld;
 begin ExchFlds(WinCursor-1,false) end;

procedure TDesignBrouse.MoveDnFld;
 begin ExchFlds(WinCursor,true) end;

{--------------------------------------------------}

type
 TColapsLine = record
  F:TFldRec; { Field from target file }
  V:boolean; { Value or FldId }
  FldId:byte; { FldId from sors file }
  Val:Small;
 end;
 PColapsList = ^TColapsList;
 TColapsList = object (TBrouseWindow)
  TFId,SFId,MaxCnt:byte;
  CArr:array[0..FldMaxCnt] of TColapsLine;
  constructor Init(aSFId,aTFId,aMax:byte);
  procedure ShowCnt; virtual;
  function LastLine:longint; virtual;
  function Line(l:longint):string; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

constructor TColapsList.Init(aSFId,aTFId,aMax:byte);
 var
  R:TRect; i:byte;
  PDF:PDataFile absolute PData;
 begin
  R.Assign(2,7,73,22);
  inherited Init(bwFldSel,DFArr[aTFId],R,5,9,ErrStr(esColapsFldWT),false);
  HelpCtx:=hcColapsList;
  MyCmdSet:=TCommandSet([cmClose,cmCancel,cmSetSorsFld,cmSetFldValue]);
  SFId:=aSFId; TFId:=aTFId; MaxCnt:=aMax;
  for i:=0 to MaxCnt do with CArr[i] do begin
   PDF^.Fields^.GetRec(i,F);
   V:=True; FldStdClear(F,Val);
  end;
  SetWCursor(0);
 end;
function TColapsList.GetTitle(MaxSize: Integer): TTitleStr;
 begin GetTitle:=ErrStr(esColapsTitle)+DFArr[SFId]^.LName end;
procedure TColapsList.ShowCnt;
 begin
  WriteStr(DrawPos.x,1,
{$IFDEF Cir}
   '  "'+DFArr[TFId]^.LName+ErrStr(esColapsTit01),1);
{$ENDIF} {$IFDEF Lat}
   ' File "'+DFArr[TFId]^.LName+ErrStr(esColapsTit01),1);
{$ENDIF}
 end;
function TColapsList.LastLine:longint; begin LastLine:=MaxCnt end;
function TColapsList.Line(l:longint):string;
 var s:string;
 begin if l<=LastLine
  then with CArr[l] do begin
   if V
    then s:=' val '+VLChar+' '+ClearSp(FldStdString(F,Val,3))
    else s:=' fld '+VLChar+' '+
     DFArr[SFId]^.SName+'.'+DFArr[SFId]^.FldName(FldId);
   Line:=RecStr(F.Name,FldMaxLen)+VLChar+s
  end
  else Line:=BlankLine
 end;
procedure TColapsList.HandleEvent(var Event: TEvent);
 var Handled,OK:boolean; P:PChoisList; i:byte; Fld:TFldRec;
 begin
  Handled:=True;
  case Event.What of
   evMouseDown:Handled:=Event.Double;
   evCommand:case Event.Command of
     cmCancel,cmClose:EndModal(Event.Command);
     cmSetSorsFld:with CArr[WinCursor] do
      if FldGetFlags(F,ffIndexed) then with DFArr[SFId]^ do begin
       New(P,Init);
       for i:=0 to Fields^.Length-1 do P^.Insert(SName+'.'+FldName(i));
       {$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
       {$IFDEF FPC} P^.Chois(i); {$ENDIF}
       if i<Fields^.Length then begin
        Fields^.GetRec(i,Fld);
        OK:=(Fld.FType=F.FType) and (Fld.Size=F.Size);
        if OK and (F.FType=CFPntr) then OK:=Fld.FPtr=f.FPtr;
        if OK then begin FldId:=i; V:=False end else ErrNum(esColapsErr01)
       end;
       ShowWCursor;
      end else ErrNum(esColapsErr02);
     cmSetFldValue:with CArr[WinCursor] do begin
      EditFirstFldValue(F,Val,0);
      V:=True; ShowWCursor;
     end;
     else Handled:=False;
    end;
   else Handled:=False;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;

{---------------------------------------------------}

type
 PColapsWindow = ^TColapsWindow;
 TColapsWindow = object (TSWindow)
  PCL:PColapsList;
  constructor Init(aPCL:PColapsList);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

constructor TColapsWindow.Init(aPCL:PColapsList);
 var R:TRect;
 begin
  R.Assign(38,3,78,10);
{$IFDEF Cir}
  inherited Init(R,'  ',wnNoNumber);
{$ENDIF}
{$IFDEF Lat}
  inherited Init(R,'File squeezer',wnNoNumber);
{$ENDIF}
  Palette:=wpGrayWindow; Flags:=Flags and ($FF xor (wfGrow+wfZoom));
  PCL:=aPCL;
 end;
procedure TColapsWindow.HandleEvent(var Event: TEvent);
 procedure Colaps;
  const SLI = SizeOf(longint);
  var
   PTR,PSR:PBlock; i:byte; c,trs,srs:word; L,Ind:longint;
   fo:TRecFileFastOut; f:file;
   UFArr:array[0..FldMaxCnt] of boolean; Fld:TFldRec; RtInd:byte;
  function DelMaxFldNum:boolean;
   var i:byte; j:integer;
   begin with PCL^ do begin
    j:=-1;
    for i:=0 to MaxCnt do with CArr[i] do if not V then j:=max(j,FldId);
    if j<>-1 then begin
     for i:=0 to MaxCnt do with CArr[i] do if not V
      then if j=FldId then V:=True;
     DFArr[SFId]^.EraseField(j);
    end;
    DelMaxFldNum:=j<>-1;
   end end;
  procedure ClrTUFlags;
   var i:integer;
   begin with PCL^ do with DFArr[TFId]^.Fields^ do
    for i:=0 to MaxCnt do begin
     GetRec(i,Fld);
     UFArr[i]:=FldGetFlags(Fld,ffUniTest);
     FldSetFlags(Fld,ffUniTest,not CArr[i].V);
     PutRec(i,Fld);
    end;
   end;
  procedure RstTUFlags;
   var i:integer;
   begin with PCL^ do with DFArr[TFId]^.Fields^ do for i:=0 to MaxCnt do
    begin GetRec(i,Fld); FldSetFlags(Fld,ffUniTest,UFArr[i]); PutRec(i,Fld) end;
   end;
  begin with PCL^ do begin
   trs:=DFArr[TFId]^.RecSize; srs:=DFArr[SFId]^.RecSize;
   GetMem(PTR,trs); GetMem(PSR,srs+SLI);
   { --- Clear target record --- }
   c:=1; RtInd:=0;
   for i:=0 to MaxCnt do with CArr[i] do begin
    Move(Val,PTR^[c],F.Size); Inc(c,F.Size);
    if not V then begin
     DFArr[SFId]^.Fields^.GetRec(FldId,Fld);
     RtInd:=RtInd or (Fld.Flags and ffRootInd);
    end;
   end;
   { --- Colapse root loop --- }
   ClrTUFlags; L:=0;
   fo.Init(DFArr[SFId]^.FName+'.New',srs+SLI);
   while L<DFArr[SFId]^.Data^.Length do begin
    DFArr[SFId]^.Data^.GetRec(L,PSR^);
    PTR^[0]:=PSR^[0]; Ind:=-1;
    if PTR^[0]<>$FF then begin
     c:=1;
     for i:=0 to MaxCnt do with CArr[i] do begin
      if not V then Move(PSR^[DFArr[SFId]^.FldPos(FldId)],PTR^[c],F.Size);
      Inc(c,F.Size)
     end;
     { --- Test target rec & set Ind --- }
     DFArr[TFId]^.RecUpdate(Ind,PTR^,false,true);
    end;
    Move(Ind,PSR^[srs],SLI); fo.PutNext(PSR^); Inc(L);
    if (L and $07) = 0 then ShowReady(@Self,L,DFArr[SFId]^.Data^.Length);
   end;
   fo.Done; RstTUFlags; FreeMem(PSR,srs+SLI); FreeMem(PTR,trs);
   WriteStr(3,4,Blank(35),1);
   { --- Rename sors file & add FPtr field & index --- }
   with Fld do begin
    Used:=0;
    StrRec(DFArr[TFId]^.LName,Name,FldMaxLen);
    FType:=CFPntr; Size:=SLI; FPtr:=TFId;
    Flags:=ffIndexed + RtInd + ffFulShow;
    FPName:=DFArr[TFId]^.FName;
    ShowSize:=15;
    StrRec(DFArr[SFId]^.SName,CntName,6);
   end;
   with DFArr[SFId]^ do begin
    i:=Fields^.Length; Fields^.PutRec(i,Fld);
    Dispose(Data,Done); FileDelete(FName+'.dat');
    Assign(f,FName+'.New'); Rename(f,FName+'.dat');
    Inc(RecSize,SLI); InitDataFile;
    CreateIndex(i);
   end;
   WriteStr(3,4,'Erasing squeezed fields',1);
   { --- Erase some fields from Sors file --- }
   while DelMaxFldNum do;
  end end;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then case Event.Command of
   cmColapsFileLop:begin
{$IFDEF Cir}
    WriteStr(3,2,' '+DFArr[PCL^.SFId]^.LName,1);
{$ENDIF}
{$IFDEF Lat}
    WriteStr(3,2,'Squeezing '+DFArr[PCL^.SFId]^.LName,1);
{$ENDIF}
    Colaps; ClearEvent(Event); Close;
   end;
  end;
 end;

procedure TDesignBrouse.ColapsToPtr;
 var TFId,TFMax,SFMax,i,FCnt:byte; PCL:PColapsList;
 function Colision:boolean;
  Var i:byte;
  begin
   Colision:=False;
   with PCL^ do if TFId=SFId then for i:=0 to MaxCnt do
    with CArr[i] do if not V then
     if not CArr[FldId].V then Colision:=True;
  end;
 begin
  TFId:=SelectFileId($FF);
  if TFId<>$FF then begin
   TFMax:=DFArr[TFId]^.Fields^.Length;
   SFMax:=DFArr[FileId]^.Fields^.Length;
   if (TFMax>0) and (SFMax>0) then if SFMax>=FldMaxCnt
    then ErrNum(esManyFldDefs) else begin
     SetUseMode;
     New(PCL,Init(FileId,TFId,TFMax-1));
     if Desktop^.ExecView(PCL)=cmClose then begin
      FCnt:=0;
      with PCL^ do for i:=0 to MaxCnt do
       if not CArr[i].V then inc(FCnt);
      if FCnt>0
       then if Colision
        then ErrNum(esColapsErr04)
        else begin
         Application^.Insert(New(PColapsWindow,Init(PCL)));
         Message(Application,evBroadcast,cmColapsFileLop,Nil);
         SetWCursor(DFArr[FileId]^.Fields^.Length-1)
        end
       else ErrNum(esColapsErr03);
     end;
     Dispose(PCL,Done);
     SetDesignMode;
    end
    else ErrNum(esColapsErr00);
  end;
 end;

{---------------------------------------------------}

type
 PExpandWindow = ^TExpandWindow;
 TExpandWindow = object (TSWindow)
  SFId,TFId,PtrId:byte; RootInd:boolean;
  constructor Init(aSFId,aTFId,aPtrId:byte; aRootInd:boolean);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

constructor TExpandWindow.Init(aSFId,aTFId,aPtrId:byte; aRootInd:boolean);
 var R:TRect;
 begin
  R.Assign(38,3,78,10);
{$IFDEF Cir}
  inherited Init(R,'  ',wnNoNumber);
{$ENDIF}
{$IFDEF Lat}
  inherited Init(R,'File expander',wnNoNumber);
{$ENDIF}
  Palette:=wpGrayWindow; Flags:=Flags and ($FF xor (wfGrow+wfZoom));
  SFId:=aSFId; TFId:=aTFId; PtrId:=aPtrId; RootInd:=aRootInd;
 end;
procedure TExpandWindow.HandleEvent(var Event: TEvent);
 procedure Expand;
  const SLI = SizeOf(longint);
  var
   PTR,PWR:PBlock; i,j:byte; trs,srs:word; L,Ind:longint;
   fo:TRecFileFastOut; f:file; Fld:TFldRec;
  begin
   WrLogStr(CurDateTime+'Expand 0');
   trs:=DFArr[TFId]^.RecSize; srs:=DFArr[SFId]^.RecSize;
   WrLogStr(CurDateTime+'Expand 1');
   GetMem(PTR,srs+trs-1); GetMem(PWR,trs);
   { --- Expand root loop --- }
   L:=0;
   WrLogStr(CurDateTime+'Expand 2');
   fo.Init(DFArr[SFId]^.FName+'.New',srs+trs-1);
   WrLogStr(CurDateTime+'Expand 3');
   while L<DFArr[SFId]^.Data^.Length do begin
    DFArr[SFId]^.Data^.GetRec(L,PTR^); Ind:=-1;
    if PTR^[0]<>$FF then Move(PTR^[DFArr[SFId]^.FldPos(PtrId)],Ind,SLI);
    with DFArr[TFId]^ do if Ind=-1
     then RecClear(PWR^) else Data^.GetRec(Ind,PWR^);
    Move(PWR^[1],PTR^[srs],trs-1); fo.PutNext(PTR^); Inc(L);
    if (L and $07) = 0 then ShowReady(@Self,L,DFArr[SFId]^.Data^.Length);
   end;
   WrLogStr(CurDateTime+'Expand 4');
   fo.Done; WriteStr(3,4,Blank(35),1);
   WrLogStr(CurDateTime+'Expand 5');
   { --- Rename source file & add fields & indexes --- }
   j:=DFArr[SFId]^.Fields^.Length;
   WrLogStr(CurDateTime+'Expand 6');
   with DFArr[TFId]^ do if Fields^.Length>0
    then for i:=0 to Fields^.Length-1 do begin
     Fields^.GetRec(i,Fld);
     FldSetFlags(Fld,ffRootInd,RootInd and FldGetFlags(Fld,ffRootInd));
     StrRec(copy(SName+'_'+RecStr(Fld.Name,FldMaxLen),1,FldMaxLen),
      Fld.Name,FldMaxLen);
     with DFArr[SFId]^.Fields^ do PutRec(Length,Fld);
    end;
   WrLogStr(CurDateTime+'Expand 7');
   with DFArr[SFId]^ do begin
    Dispose(Data,Done); FileDelete(FName+'.dat');
    Assign(f,FName+'.New'); Rename(f,FName+'.dat');
    Inc(RecSize,trs-1); InitDataFile;
    for i:=0 to Fields^.Length-1 do if i>=j then begin
     Fields^.GetRec(i,Fld);
     if FldGetFlags(Fld,ffIndexed) then CreateIndex(i);
    end;
   end;
   { --- Erase pntr field from Source file --- }
   WriteStr(3,4,'Erasing pointer field',1);
   WrLogStr(CurDateTime+'Expand 8');
   DFArr[SFId]^.EraseField(PtrId);
   FreeMem(PTR,srs+trs-1); FreeMem(PWR,trs);
   WrLogStr(CurDateTime+'Expand 9');
  end;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then case Event.Command of
   cmColapsFileLop:begin
{$IFDEF Cir}
    WriteStr(3,2,' '+DFArr[SFId]^.LName,1);
{$ENDIF}
{$IFDEF Lat}
    WriteStr(3,2,'Expanding '+DFArr[SFId]^.LName,1);
{$ENDIF}
    Expand; ClearEvent(Event); Close;
   end;
  end;
 end;

procedure TDesignBrouse.ExpandPtr;
 var
  EndId:byte; Fld:TFldRec;
  PDF:PDataFile absolute PData;
 begin with PDF^ do begin
  WrLogStr(CurDateTime+'Expand pointer begin ...');
  EndId:=LastLine-1; Fields^.GetRec(WinCursor,Fld);
  if Fields^.Length+DFArr[Fld.FPtr]^.Fields^.Length>FldMaxCnt
   then ErrNum(esManyFldDefs) else if YN_Win2(
    ErrStr(esExpandAccep)+FldName(WinCursor)+' !',
    ErrStr(esAreYouShure))
   then begin
    WrLogStr(CurDateTime+'Expand pointer accepted ...');
    SetUseMode;
    Application^.Insert(New(PExpandWindow,
     Init(FileId,Fld.FPtr,WinCursor,FldGetFlags(Fld,ffRootInd))));
    WrLogStr(CurDateTime+'Expand window constructed ...');
    Message(Application,evBroadcast,cmColapsFileLop,Nil);
    WrLogStr(CurDateTime+'Expand pointer done ...');
    SetDesignMode;
    SetWCursor(EndId);
   end;
  WrLogStr(CurDateTime+'Expand pointer finished ...');
 end end;

{--------------------------------------------------}

end.
