unit End_User;
interface

{$I options.pp}

uses
 File_win,
 Date_lib, TV_box, App, Drivers, Views;

type
 TEndUser = object(TSApplication)
  FileWindow:PFilesWindow;
  constructor Init;
  destructor Done; virtual;
  function  GetPalette: PPalette; virtual;
  procedure InitStatusLine; virtual;
  procedure Idle; virtual;
  procedure UseFile;
 end;

function RecVal(FId,FldId:byte; RecId:longint):string;
function RealVal(FId,FldId:byte; RecId:longint):real;
procedure DateVal(FId,FldId:byte; RecId:longint; var D:DateRec);
procedure SCut(s:string; var s1,s2:string; x:byte);

procedure AnalizeParams;

implementation

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC} Sk_types, {$ENDIF}
 Info_def, Menu_cmd, Str_Def, 
 Brousers, DataFile, Records, Designer, Selector, Win_def,
 Objects, Menus, Screen;

constructor TEndUser.Init;
 begin
  inherited Init;
  New(CountWindow,Init); InsertWindow(CountWindow); FreshCounter;
  InsertWindow(New(POpenWindow,Init));
  New(FileWindow,Init); InsertWindow(FileWindow);
  DisableCommands(TCommandSet(UseCmdSet+DesCmdSet));
  Message(Application,evBroadcast,cmOpenDataMsg,Nil);
 end;
destructor TEndUser.Done;
 begin
  { Dispose(FileWindow,Done); }
  inherited Done;
 end;

const
  CSkeletColor =
        { Menu & Status line colors }{     Blue Window Colors      }
        #$71#$70#$78#$74#$4F#$46#$4E#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
     {     Brown Window Colors      }{     Gray Window Colors      }
    #$67#$6F#$6A#$13#$13#$6E#$4E#$3F#$70#$7F#$7A#$13#$13#$70#$4E#$7E +
     {   Dialog boxes colors - gray, blue, cyan ( $20 for each )   }
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

function TEndUser.GetPalette: PPalette;
 const
  P: array[apColor..apMonochrome] of string[Length(CAppColor)] =
    (CSkeletColor, CAppBlackWhite, CAppMonochrome);
 begin
  GetPalette := @P[AppPalette];
 end;

procedure TEndUser.InitStatusLine;
 var R: TRect;
 function New_Esc(P:PStatusItem): PStatusItem;
  begin New_Esc:=NewStatusKey('~Esc~ ', kbEsc, cmClose,P) end;
 function New_Can(P:PStatusItem): PStatusItem;
  begin New_Can:=NewStatusKey('~Esc~ ', kbEsc, cmCancel,P) end;
 function New_Sel(P:PStatusItem): PStatusItem;
  begin New_Sel:=New_Can(NewStatusKey('~Enter~ ',kbEnter,cmClose,P)) end;
 function New_ER(P:PStatusItem): PStatusItem;
  begin New_ER:=New_Can(NewStatusKey('~F1~ ',kbF1,cmOK,P)) end;
 function New_CanClose(P:PStatusItem): PStatusItem;
  begin New_CanClose:=New_Can(NewStatusKey('~F1~ ',kbF1,cmClose,P)) end;
 function QuerySortList(P:PStatusItem): PStatusItem;
  begin QuerySortList:=New_CanClose(
   NewStatusKey('~F2~ ',kbF2,cmAddSortEl,
   NewStatusKey('~F3~ ',kbF3,cmDelSortEl,
   P)))
  end;
 function NextPrevWinKeys: PStatusItem;
  begin NextPrevWinKeys:=
   NewStatusKey('', kbTab,      cmNext,
   NewStatusKey('', kbShiftTab, cmPrev, nil))
  end;
 const
  uskBrouse = 0;
  uskSelect = 1;
  uskInclud = 2;
  uskSetBrs = 3;
 function UseStatusKeys(usk:byte):PStatusItem;
  function Tail_0:PStatusItem;
   begin Tail_0:=
    NewStatusKey('~F7~ ',    kbF7,cmMixRec,
    NewStatusKey('~F8~ ',kbF8,cmDupRec,
    NextPrevWinKeys))
   end;
  function Tail_1:PStatusItem;
   var Tail:PStatusItem;
   begin
    case usk of
     uskBrouse,uskInclud,uskSetBrs:Tail:=
     NewStatusKey('~F6~ ',kbF6,cmRecLinks,Tail_0);
     uskSelect:Tail:=Tail_0;
    end;
    case usk of
     uskBrouse,uskSelect:Tail_1:=
     NewStatusKey('~F4~ ', kbF4, cmOrder,
     NewStatusKey('~F5~ ',  kbF5, cmPart,
     Tail));
     uskInclud,uskSetBrs:Tail_1:=Tail;
    end;
   end;
  begin
   UseStatusKeys:=
    NewStatusKey('~F1~ ',   kbF1, cmNewRec,
    NewStatusKey('~F2~ ',  kbF2, cmEditRec,
    NewStatusKey('~F3~ ',   kbF3, cmDelRec,
    Tail_1)))
  end;
 begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(1800, 1899, { Colapse File List }
    New_CanClose(
     NewStatusKey('~F2~   ',kbF2,cmSetSorsFld,
     NewStatusKey('~F3~  ', kbF3,cmSetFldValue,nil))),
   NewStatusDef(1700, 1799, { Edit Query List }
    QuerySortList(
     NewStatusKey('~F4~ ',kbF4,cmToggle,
     NewStatusKey('~F5~ ', kbF5,cmChFldVal,Nil))),
   NewStatusDef(1600, 1699, { Edit Sort List }
    QuerySortList(NewStatusKey('~F4~  ',kbF4,cmToggle,Nil)),
   NewStatusDef(1500, 1599, { Field select }
    New_Sel(NewStatusKey('~F2~ /',kbF2,cmExpColaps,Nil)),
   NewStatusDef(1450, 1499, { Included Brouser }
    New_Esc(UseStatusKeys(uskInclud)),
   NewStatusDef(1400, 1449, { Selection brouser }
    New_Esc(UseStatusKeys(uskSetBrs)),
   NewStatusDef(1350, 1399, { Record selector }
    New_Sel(UseStatusKeys(uskSelect)),
   NewStatusDef(1300, 1349, { Record brouser }
    New_Esc(UseStatusKeys(uskBrouse)),
   NewStatusDef(1200, 1299, { Field brouser }
    New_Esc(
     NewStatusKey('~F1~ ',  kbF1, cmNewFld,
     NewStatusKey('~F2~ ', kbF2, cmEditFld,
     NewStatusKey('~F3~ ', kbF3, cmDelFld,
     NextPrevWinKeys)))),
   NewStatusDef(1000, 1009, { Edit record part of record }
    New_ER(nil),
   NewStatusDef(1010, 1019, { Edit pointer part of record }
    New_ER(NewStatusKey('~F2~ ', kbF2, cmEditPtr,Nil)),
   NewStatusDef(1020, 1029, { File brouser }
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,
    NewStatusKey('~Enter~ ',kbEnter,cmUse,
    NextPrevWinKeys)),
   NewStatusDef(1100, 1110, { Simple chois }
    New_Sel(Nil),
   NewStatusDef($0000, $FFFF,
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,Nil),
   nil))))))))))))))));
 end;

procedure TEndUser.UseFile;
 var FId:byte;
 begin
  SetUseMode;
  with FileWindow^ do begin
   FId:=GetFileId(WinCursor);
   if DFArr[FId]^.Fields^.Length>0
    then InsertWindow(New(PStdBrouse,Init(FId)))
    else ErrNum(esMissFields0);
  end;
 end;

procedure TEndUser.Idle;
 begin
  inherited Idle;
  FreshCounter;
{ if CountEnabled then Message(Application,evBroadcast,cmCount,Nil); }
 end;

{----------------------------------------------------}

function RecVal(FId,FldId:byte; RecId:longint):string;
 var PB:PBlock; Fld:TFldRec;
 begin with DFArr[FId]^ do begin
  GetMem(PB,RecSize);
  Fields^.GetRec(FldId,Fld);
  if RecId<>-1 then begin
   Data^.GetRec(RecId,PB^);
   RecVal:=ClearSp(FldStdString(Fld,PB^[FldPos(FldId)],3));
  end else RecVal:='';
  FreeMem(PB,RecSize)
 end end;

function RealVal(FId,FldId:byte; RecId:longint):real;
 var PB:PBlock; Fld:TFldRec; r:real; l:longint;
 begin with DFArr[FId]^ do begin
  GetMem(PB,RecSize);
  Fields^.GetRec(FldId,Fld);
  Data^.GetRec(RecId,PB^);
  case Fld.FType of
   cfReal:begin Move(PB^[FldPos(FldId)],r,SizeOf(r)); RealVal:=r end;
   cfLong:begin Move(PB^[FldPos(FldId)],l,SizeOf(l)); RealVal:=l end;
  end;
  FreeMem(PB,RecSize);
 end end;

procedure DateVal(FId,FldId:byte; RecId:longint; var D:DateRec);
 var PB:PBlock; Fld:TFldRec;
 begin with DFArr[FId]^ do begin
  GetMem(PB,RecSize);
  Fields^.GetRec(FldId,Fld);
  Data^.GetRec(RecId,PB^);
  Move(PB^[FldPos(FldId)],D,SizeOf(DateRec));
  FreeMem(PB,RecSize);
 end end;

procedure SCut(s:string; var s1,s2:string; x:byte);
 var i:byte;
 begin
  s1:=s; s2:='';
  if length(s)>x then begin
   i:=x; while (i>0) and (s[i]<>' ') do dec(i);
   s1:=copy(s,1,i-1);
   s2:=copy(s,i+1,Length(s)-i);
  end;
 end;

{-----------------------------------------------}

procedure Help;
 begin
  Writeln;
  Writeln(ErrStr(esSRDB_Help_0));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_1));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_2));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_3));
  Writeln(ErrStr(esSRDB_Help_4));
  Writeln(ErrStr(esSRDB_Help_5));
  Writeln(ErrStr(esSRDB_Help_6));
  Writeln;
  Writeln(ErrStr(esSRDB_Help_8));
  Writeln(ErrStr(esSRDB_Help_9));
  Writeln;
  Writeln('  -V:xx - Sets vertical terminal height to xx lines.');
  Writeln('          Default value is 25, you may set 24, 38, 42.');
  Writeln;
  Halt;
 end;

procedure SetVerSize(s:string);
 var w:string; i,l:integer;
 begin
  w:=s; Delete(w,1,3);
  Val(w,l,i);
  if i=0 then begin
   if l<=24 then l:=24;
   if l>=52 then l:=52;
   screenH0:=l;
  end;
 end;

procedure SetBufSize(s:string);
 var w:string; i,l:integer;
 begin
  w:=s; Delete(w,1,3);
  Val(w,l,i);
  if i=0 then if (l>=32) and (l<=240) then begin
   StdIndxBufLen:=l;
   StdDataBufLen:=l;
  end;
 end;

procedure AnalizeParams;
 var s:string; i,j:byte;
 begin
  Writeln;
  Writeln(ErrStr(esSRDB_Help_7));
  if paramcount>0 then for i:=1 to paramcount do begin
   s:=ParamStr(i);
   if Length(s)>0 then for j:=1 to length(s) do s[j]:=UpCase(s[j]);
   if Pos('/B:',s)>0 then SetBufSize(s);
   if Pos('-V:',s)>0 then SetVerSize(s);
   if Pos('/F' ,s)>0 then KrunchEnabled:=False;
   if (s='/?') or (s='-H') then Help;
  end;
 end;

{-----------------------------------------------}

end.