unit File_Win;
{$I options.pp}
interface

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 DataFile, Win_Def,
 Drivers;

const
 ProjFileName = 'Project.Def';
 FileStatusStr0:array[0..2] of string[4] = ('norm','temp','err?');
 FileStatusStr1:array[0..2] of string[7] =
{$IFDEF Cyr}
  ('','','');
{$ENDIF}{$IFDEF Lat}
  ('  root ','  temp ',' error ');
{$ENDIF}

type
 DFNameRec = object
  FN:SmallFName;
  LN:LongFName;
  SN:ShortFName;
  Stat:byte;
  CSize:byte;
  procedure Init(
   aFN:SmallFName; aLN:LongFName; aSN:ShortFName; aStat,aCSize:byte);
  procedure Get(PDF:PDataFile);
  procedure Put(PDF:PDataFile);
 end;

 PFilesWindow = ^TFilesWindow;
 TFilesWindow = object (TBrouseWindow)
  constructor Init;
  function LastLine:longint; virtual;
{$IFDEF Design} procedure ShowCnt; virtual; {$ENDIF}
  function Line(l:longint):string; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure CorrectEnable; virtual;
 end;

{------------------------------------------}

const
 DesCount :byte = 0;
 UseCount :byte = 0;
 FileCount:byte = 0;

function SelectFileId(aFId:byte):byte;
procedure UpdateProjFile;

implementation

uses
{$IFDEF Design}
 {$IFDEF Turbo} Dos, {$ENDIF}
 {$IFDEF FPC} Linux, Strings, {$ENDIF}
 DBF_Def, Disk_rec,
{$ENDIF}
 Menu_cmd, TV_box, Records, Str_def,
 App, Objects, Views;

{------------------------------------------}

procedure UpdateProjFile;
 var t:text; i:byte;
 begin
  assign(t,ProjFileName); rewrite(t);
  writeln(t,ErrStr(esUpdProjHed0));
  writeln(t,RepChar(54,'-'));
  if FileCount>0 then for i:=0 to FileCount-1
   do with DFArr[GetFileId(i)]^ do begin
    { FILE disk_name,long_name,short_name,status }
    writeln(t,
     'FILE '+FName+','+LName+','+SName+','+
     FileStatusStr0[Status]+',',CntSize);
    writeln(t,'END_FILE');
   end;
  Close(t);
 end;

{------------------------------------------}

procedure DFNameRec.Init(
 aFN:SmallFName; aLN:LongFName; aSN:ShortFName; aStat,aCSize:byte);
 begin FN:=aFN; LN:=aLN; SN:=aSN; Stat:=aStat; CSize:=aCSize end;
procedure DFNameRec.Get(PDF:PDataFile);
 begin with PDF^ do Self.Init(FName,LName,SName,Status,CntSize) end;
procedure DFNameRec.Put(PDF:PDataFile);
 begin with PDF^ do
  begin FName:=FN; LName:=LN; SName:=SN; Status:=Stat; CntSize:=CSize end end;

function EditFParams(var DFN:DFNameRec; FullCase:boolean):boolean;
 const NormalLeter = ['A'..'Z','0'..'9'];
 var Dialog:PSRecDialog; R:TRect; OK,ST:boolean; i,j:byte;
 begin with DFN do begin
  R.Assign(0,0,40,10+ord(FullCase)); CenterRect(R);
  ST:=Stat=0;
  New(Dialog, Init(R,ErrStr(esFileNamesDl)));
  with Dialog^ do begin
   if FullCase then
   AddStrNum(esEntDos_Name,SizeOf(FN)-1);
   AddStrNum(esEntLongName,SizeOf(LN)-1);
   AddStrNum(esEntShrtName,SizeOf(SN)-1);
   AddBoolNum(esRootFileYes);
   AddNewByte(ErrStr(esLineCtrSize));
   AddOkCancelButtons; i:=0;
   if FullCase then begin Carr[i]^.SetData(FN); Inc(i) end;
   Carr[i]^.SetData(LN); Inc(i);
   Carr[i]^.SetData(SN); Inc(i);
   Carr[i]^.SetData(ST); Inc(i);
   Carr[i]^.SetData(CSize); {Inc(i);}
  end;
  OK := DeskTop^.ExecView(Dialog) <> cmCancel;
  if OK then with Dialog^ do begin
   i:=0;
   if FullCase then begin
    Carr[i]^.GetData(FN); inc(i);
    if FN='' then OK:=False else
     for j:=1 to length(FN) do if not (FN[j] in NormalLeter)
      then FN[j]:=chr(min(max(1,(ord(FN[j]) and $1F))+ord('@'),ord('Z')));
   end;
   Carr[i]^.GetData(LN); inc(i);
   Carr[i]^.GetData(SN); inc(i);
   Carr[i]^.GetData(ST); inc(i);
   Carr[i]^.GetData(CSize); {inc(i);}
   Stat:=1-ord(ST);
   if CSize<>0 then CSize:=min(8,max(2,CSize));
  end;
  Dispose(Dialog, Done); EditFParams:=OK;
 end end;

{------------------------------------------}

constructor TFilesWindow.Init;
 var R: TRect;
 begin
  {$IFDEF Design}
  R.Assign(0,3,16+17,21);
  inherited Init(bwFiles,Nil,R,5,12,ErrStr(esFilesBrHead),false);
  {$ENDIF} {$IFDEF User}
  R.Assign(0,5,16,16);
  inherited Init(bwFiles,Nil,R,3,7,' :',false);
  {$ENDIF}
  MyCmdSet:=TCommandSet(RootCmdSet);
  HelpCtx:=hcFileList;
 end;
{$IFDEF Design}
procedure TFilesWindow.ShowCnt;
 begin WriteStr(4,1,{$IFDEF Cir}'  :'{$ENDIF}
       {$IFDEF Lat}'File list:'{$ENDIF},2) end;
{$ENDIF}
function TFilesWindow.Line(l:longint):string;
 begin if l<LastLine
  then with DFArr[GetFileId(l)]^ do
   Line:=
    ' '+JustStr(LName,12)+' ' 
    {$IFDEF Design} 
    +VLChar+
    ' '+JustStr(SName,4) +' '+VLChar+
    ' '+FileStatusStr1[Status] 
    {$ENDIF}
  else Line:=BlankLine
 end;
function TFilesWindow.LastLine:longint; begin LastLine:=FileCount end;

procedure TFilesWindow.CorrectEnable;
 begin
  if DesCount>0 then DisableCommands(TCommandSet([cmUse]));
  if UseCount>0 then DisableCommands(TCommandSet([cmDesign,cmNewFile]));
  if (UseCount>0) or (DesCount>0)
   then DisableCommands(TCommandSet([cmDelFile,cmDupFile,cmRenFile
        {$IFDEF Design},cmImportDBF{$ENDIF}]));
  if WinCursor=LastLine then DisableCommands(TCommandSet(RootCmdSet1));
 end;

procedure TFilesWindow.HandleEvent(var Event: TEvent);
{$IFDEF Design}
 const
  fcNewFile   = 0;
  fcCopyFile  = 1;
  fcImportDBF = 2;
 var
  DFN:DFNameRec; Id:byte; OK:boolean;
  PDBF:PDBFFile;
 procedure ImportDBFData;
  var
   i,m:byte; Fld:TFldRec; PB:PBlock; L,Ind:longint;
   fo:TRecFileFastOut;
  begin with DFArr[Id]^ do begin
   m:=min(FldMaxCnt,PDBF^.FldCnt-1); Dispose(Data,Done);
   for i:=0 to m do begin
    PDBF^.ImportFld(i,Fld); Fields^.PutRec(i,Fld); Inc(RecSize,Fld.Size) end;
   GetMem(PB,RecSize); L:=PDBF^.Head.RecCount;
   if L>0 then begin
    fo.Init(FName+'.dat',RecSize);
    for Ind:=0 to L-1 do
     begin PDBF^.ImportRec(PB^,m); fo.PutNext(PB^) end;
    fo.Done;
   end;
   FreeMem(PB,RecSize); InitDataFile; CreateIndex(0);
  end end;
 procedure FindNewName;
  begin repeat
   OK:=EditFParams(DFN,True);
   if OK then begin
    Id:=DF_FindId(DFN.FN);
    if Id<>$FF then ErrNum(esExistSamNam);
   end;
  until (Id=$FF) or (not OK) end;
 procedure FileCreate(FId:byte; fc:byte);
  begin
   FindNewName;
   if OK then if FileCount<255 then begin
    Id:=0; while DFArr[Id]<>Nil do inc(Id);
    if FId=$FF
     then begin
      New(DFArr[Id],Create(DFN));
      if fc=fcImportDBF then ImportDBFData;
     end
     else begin
      DFArr[FId]^.MakeCopy(DFN.FN);
      New(DFArr[Id],Open(DFN))
     end;
    inc(FileCount); SetWCursor(Id); UpdateProjFile;
    Message(Application,evBroadcast,cmDesFile,Nil);
   end else LifeError('Many files in DataBase');
  end;
 procedure CreateNewFile;
  begin
   DFN.Init('DUMMY',
{$IFDEF Cir}''{$ENDIF}{$IFDEF Lat}'Unnamed'{$ENDIF},'????',0,0);
   FileCreate($FF,fcNewFile);
  end;
 procedure RenameFile;
  begin
   Id:=GetFileId(WinCursor); DFN.Get(DFArr[Id]);
   if EditFParams(DFN,False)
    then begin DFN.Put(DFArr[Id]); UpdateProjFile; ShowWCursor end
  end;
 procedure DestroyFile;
  begin
   SetUseMode; Id:=GetFileId(WinCursor);
   with DFArr[Id]^ do if Status<>1
    then ErrNum(esDestrTmpFil)
    else if FLCnt>0
     then ErrNum(esNoDstLnkFil)
     else begin { Destroy file }
      Dispose(DFArr[Id],Kill);
      DFArr[Id]:=Nil;
      Dec(FileCount);
      SetWCursor(WinCursor);
      UpdateProjFile
     end;
   SetDesignMode;
  end;
 procedure CopyFile;
  var FId:byte;
  begin
   FId:=GetFileId(WinCursor); DFN.Get(DFArr[FId]);
   DFN.Stat:=1; FileCreate(FId,fcCopyFile);
  end;
 procedure ImportDBF;
  var DBFName:string; sn:string[8];
  function SelectFileName:boolean;
   const fmax = 40;
   var
   {$IFDEF Turbo}
    DirInfo:SearchRec;
    pats:string; plen:byte absolute pats;
   {$ENDIF}
   {$IFDEF FPC}
    TheDir : PDir;
    ADirent : PDirent;
    Entry : Longint;
   {$ENDIF}
    i,nc:byte; na:array[0..fmax] of string[8];
    PCL:PChoisList;
   begin
   {$IFDEF Turbo}
    i:=pos('.',DBFName); if i>0 then DBFName:=copy(DBFName,1,i-1);
    pats:=DBFName; while pats[plen]<>'\' do dec(plen);
    New(PCL,Init); nc:=0;
    FindFirst(DBFName+'.dbf',Archive,DirInfo);
    while DosError = 0 do begin
     i:=Pos('.',DirInfo.Name);
     if (i>1) and (nc<=fmax) then begin
      na[nc]:=ClearSp(Copy(DirInfo.Name,1,i-1));
      PCL^.Insert(' '+na[nc]); inc(nc)
     end;
     FindNext(DirInfo);
    end;
    {$IFDEF Cir} PCL^.Insert(' <> ');  {$ENDIF}
    {$IFDEF Lat} PCL^.Insert(' <nobody> '); {$ENDIF}
    Dispose(PCL,Chois(i));
    if i<nc then begin
     SelectFileName:=true;
     sn:=na[i]; DBFName:=pats+sn+'.dbf';
    end else SelectFileName:=false;
   {$ENDIF}
   {$IFDEF FPC}
    New(PCL,Init); nc:=0;
    TheDir:=OpenDir(DBFName);
    Repeat
     Entry:=TellDir(TheDir);
     ADirent:=ReadDir(TheDir);
     If ADirent<>Nil then With ADirent^ do begin
      sn:=StrPas(pchar(@name[0]));
      i:=Pos('.dbf',sn);
      if (i>1) and (nc<=fmax) then begin
       na[nc]:=ClearSp(Copy(sn,1,i-1));
       PCL^.Insert(' '+na[nc]); inc(nc)
      end;
     end;
    Until ADirent=Nil;
    PCL^.Insert(' <nobody> ');
    PCL^.Chois(i);
    if i<nc then begin
     SelectFileName:=true; sn:=na[i];
     DBFName:=DBFName+'/'+sn+'.dbf';
    end else SelectFileName:=false;
   {$ENDIF}
   end;
  begin
  {$IFDEF Turbo}
   DBFName:=FExpand('*.DBF');
   EditSomeString(
    {$IFDEF Cir}'  DOS'{$ENDIF}
    {$IFDEF Lat}'DOS pattern'{$ENDIF}
    +':',DBFName,40);
  {$ENDIF}
  {$IFDEF FPC}
   DBFName:=FExpand('');
   EditSomeString('Enter path:',DBFName,50);
  {$ENDIF}
   if EditStringOK then begin
    if SelectFileName then
    if FileExists(DBFName) then begin
     New(PDBF,ImportDBF(DBFName));
     DFN.Init(sn,sn+'_DBF','????',0,0);
     FileCreate($FF,fcImportDBF);
     Dispose(PDBF,Done);
    end else LifeError(DBFName+
{$IFDEF Cir}'   ');{$ENDIF}{$IFDEF Lat}' not found');{$ENDIF}
   end;
  end;
{$ENDIF}
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evCommand:case Event.Command of
    cmBrouseDouble,cmUse:if (DesCount=0) and (WinCursor<LastLine) then
     Message(Application,evBroadcast,cmUseFile,DFArr[GetFileId(WinCursor)]);
{$IFDEF Design}
    cmDesign:
     Message(Application,evBroadcast,cmDesFile,DFArr[GetFileId(WinCursor)]);
    cmNewFile:CreateNewFile;
    cmRenFile:RenameFile;
    cmDelFile:DestroyFile;
    cmDupFile:CopyFile;
    cmImportDBF:ImportDBF;
{$ENDIF}
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

{------------------------------------------------------}

function SelectFileId(aFId:byte):byte;
 var P:PChoisList; i:byte;
 begin
  New(P,Init);
  if FileCount>0 then for i:=0 to FileCount-1
   do P^.Insert(' '+DFArr[GetFileId(i)]^.LName+' ');
  P^.SetCursor(aFId);
{$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
{$IFDEF FPC} P^.Chois(i); {$ENDIF}
  SelectFileId:=GetFileId(i);
 end;

{------------------------------------------------------}

end.
