unit info_def;
interface

{$I options.pp}

uses
 Date_lib,
 DataFile, Brousers, tv_box, 
 Views, Objects, Drivers;

const
 KrunchEnabled:boolean = True;

type
 POpenWindow = ^TOpenWindow;
 TOpenWindow = object (TSWindow)
  constructor Init;
  procedure HandleEvent(var Event: TEvent); virtual;
 end;
 PIndexingWindow = ^TIndexingWindow;
 TIndexingWindow = object (TSWindow)
  PDF:PDataFile; FldId:byte;
  constructor Init(aPDF:PDataFile; aFldId:byte);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;
 PCreateSelWindow = ^TCreateSelWindow;
 TCreateSelWindow = object (TSWindow)
  PFB:PFileBrouser; Id:Byte;
  constructor Init(aPFB:PFileBrouser; aId:byte);
  procedure HandleEvent(var Event: TEvent); virtual;
 end;
 PCountWindow = ^TCountWindow;
 TCountWindow = object (TSWindow)
  OT:TimeRec; OM:longint; OD:DateRec; OC:byte;
  constructor Init;
  procedure DrawData; virtual;
  procedure Draw; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

var
 CountWindow:PCountWindow;

procedure FreshCounter;
procedure ShowReady(PV:PView; Cnt,Max:longint);

implementation

uses
{$IFDEF Turbo} Crt, Dos, Skl_defs, {$ENDIF}
{$IFDEF FPC} Crt, Linux, Sk_types, Strings, Trace, {$ENDIF}
 Records, Selector,
 File_win, Win_def, Menu_cmd, App_def, Str_Def,
 App;

{----------------------------------------------}

constructor TCountWindow.Init;
 var R:TRect;
 begin
  R.Assign(55,17,80,23);
  inherited Init(R,
{$IFDEF Cir} '',wnNoNumber); {$ENDIF}
{$IFDEF Lat} 'SystemInfo',wnNoNumber); {$ENDIF}
  Palette:=wpBlueWindow;
  Flags:=Flags and ($FF xor (wfGrow+wfClose+wfZoom));
  Options := (Options or ofFirstClick) and ($FFFF xor ofSelectable);
  TimeClear(OT); DateClear(OD);
  OM:=-1; OC:=$FF;
 end;
procedure TCountWindow.DrawData;
 var s:string;
 begin
{$IFDEF Cir}
  Str(OM,s); WriteStr(3,1,' = '+s+'   ',1);
  WriteStr(3,2,'  '+DateStr_2(OD),1);
  WriteStr(3,3,'   '+TimeStr_1(OT),1);
  Str(OC,s); WriteStr(3,4,s+'    ',1);
{$ENDIF}
{$IFDEF Lat}
  Str(OM,s); WriteStr(3,1,'FreeMem = '+s+'   ',1);
  WriteStr(3,2,'Date is '+DateStr_2(OD),1);
  WriteStr(3,3,'Time is '+TimeStr_1(OT),1);
  Str(OC,s); WriteStr(3,4,s+' open files  ',1);
{$ENDIF}
 end;
procedure TCountWindow.Draw; begin inherited Draw; DrawData end;
procedure TCountWindow.HandleEvent(var Event: TEvent);
 var D:DateRec; T:TimeRec;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then if Event.Command=cmCountMsg then begin
   DateGetD(D); TimeGetT(T);
   if (not TimeEqu(T,OT)) or (not DateEqu(OD,D)) or
      (MemAvail<>OM) or (FileCount<>OC) then
    begin OC:=FileCount; OT:=T; OD:=D; OM:=MemAvail; DrawData end;
   ClearEvent(Event);
  end;
 end;

procedure FreshCounter;
 begin Message(CountWindow,evBroadcast,cmCountMsg,Nil) end;

{----------------------------------------------}

constructor TOpenWindow.Init;
 var R:TRect;
 begin
  R.Assign(0,0,38,6); R.Move(38,9);
{$IFDEF Cir}
  inherited Init(R,' ',wnNoNumber);
{$ENDIF}
{$IFDEF Lat}
  inherited Init(R,'StartupInfo',wnNoNumber);
{$ENDIF}
  Palette:=wpGrayWindow;
  Flags:=Flags and ($FF xor (wfGrow+wfZoom));
  { Options :=Options or ofCentered; }
 end;
procedure TOpenWindow.HandleEvent(var Event: TEvent);
 procedure KrunchFiles;
  var i,j:byte; Last,First:longint; PB,PD:PBlock; s:string[10];
  begin if FileCount>0 then for j:=0 to FileCount-1
   do with DFArr[j]^ do if Data^.Length>OpenLen then begin
     GetMem(PB,RecSize); GetMem(PD,RecSize);
     Last:=Data^.Length; First:=-1;
     while Last>OpenLen do begin
      Str(Last-OpenLen,s);
{$IFDEF Cir}
      WriteStr(3,3,' '+LName+'   '+s+' !  ',1);
{$ENDIF}
{$IFDEF Lat}
      WriteStr(3,3,'From '+LName+' remains '+s+' !  ',1);
{$ENDIF}
      Dec(Last); Data^.GetRec(Last,PB^);
      if PB^[0]<>$FF then begin
       PD^[0]:=0;
       while PD^[0]<>$FF do begin Inc(First); Data^.GetRec(First,PD^) end;
       ExchRelated(Last,First);
       Data^.GetRec(Last,PB^); Data^.PutRec0(First,PB^);
       for i:=0 to Fields^.Length-1 do if IndArr[i]<>Nil
        then with IndArr[i]^ do begin Del(Last); Add(First) end;
{       Folowing is correct only for unique fields, don't use ! }
{       then IndArr[i]^.Mov(Last,First);  }
      end;
     end;
     Data^.Trunc0(OpenLen); Data^.Flush;
     FreeMem(PD,RecSize); FreeMem(PB,RecSize);
  end end;
 procedure FindFiles;
  var t:text; i:byte; DFNR:DFNameRec;
  procedure OpenThisFile;
   begin
{$IFDEF Cir}
    WriteStr(3,3,DFNR.LN+'   !     ',1);
{$ENDIF} {$IFDEF Lat}
    WriteStr(3,3,DFNR.LN+' found !     ',1);
{$ENDIF}
    New(DFArr[FileCount],Open(DFNR));
    FreshCounter; Inc(FileCount);
    SRDBApp.FileWindow^.SetWCursor(FileCount);
   end;
  procedure OpenFldFiles;
   var
    {$IFDEF Turbo} DirInfo:SearchRec; {$ENDIF}
    {$IFDEF FPC} TheDir:PDir; ADirent:PDirent; Entry:Longint; {$ENDIF}
    i:byte; s:string[8]; sn:string[20];
   begin
{$IFDEF Turbo}
    FindFirst('*.Fld',Archive,DirInfo);
    while DosError = 0 do begin
     i:=Pos('.',DirInfo.Name);
     if i>1 then begin
      s:=ClearSp(Copy(DirInfo.Name,1,i-1));
      DFNR.Init(s,s,Copy(s,1,4),0,0); OpenThisFile;
     end;
     FindNext(DirInfo);
    end;
{$ENDIF}
{$IFDEF FPC}
    TheDir:=OpenDir('./.');
    Repeat
     Entry:=TellDir(TheDir);
     ADirent:=ReadDir(TheDir);
     If ADirent<>Nil then With ADirent^ do begin
      sn:=StrPas(pchar(@name[0]));
      i:=Pos('.fld',sn);
      if i>1 then begin
       s:=ClearSp(Copy(sn,1,i-1));
       DFNR.Init(s,s,Copy(s,1,4),0,0); OpenThisFile;
      end;
     end;
    Until ADirent=Nil;
{$ENDIF}
    UpdateProjFile;
   end;
  procedure OpenProjFile;
   var Tail:string; wrk:string[20]; i:byte; t:text; c:integer;
   function Eat:string;
    var i:byte;
    begin
     i:=Pos(',',Tail);
     if i>0
      then begin Eat:=ClearSp(Copy(Tail,1,i-1)); System.Delete(Tail,1,i) end
      else begin Eat:=Tail; Tail:='' end;
    end;
   begin
    assign(t,ProjFileName); reset(t);
    while not eof(t) do begin
     readln(t,Tail);
     if Pos('FILE ',Tail)=1 then with DFNR do begin
      System.Delete(Tail,1,5);
      FN:=Eat; LN:=Eat; SN:=Eat;
      wrk:=Eat; Stat:=2; { Error Value }
      for i:=0 to 1 do if wrk=FileStatusStr0[i] then Stat:=i;
      wrk:=Eat; if wrk='' then wrk:='0';
      Val(wrk,CSize,c); if CSize<>0 then CSize:=min(8,max(2,CSize));
      {$IFDEF Turbo} wrk:=FN+'.FLD'; {$ENDIF}
      {$IFDEF FPC} wrk:=FN+'.fld'; {$ENDIF}
      if FileExists(wrk) then OpenThisFile
       else LifeError(ErrStr(esCanTFindFil)+wrk);
     end;
    end;
    System.Close(t);
   end;
  begin
   WriteStr(3,2,ErrStr(esNowIMOpenFl),1);
   if FileExists(ProjFileName) then OpenProjFile else OpenFldFiles;
   if FileCount>0 then for i:=0 to FileCount-1 do DFArr[i]^.SetFldLinks;
   if KrunchEnabled then begin
    WriteStr(3,2,ErrStr(esNowIMCrncFl),1);
    SetUseMode; KrunchFiles; SetDesignMode;
   end;
   SRDBApp.FileWindow^.SetWCursor(0);
  end;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then if Event.Command=cmOpenDataMsg then begin
   FindFiles;
   ClearEvent(Event); Close;
  end;
 end;

{----------------------------------------------}

constructor TCreateSelWindow.Init(aPFB:PFileBrouser; aId:byte);
 var R:TRect;
 begin
  R.Assign(38,3,78,10);
{$IFDEF Cir}
  inherited Init(R,'',wnNoNumber);
{$ENDIF}
{$IFDEF Lat}
  inherited Init(R,'SelectorInfo',wnNoNumber);
{$ENDIF}
  Palette:=wpGrayWindow; Flags:=Flags and ($FF xor (wfGrow+wfZoom));
  PFB:=aPFB; Id:=aId;
 end;
procedure TCreateSelWindow.HandleEvent(var Event: TEvent);
 procedure CreateSel(cmd:word);
  var
   PFVL:PFileVirtList; Sucess:boolean; N:longint; s1,s2:string[10];
   PFS:PFileVirtSel;
   aFileId,aFldId:byte; Ind,Cnt0,Cnt1,L:longint;
   Fld:TFldRec; c:word; BigSet:TBigSet; BSSuc:boolean;
  begin with PFB^ do begin
   PFS:=PFileVirtSel(PData);
   case cmd of
    cmCreateFullSel:New(PFVL,Init(PDF^.Data));
    cmCreateQuerSel:begin
     New(PFVL,Init(PDF^.Data));
     PFVL^.LimitTxt:=ErrStr(esQuerySelect);
    end;
    cmCreateLinkSel:begin
     with PDF^.FLArr[Id] do begin aFileId:=FileId; aFldId:=FldId end;
     New(PFVL,Init(DFArr[aFileId]^.Data));
     PFVL^.LimitTxt:=ErrStr(esLinksSelect)+PDF^.LName;
    end;
    cmCreateProjSel:begin
     PDF^.Fields^.GetRec(Id,Fld);
     aFileId:=Fld.FPtr; c:=PDF^.FldPos(Id);
     New(PFVL,Init(DFArr[aFileId]^.Data));
     PFVL^.LimitTxt:=ErrStr(esProjtSelect)+PDF^.LName+'.'+PDF^.FldName(Id);
     L:=PFVL^.PCF^.Length; BigSet.Init(L,BSSuc);
    end;
   end;
   Sucess:=True; N:=0;
   while (N<LastLine) and Sucess do begin
    if RecOK(N) then case cmd of
     cmCreateFullSel:PFVL^.AddInd(PFS^.FPtr(N),Sucess);
     cmCreateQuerSel:begin
      Ind:=PFS^.FPtr(N);
      if PQueryList(Event.InfoPtr)^.TestInd(Ind)
       then PFVL^.AddInd(Ind,Sucess);
     end;
     cmCreateLinkSel:with DFArr[aFileId]^ do begin
      Ind:=PFS^.FPtr(N);
      Cnt1:=FindFirst(aFldId,Ind,False); Cnt0:=FindFirst(aFldId,Ind,True);
      if Cnt0<=Cnt1 then for L:=Cnt0 to Cnt1 do if Sucess
       then PFVL^.AddInd(IndArr[aFldId]^.GetV(L),Sucess);
     end;
     cmCreateProjSel:if BSSuc then begin
      Move(PFS^.PR^[c],Ind,SizeOf(longint));
      if Ind<>-1 then BigSet.AddEl(Ind);
     end;
    end;
    inc(N); if (N and $0F) = 0 then ShowReady(@Self,N,LastLine);
   end;
   case cmd of
    cmCreateFullSel,cmCreateQuerSel:
     Application^.InsertWindow(
      New(PStdSelection,Init(MyId,PFVL,LastInd)));
    cmCreateLinkSel:Application^.InsertWindow(
     New(PStdSelection,Init(aFileId,PFVL,-1)));
    cmCreateProjSel:if BSSuc then begin
     if L>0 then for Ind:=0 to L-1 do
      if BigSet.TestEl(Ind) and Sucess then PFVL^.AddInd(Ind,Sucess);
     BigSet.Done;
     Application^.InsertWindow(New(PStdSelection,Init(aFileId,PFVL,-1)));
    end;
   end;
  end end;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then case Event.Command of
   cmCreateFullSel,cmCreateLinkSel,
   cmCreateProjSel,cmCreateQuerSel:begin
    WriteStr(3,2,ErrStr(esCreateSelec),1);
{$IFDEF Cir}
    WriteStr(3,3,' : '+PFB^.PDF^.LName,1);
{$ENDIF}
{$IFDEF Lat}
    WriteStr(3,3,'for file: '+PFB^.PDF^.LName,1);
{$ENDIF}
    CreateSel(Event.Command);
    ClearEvent(Event); Close;
   end;
  end;
 end;

{----------------------------------------------}

constructor TIndexingWindow.Init(aPDF:PDataFile; aFldId:byte);
 var R:TRect;
 begin
  R.Assign(40,1,78,8);
{$IFDEF Cir}
  inherited Init(R,'',wnNoNumber);
{$ENDIF}
{$IFDEF Lat}
  inherited Init(R,'IndexInfo',wnNoNumber);
{$ENDIF}
  Palette:=wpGrayWindow;
  Flags:=Flags and ($FF xor (wfGrow+wfZoom));
  PDF:=aPDF; FldId:=aFldId;
 end;
procedure TIndexingWindow.HandleEvent(var Event: TEvent);
 procedure CreateNewIndex;
  const TmpIName = 'Index.TMP';
  var   TmpISize:word;
  begin
   WriteStr(3,4,ErrStr(esExtrFldData),1);
   PDF^.ExtrIndData(FldId,TmpIName,TmpISize,@Self);
   WriteStr(3,4,Blank(25),1);
   WriteStr(3,4,ErrStr(esBuildingInd),1);
   with PDF^ do New(IndArr[FldId],
    Build(IndexName(FldId),PDF,FldId,TmpIName,TmpISize,@Self));
  end;
 var Fld:TFldRec;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then if Event.Command=cmCreateIndex then begin
   WriteStr(3,2,ErrStr(esBuildingIn1),1);
{$IFDEF Cir}
   PDF^.Fields^.GetRec(FldId,Fld);
   WriteStr(3,3,': '+PDF^.LName+', : '+
{$ENDIF}
{$IFDEF Lat}
   PDF^.Fields^.GetRec(FldId,Fld);
   WriteStr(3,3,'File: '+PDF^.LName+', field: '+
{$ENDIF}
    ClearSp(RecStr(Fld.Name,FldMaxLen)),1);
   CreateNewIndex;
   ClearEvent(Event); Close;
  end;
 end;

{----------------------------------------------}

procedure ShowReady(PV:PView; Cnt,Max:longint);
 var s1,s2:string[20];
 begin
  FreshCounter; Str(Cnt,s1); Str(Max,s2);
{$IFDEF Cir}
  PV^.WriteStr(3,4,s1+'  '+s2+'  ',1);
{$ENDIF}
{$IFDEF Lat}
  PV^.WriteStr(3,4,s1+' from '+s2+' ready',1);
{$ENDIF}
 end;

{----------------------------------------------}

end.