unit lines;
interface
{$I options.pp}

uses
 Dialogs, Drivers, Objects, Views;

type
 PInputLine0 = ^TInputLine0;
 TInputLine0 = object (TInputLine)
  TextCase:boolean;
  constructor Init(var Bounds:TRect; AMaxLen:Integer; aTC:boolean);
  procedure SetState(AState: Word; Enable: Boolean); virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure GetNumber(var L:longint);
 end;
 PSInputLine = ^TSInputLine;
 TSInputLine = object (TInputLine0)
  procedure SetState(AState: Word; Enable: Boolean); virtual;
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputDate = ^TSInputDate;
 TSInputDate = object (TInputLine0)
  constructor Init(var Bounds: TRect);
  procedure SetState(AState: Word; Enable: Boolean); virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputTime = ^TSInputTime;
 TSInputTime = object (TSInputDate)
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputDate10 = ^TSInputDate10;
 TSInputDate10 = object (TSInputDate)
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputByte = ^TSInputByte;
 TSInputByte = object (TInputLine0)
  constructor Init(var Bounds: TRect);
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputWord = ^TSInputWord;
 TSInputWord = object (TInputLine0)
  constructor Init(var Bounds: TRect);
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputLong = ^TSInputLong;
 TSInputLong = object (TInputLine0)
  constructor Init(var Bounds: TRect);
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
 PSInputReal = ^TSInputReal;
 TSInputReal = object (TInputLine0)
  constructor Init(var Bounds: TRect);
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
{
 PSInputBool = ^TSInputBool;
 TSInputBool = object (TCheckBox)
  procedure SetData(var Rec); virtual;
  procedure GetData(var Rec); virtual;
 end;
}

{-----------------------------------------------}

 PSInputPntr = ^TSInputPntr;
 TSInputPntr = object (TView)
  constructor Init(aLen:byte);
  procedure SetState(AState: Word; Enable: Boolean); virtual;
  function GetPalette: PPalette; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure EditData; virtual;
 end;

{-----------------------------------------------}

implementation

uses
 {$IFDEF Turbo} skl_defs, {$ENDIF} 
 {$IFDEF FPC  } sk_types, {$ENDIF} 
 date_lib, str_def, menu_cmd;

{-----------------------------------------------}

constructor TInputLine0.Init(
 var Bounds:TRect; AMaxLen:Integer; aTC:boolean);
 begin
  inherited Init(Bounds,aMaxLen);
  TextCase:=aTC;
 end;
procedure TInputLine0.SetState(AState: Word; Enable: Boolean);
 begin
  inherited SetState(AState,Enable);
  if ((AState and sfSelected)>0) or
     (((AState and sfActive)>0) and ((State and sfSelected)>0))
   then begin SelectAll(False); BlockCursor end;
 end;
procedure TInputLine0.HandleEvent(var Event: TEvent);
 procedure Normalize;
  const  LetSmall = ['a'..'z',''..'']; LetBig   = ['A'..'Z',''..''];
  var i:byte; cs:boolean; c:char;
  begin
   cs:=true;
   if Length(Data^)>0 then for i:=1 to Length(Data^) do begin
    c:=Data^[i];
    if cs
     then if c in LetSmall then Data^[i]:=chr(ord(c)-32) else
     else if c in LetBig then Data^[i]:=chr(ord(c)+32) else;
    cs:=not (c in LetSmall+LetBig+['0'..'9']);
   end;
  end;
 begin
  inherited HandleEvent(Event);
  if (Event.What=evNothing) and (not TextCase)
   then begin Normalize; DrawView end;
 end;
procedure TInputLine0.GetNumber(var L:longint);
 var s:string; i:integer;
 begin
  inherited GetData(s); Val(ClearSp(s),L,i);
  if i<>0 then begin L:=0; ErrNum(esBadNumFormt) end;
 end;

procedure TSInputLine.SetState(AState: Word; Enable: Boolean);
 begin
  TInputLine.SetState(AState,Enable);
  if ((AState and sfSelected)>0) or
     (((AState and sfActive)>0) and ((State and sfSelected)>0))
   then begin
    SelectAll(False);
    if TextCase then NormalCursor else BlockCursor
   end;
 end;
procedure TSInputLine.SetData(var Rec);
 var s:string;
 begin
  s:=ClearSp(RecStr(Rec,MaxLen));
  inherited SetData(s);
 end;
procedure TSInputLine.GetData(var Rec);
 var s:string;
 begin
  inherited GetData(s);
  StrRec(s,Rec,MaxLen);
 end;

constructor TSInputDate.Init(var Bounds: TRect);
 begin inherited Init(Bounds,Bounds.B.X-2,True) end;
procedure TSInputDate.SetState(AState: Word; Enable: Boolean);
 begin
  inherited SetState(AState,Enable);
  { *** Next line works in oposite way to documentation ! *** }
  inherited SetState(sfCursorIns,True{False});
 end;
procedure TSInputDate.HandleEvent(var Event: TEvent);
 var OldPos:integer;
 begin
  OldPos:=CurPos; inherited HandleEvent(Event);
  if OldPos<>CurPos then case CurPos of
   2,5:begin
     if OldPos<CurPos then inc(CurPos) else dec(CurPos);
     DrawView;
    end;
  end;
 end;
procedure TSInputDate.SetData(var Rec);
 var s:string[8]; D:DateRec absolute Rec;
 begin s:=DateStr_1(D); TInputLine.SetData(s) end;
procedure TSInputDate.GetData(var Rec);
 var s:string[8]; D:DateRec absolute Rec; i:integer; w:byte;
 begin
  TInputLine.GetData(s);
  Val(copy(s,1,2),d.d,i);
  Val(copy(s,4,2),d.m,i);
  Val(copy(s,7,2),w,i);
  if (w<30) and (d.d in [1..31]) and (d.m in [1..12])
   then d.y:=100+w else d.y:=w;
 end;

procedure TSInputTime.SetData(var Rec);
 var s:string[8]; T:TimeRec absolute Rec;
 begin s:=TimeStr_1(T); TInputLine.SetData(s) end;
procedure TSInputTime.GetData(var Rec);
 var s:string[8]; T:TimeRec absolute Rec; i:integer;
 begin
  TInputLine.GetData(s);
  Val(copy(s,1,2),T.h,i); T.h:=T.h mod 24;
  Val(copy(s,4,2),T.m,i); T.m:=T.m mod 60;
  Val(copy(s,7,2),T.s,i); T.s:=T.s mod 60;
 end;

procedure TSInputDate10.SetData(var Rec);
 var s:string[10]; D:DateRec absolute Rec;
 begin s:=DateStr_2(D); TInputLine.SetData(s) end;
procedure TSInputDate10.GetData(var Rec);
 var s:string[10]; D:DateRec absolute Rec; i,w:integer;
 begin
  TInputLine.GetData(s);
  Val(copy(s,1,2),d.d,i);
  Val(copy(s,4,2),d.m,i);
  Val(copy(s,7,4),w,i);
  if (w<2155) and (w>=1900) then d.y:=w-1900 else
   if (w<30) and (w>=0) then d.y:=100+w else
    if (w>=30) and (w<100) then d.y:=w else d.y:=0;
 end;

constructor TSInputByte.Init(var Bounds: TRect);
 begin inherited Init(Bounds,3,True) end;
procedure TSInputByte.SetData(var Rec);
 var s:string[3];
 begin Str(byte(Rec),s); inherited SetData(s) end;
procedure TSInputByte.GetData(var Rec);
 var L:longint;
 begin
  GetNumber(L); byte(Rec):=L;
  if byte(Rec)<>L then begin byte(rec):=0; ErrNum(esBadNumRange) end;
 end;

constructor TSInputWord.Init(var Bounds: TRect);
 begin inherited Init(Bounds,6,True) end;
procedure TSInputWord.SetData(var Rec);
 var s:string[6];
 begin Str(word(Rec),s); inherited SetData(s) end;
procedure TSInputWord.GetData(var Rec);
 var L:longint;
 begin
  GetNumber(L); word(Rec):=L;
  if word(Rec)<>L then begin word(Rec):=0; ErrNum(esBadNumRange) end;
 end;

constructor TSInputLong.Init(var Bounds: TRect);
 begin inherited Init(Bounds,12,True) end;
procedure TSInputLong.SetData(var Rec);
 var s:string[12];
 begin Str(longint(Rec),s); inherited SetData(s) end;
procedure TSInputLong.GetData(var Rec);
 begin GetNumber(longint(Rec)) end;

constructor TSInputReal.Init(var Bounds: TRect);
 begin inherited Init(Bounds,12,True) end;
procedure TSInputReal.SetData(var Rec);
 var s:string[20]; t,n:real;
 begin
  n:=abs(round(real(Rec)));
  t:=100*abs(real(Rec)-round(real(Rec))); t:=abs(t-round(t));
  if (t>0.001) and (n<10000)
   then Str(real(Rec):12:4,s) else Str(real(Rec):12:2,s);
  s:=ClearSp(s); RExpandStr(s,12,' ');
  inherited SetData(s)
 end;
procedure TSInputReal.GetData(var Rec);
 var s:string[20]; i:integer;
 begin
  inherited GetData(s); s:=ClearSp(s);
  if Pos('.',s)=0 then s:=s+'.0';
  Val(ClearSp(s),real(Rec),i);
  if i<>0 then real(Rec):=0.0
 end;

{
procedure TSInputBool.SetData(var Rec);
 var l:longint; b:boolean absolute Rec;
 begin l:=ord(b); inherited SetData(l) end;
procedure TSInputBool.GetData(var Rec);
 var l:longint; b:boolean absolute Rec;
 begin inherited GetData(l); b:=(l and 1)>0 end;
}

{-----------------------------------------------}

constructor TSInputPntr.Init(aLen:byte);
 var R:TRect;
 begin
  R.Assign(0,0,aLen,1); inherited Init(R);
  EventMask := EventMask or (evBroadcast + evMouse + evKeyboard);
  Options:=Options or (ofSelectable + ofFirstClick);
  HelpCtx:=hcEditPtr;
 end;
procedure TSInputPntr.SetState(AState: Word; Enable: Boolean);
 begin
  inherited SetState(AState, Enable);
  if AState and sfFocused <> 0 then DrawView;
 end;
function TSInputPntr.GetPalette: PPalette;
 const P: String[Length(CCluster)] = CCluster;
 begin GetPalette:=@P end;
procedure TSInputPntr.EditData; begin end;
procedure TSInputPntr.HandleEvent(var Event: TEvent);
 var Handled:boolean;
 procedure EditData0; begin EditData; Handled:=True end;
 begin
  Handled:=False;
  case Event.What of
   evCommand:if Event.Command=cmEditPtr then EditData0;
   evMouseDown:if Event.Double then EditData0;
   evKeyDown:if Event.KeyCode = kbF2 then EditData0;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;

{-----------------------------------------------}

end.
