unit selector;
interface

{$I options.pp}

uses
 {$IFDEF Turbo} Skl_Defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 Disk_Rec, Win_Def, DataFile,
 Drivers, Views;

const
 QueryListArrMax = 10;
 FldListMaxDepth = 10;

type
 PFileVirtSel = ^TFileVirtSel;
 TFileVirtSel = object
  Size:word; CurStart,CurEnd,WrkInd:Longint;
  PR: PBlock; PCF: PRecFileCashDrv;
  constructor Init(aPCF: PRecFileCashDrv);
  procedure InitLimits; virtual;
  function Title:string; virtual;
  function FPtr(i:longint):longint; virtual;
  destructor Done; virtual;
  procedure ChangeLimits; virtual;
  function LimitStr:string; virtual;
  procedure AddInd(Ind:longint; var Sucess:boolean); virtual;
  procedure DelInd(Ind:longint); virtual;
  function  GetIndexId:byte; virtual;
 end;
 PFileStdSel = ^TFileStdSel;
 TFileStdSel = object (TFileVirtSel)
  PDF:PDataFile;
  constructor Init(aPDF: PDataFile);
  procedure InitLimits; virtual;
  function FPtr(i:longint):longint; virtual;
  procedure ChangeLimits; virtual;
  function LimitStr:string; virtual;
  procedure SetIndexId(aIndId:byte); virtual;
  procedure SetLimits(aIndId:byte; aPLim:pointer); virtual;
  function  GetIndexId:byte; virtual;
 private
  IndexId:byte; Ltd:boolean; Limits:Small;
 end;
 PLBlock = ^TLBlock;
 TLBlock = array[0..16000] of longint;
 PFileVirtList = ^TFileVirtList;
 TFileVirtList = object (TFileVirtSel)
  PList:PLBlock; ListSize,ListCnt:word;
  LimitTxt:string[80];
  constructor Init(aPCF: PRecFileCashDrv);
  procedure InitLimits; virtual;
  function FPtr(i:longint):longint; virtual;
  destructor Done; virtual;
  procedure AddInd(Ind:longint; var Sucess:boolean); virtual;
  procedure DelInd(Ind:longint); virtual;
  function LimitStr:string; virtual;
  procedure Sort(aPtr:pointer; PV:PView); virtual;
 end;
 PBigSet = ^TBigSet;
 TBigSet = object
  Data:PBlock; SetSize:longint; Size:word;
  constructor Init(aSetSize:longint; var Sucess:boolean);
  destructor Done;
  procedure AddEl(Ind:longint);
  procedure DelEl(Ind:longint);
  function TestEl(Ind:longint):boolean;
 end;

 TFldList = array[0..FldListMaxDepth] of byte;
 TQueryLine = record FL:TFldList; Rel:byte; Val:Small end;
 PQueryList = ^TQueryList;
 TQueryList = object (TBrouseWindow)
  FId,MaxCnt:byte;
  QArr:array[0..QueryListArrMax] of TQueryLine;
  constructor Init(aFId:byte);
  function LastLine:longint; virtual;
  function Line(l:longint):string; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure CorrectEnable; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  function TestInd(aInd:longint):boolean;
 end;

{---------------------------------------------}

function SelectSortList (aPtr:pointer):boolean;
function SelectQueryList(aPtr:pointer; var PQL:PQueryList):boolean;

implementation

uses
 Brousers, Records, Menu_cmd, TV_box, Info_def, Str_Def,
 App, Objects;

{-------------------------------------------------}

constructor TFileVirtSel.Init(aPCF: PRecFileCashDrv);
 begin
  PCF:=aPCF; Size:=PCF^.Size; InitLimits; GetMem(PR,Size);
 end;
procedure TFileVirtSel.InitLimits;
 begin CurStart:=0; CurEnd:=PCF^.Length end;
destructor TFileVirtSel.Done; begin FreeMem(PR,Size) end;
function TFileVirtSel.Title:string; begin Title:='' end;
function TFileVirtSel.FPtr(i:longint):longint;
 begin if CurStart+i<CurEnd then Fptr:=i+CurStart else FPtr:=-1 end;
procedure TFileVirtSel.ChangeLimits; begin end;
function TFileVirtSel.LimitStr:string; begin LimitStr:='' end;
procedure TFileVirtSel.AddInd(Ind:longint; var Sucess:boolean);
 begin end;
procedure TFileVirtSel.DelInd(Ind:longint);
 begin end;
function TFileVirtSel.GetIndexId:byte; begin GetIndexId:=$ff end;

{-------------------------------------------------}

constructor TFileStdSel.Init(aPDF: PDataFile);
 begin PDF:=aPDF; IndexId:=$FF; Ltd:=False; inherited Init(PDF^.Data) end;
function TFileStdSel.FPtr(i:longint):longint;
 begin if (IndexId=$FF) or (i+CurStart>=CurEnd)
  then FPtr:=inherited FPtr(i)
  else FPtr:=PDF^.IndArr[IndexId]^.GetV(i+CurStart);
 end;
function TFileStdSel.LimitStr:string;
 var Fld:TFldRec; s:string;
 begin
{$IFDEF Cir}
  s:='   ';
  if IndexId=$FF then s:=s+''
{$ENDIF} {$IFDEF Lat}
  s:=' Order by ';
  if IndexId=$FF then s:=s+'creation'
{$ENDIF}
   else begin
    s:=s+PDF^.FldName(IndexId);
    PDF^.Fields^.GetRec(IndexId,Fld);
   end;
  if Ltd
   then s:=s+' '+FldLimitStr(Fld,Limits)
   else s:=s+ErrStr(esAllRecords0);
  LimitStr:=s;
 end;
procedure TFileStdSel.InitLimits;
 var Fld:TFldRec;
 procedure LongLimits;
  var Num:array[0..1] of longint absolute Limits;
  begin
   Ltd:=True;
   CurStart:=PDF^.FindFirst(IndexId,Num[0],True);
   CurEnd:=PDF^.FindFirst(IndexId,Num[1],False)+1;
  end;
 procedure PntrLimits;
  var Pntr:longint absolute Limits;
  begin
   Ltd:=True;
   CurStart:=PDF^.FindFirst(IndexId,Pntr,True);
   CurEnd:=PDF^.FindFirst(IndexId,Pntr,False)+1;
  end;
 procedure DateLimits;
  var Period:TPeriod absolute Limits;
  begin
   Ltd:=True;
   CurStart:=PDF^.FindFirst(IndexId,Period.D0,True);
   CurEnd:=PDF^.FindFirst(IndexId,Period.D1,False)+1;
  end;
 procedure TextLimits;
  var ss,se:string;
  begin
   Ltd:=True; ss:=ClearSp(RecStr(Limits,Fld.Size)); se:=ss;
   RExpandStr(ss,Fld.Size,chr(0));
    CurStart:=PDF^.FindFirst(IndexId,ss[1],True);
   RExpandStr(se,Fld.Size,chr($FF));
    CurEnd:=PDF^.FindFirst(IndexId,se[1],False)+1;
  end;
 begin if Ltd
  then begin
   PDF^.Fields^.GetRec(IndexId,Fld);
   case Fld.FType of
    CFList,CFWord,CFLong:LongLimits;
    CFPntr:PntrLimits;
    CFDate:DateLimits;
    CFStr,CFName:TextLimits;
   end;
   CurEnd:=max(CurEnd,CurStart);
  end
  else if IndexId<>$FF
   then begin
    CurStart:=0; CurEnd:=PDF^.IndArr[IndexId]^.Data.Cnt;
   end
   else inherited InitLimits;
 end;
procedure TFileStdSel.ChangeLimits;
 var Fld:TFldRec;
 begin
  PDF^.Fields^.GetRec(IndexId,Fld);
  FldChangeLimits(Fld,Limits,Ltd);
 end;
procedure TFileStdSel.SetIndexId(aIndId:byte);
 begin Ltd:=False; IndexId:=aIndId; InitLimits end;
procedure TFileStdSel.SetLimits(
 aIndId:byte; aPLim:pointer);
 begin
  Move(aPLim^,Limits,SizeOf(Limits));
  Ltd:=True; IndexId:=aIndId; InitLimits
 end;
function TFileStdSel.GetIndexId:byte; begin GetIndexId:=IndexId end;

{------------------------------------------------------}

constructor TFileVirtList.Init(aPCF: PRecFileCashDrv);
 begin
  ListCnt:=0; ListSize:=100; GetMem(PList,ListSize*4);
  LimitTxt:=ErrStr(esCopySelect0); inherited Init(aPCF);
 end;
procedure TFileVirtList.InitLimits;
 begin CurStart:=0; CurEnd:=ListCnt end;
destructor TFileVirtList.Done;
 begin FreeMem(PList,ListSize*4); inherited Done end;
function TFileVirtList.FPtr(i:longint):longint;
 begin if CurStart+i<CurEnd then Fptr:=PList^[i+CurStart] else FPtr:=-1 end;
procedure TFileVirtList.AddInd(Ind:longint; var Sucess:boolean);
 var NLS:word; NP:PLBlock;
 begin
  { Sucess:=True; } NLS:=ListSize+100;
  if ListCnt=ListSize then if NLS<16000
   then if MaxAvail>NLS*4
    then begin
     GetMem(NP,NLS*4); Move(PList^,NP^,ListCnt*4);
     FreeMem(PList,ListSize*4); PList:=NP; ListSize:=NLS;
    end
    else begin Sucess:=False; ErrNum(esNoMemForLst) end
   else begin Sucess:=False; ErrNum(esTooLongList) end;
  if Sucess then begin PList^[ListCnt]:=Ind; Inc(ListCnt); InitLimits end;
 end;
procedure TFileVirtList.DelInd(Ind:longint);
 var i:longint;
 begin
  { Downto loop speeds EraseSel command }
  i:=ListCnt-1; while (i>=0) and (PList^[i]<>Ind) do dec(i);
  if i>=0 then begin PList^[i]:=PList^[ListCnt-1]; Dec(ListCnt) end;
 end;
function TFileVirtList.LimitStr:string; begin LimitStr:=LimitTxt end;

{-----------------------------------------------------------}

procedure FldListPtrE(
 aFId:byte; FL:TFldList;
 var FLCnt:byte;
 var Fld:TFldRec);
 var LastFId:byte;
 begin
  LastFId:=aFId; FLCnt:=0;
  repeat
   DFArr[LastFId]^.Fields^.GetRec(FL[FLCnt],Fld);
   inc(FLCnt); if FL[FLCnt]<>$FF then LastFId:=Fld.FPtr;
  until FL[FLCnt]=$FF;
 end;

function FldListStr0(aFId:byte; FL:TFldList):string;
 var s:string; i,j:byte; Fld:TFldRec;
 begin
  i:=aFId; j:=0; s:='';
  repeat
   s:=s+DFArr[i]^.FldName(FL[j]);
   DFArr[i]^.Fields^.GetRec(FL[j],Fld);
   inc(j); i:=Fld.FPtr;
   if FL[j]<>$FF then s:=s+'.';
  until FL[j]=$FF;
  FldListPtrE(aFId,FL,j,Fld);
  if Fld.FType=CFPntr then s:=s+' [^'+DFArr[Fld.FPtr]^.LName+']';
  FldListStr0:=s;
 end;

procedure FldListClear(aFId:byte; FL:TFldList; var Rec);
 var FLCnt:byte; Fld:TFldRec;
 begin
  FldListPtrE(aFId,FL,FLCnt,Fld);
  FldStdClear(Fld,Rec);
 end;

function QValStr(aFId:byte; FL:TFldList; var Rec):string;
 var FLCnt:byte; Fld:TFldRec;
 begin
  FldListPtrE(aFId,FL,FLCnt,Fld);
  QValStr:=FldStdString(Fld,Rec,3);
 end;

{------------------------------------------}

const
 FLArrMax = 100;

type
 PFldSelector = ^TFldSelector;
 TFldSelector = object (TBrouseWindow)
  FId,MaxCnt:byte;
  FLArr:array[0..FLArrMax] of TFldList;
  constructor Init(aFId:byte);
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure CorrectEnable; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  function LastLine:longint; virtual;
  function Line(l:longint):string; virtual;
 end;

constructor TFldSelector.Init(aFId:byte);
 var
  R:TRect; i:byte;
  PDF:PDataFile absolute PData;
 begin
  R.Assign(45,1,75,21);
  inherited Init(bwFldSel,DFArr[aFId],R,3,16,
{$IFDEF Cir} '    ' {$ENDIF}
{$IFDEF Lat} '  List for '  {$ENDIF}
   +DFArr[aFId]^.LName,false);
  { Flags:=Flags or wfClose; }
  { Options := Options or ofCentered; }
  HelpCtx:=hcFldSelect;
  MyCmdSet:=TCommandSet([cmClose,cmCancel,cmExpColaps]);
  FId:=aFId; MaxCnt:=0;
  for i:=0 to PDF^.Fields^.Length-1 do begin
   FLArr[MaxCnt][0]:=i; FLArr[MaxCnt][1]:=$FF;
   Inc(MaxCnt);
  end;
  SetWCursor(0);
 end;
function TFldSelector.GetTitle(MaxSize: Integer): TTitleStr;
 begin
{$IFDEF Cir} GetTitle:=' :'; {$ENDIF}
{$IFDEF Lat} GetTitle:='Field selector'; {$ENDIF}
 end;
function TFldSelector.LastLine:longint; begin LastLine:=MaxCnt-1 end;
procedure TFldSelector.CorrectEnable;
 var FLCnt:byte; Fld:TFldRec;
 begin
  FldListPtrE(FId,FLArr[WinCursor],FLCnt,Fld);
  if Fld.FType<>CFPntr then DisableCommands(TCommandSet([cmExpColaps]))
 end;
function TFldSelector.Line(l:longint):string;
 begin if l<=LastLine
  then Line:=FldListStr0(FId,FLArr[l])
  else Line:=BlankLine
 end;
procedure TFldSelector.HandleEvent(var Event: TEvent);
 procedure ExpandColapse;
  function Expanded:boolean;
   var i:byte; OK:boolean;
   begin if WinCursor<LastLine then begin
    OK:=True; i:=0;
    while (FLArr[WinCursor][i]<>$FF) and OK do
     begin OK:=FLArr[WinCursor][i]=FLArr[WinCursor+1][i]; inc(i) end;
    Expanded:=OK;
   end else Expanded:=false end;
  var j,k,l:byte; Fld:TFldRec;
  begin if Expanded
   then while Expanded do begin
    if WinCursor+1<LastLine
     then for k:=WinCursor+2 to LastLine do FLArr[k-1]:=FLArr[k];
    dec(MaxCnt);
   end
   else begin { Expand }
    FldListPtrE(FId,FLArr[WinCursor],j,Fld);
    l:=DFArr[Fld.FPtr]^.Fields^.Length;
    if l+MaxCnt<FLArrMax then begin
     if WinCursor<LastLine
      then for k:=LastLine downto WinCursor+1 do FLArr[k+l]:=FLArr[k];
     inc(MaxCnt,l);
     for k:=1 to l do begin
      FLArr[k+WinCursor]:=FLArr[WinCursor];
      FLArr[k+WinCursor][j  ]:=k-1;
      FLArr[k+WinCursor][j+1]:=$ff;
     end;
    end;
   end;
   SetWCursor(WinCursor);
  end;
 var Handled:boolean;
 procedure CloseSelf(Command:word);
  begin EndModal(Command); Handled:=True end;
 begin
  Handled:=False;
  case Event.What of
   evCommand:case Event.Command of
     cmCancel,cmClose:CloseSelf(Event.Command);
    end;
  end;
  if Handled then ClearEvent(Event) else begin
   inherited HandleEvent(Event);
   if Event.What=evCommand then case Event.Command of
    cmExpColaps,cmBrouseDouble:begin
     if CommandEnabled(cmExpColaps) then ExpandColapse;
     ClearEvent(Event);
    end;
   end;
  end;
 end;

function SelectFldList(aFId:byte; var FldList:TFldList):boolean;
 var P:PFldSelector; OK:boolean;
 begin
  New(P,Init(aFId));
  OK:=Desktop^.ExecView(P)=cmClose;
  if OK then FldList:=P^.FLArr[P^.WinCursor];
  SelectFldList:=OK;
  Dispose(P,Done);
 end;

{------------------------------------------}

type
 TSortLine = record FL:TFldList; Order:boolean end;
 PSortSelector = ^TSortSelector;
 TSortSelector = object (TBrouseWindow)
  FId,MaxCnt:byte;
  SortArr:array[0..FLArrMax] of TSortLine;
  constructor Init(aFId:byte);
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure CorrectEnable; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  function LastLine:longint; virtual;
  function Line(l:longint):string; virtual;
 end;

constructor TSortSelector.Init(aFId:byte);
 var
  R:TRect; i:byte;
  PDF:PDataFile absolute PData;
 begin
  R.Assign(2,3,43,20);
  inherited Init(bwFldSel,DFArr[aFId],R,4,12,ErrStr(esFldForSort0),false);
  { Flags:=Flags or wfClose; }
  { Options := Options or ofCentered; }
  HelpCtx:=hcSortSelect;
  MyCmdSet:=TCommandSet([cmClose,cmCancel,cmAddSortEl,cmDelSortEl,cmToggle]);
  FId:=aFId; MaxCnt:=0; SetWCursor(0);
 end;
function TSortSelector.GetTitle(MaxSize: Integer): TTitleStr;
 begin
{$IFDEF Cir} GetTitle:='  ' {$ENDIF}
{$IFDEF Lat} GetTitle:='Sorter for ' {$ENDIF}
   +DFArr[FId]^.LName;
 end;
function TSortSelector.LastLine:longint; begin LastLine:=MaxCnt end;
procedure TSortSelector.CorrectEnable;
 begin if WinCursor=LastLine
  then DisableCommands(TCommandSet([cmDelSortEl,cmToggle])) end;
function TSortSelector.Line(l:longint):string;
 var s:string[10];
 begin if l<LastLine
  then begin
   if SortArr[l].Order
{$IFDEF Cir} then s:='' else s:=''; {$ENDIF}
{$IFDEF Lat} then s:='increase' else s:='decrase'; {$ENDIF}
   Line:=JustStr(FldListStr0(FId,SortArr[l].FL),28)+VLChar+' '+s;
  end
  else Line:=BlankLine
 end;
procedure TSortSelector.HandleEvent(var Event: TEvent);
 procedure AddSortEl;
  var FldList:TFldList;
  begin if SelectFldList(FId,FldList) then begin
   SortArr[MaxCnt].FL:=FldList;
   SortArr[MaxCnt].Order:=True;
   inc(MaxCnt); SetWCursor(MaxCnt-1);
  end end;
 procedure DelSortEl;
  var i:byte;
  begin
   if WinCursor<LastLine-1 then
    for i:=WinCursor to LastLine-2 do SortArr[i]:=SortArr[i+1];
   dec(MaxCnt); SetWCursor(WinCursor);
  end;
 var Handled:boolean;
 begin
  Handled:=True;
  case Event.What of
   evMouseDown:Handled:=Event.Double;
   evCommand:case Event.Command of
     cmCancel,cmClose:EndModal(Event.Command);
     cmAddSortEl:AddSortEl;
     cmDelSortEl:DelSortEl;
     cmToggle:begin
      SortArr[WinCursor].Order:=not SortArr[WinCursor].Order;
      ShowWCursor;
     end;
     else Handled:=False;
    end;
    else Handled:=False;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;

procedure SetInitEvent;
 var Ev:TEvent;
 begin
  with Ev do begin What:=evCommand; Command:=cmAddSortEl; InfoPtr:=nil end;
  Desktop^.PutEvent(Ev);
 end;

function SelectSortList(aPtr:pointer):boolean;
 var
  PSS:PSortSelector; OK:boolean;
  PFB:PFileBrouser absolute aPtr;
  PFVL:PFileVirtList;
 begin
  New(PSS,Init(PFB^.MyId));
  SetInitEvent; OK:=Desktop^.ExecView(PSS)=cmClose;
  if OK and (PSS^.MaxCnt>0) then begin
   PFVL:=PFB^.PData;
   PFVL^.Sort(PSS,PFB);
  end else OK:=False;
  Dispose(PSS,Done); SelectSortList:=OK;
 end;

{------------------------------------------}

const
 rcEqual = 0;
 rcNoEqu = 1;
 rcLessE = 2;
 rcGreaE = 3;
 rcBegin = 4;
 rcConts = 5;

function QRelStr(r:byte):string;
 var s:string[15];
 begin
  case r of
{$IFDEF Cir}
   rcEqual:s:=' ';
   rcNoEqu:s:=' ';
   rcLessE:s:='<  ';
   rcGreaE:s:='>  ';
   rcBegin:s:=' ';
   rcConts:s:=' ';
{$ENDIF}{$IFDEF Lat}
   rcEqual:s:='equal to';
   rcNoEqu:s:='differ from';
   rcLessE:s:='< or equal';
   rcGreaE:s:='> or equal';
   rcBegin:s:='starts with';
   rcConts:s:='contains';
{$ENDIF}
  end;
  QRelStr:=JustStr(' '+s,15);
 end;

function SelectRel(r,t:byte):byte;
 var P:PChoisList; i,m:byte;
 begin
  case t of
   CFList,CFWord,CFLong,CFReal,CFDate,CFTime:m:=rcGreaE;
   CFPntr:m:=rcNoEqu;
   CFStr,CFName:m:=rcConts;
  end;
  New(P,Init);
  for i:=0 to m do P^.Insert(QRelStr(i));
  P^.SetCursor(r);
  {$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
  {$IFDEF FPC} P^.Chois(i); {$ENDIF}
  if i>m then SelectRel:=r else SelectRel:=i;
 end;

constructor TQueryList.Init(aFId:byte);
 var
  R:TRect; i:byte;
  PDF:PDataFile absolute PData;
 begin
  R.Assign(2,3,73,20);
  inherited Init(bwFldSel,DFArr[aFId],R,4,12,ErrStr(esFldForQuery),false);
  HelpCtx:=hcQueryList;
  MyCmdSet:=TCommandSet(
   [cmClose,cmCancel,cmAddSortEl,cmDelSortEl,cmToggle,cmChFldVal]);
  FId:=aFId; MaxCnt:=0;
  SetWCursor(0);
 end;
function TQueryList.GetTitle(MaxSize: Integer): TTitleStr;
 begin GetTitle:=ErrStr(esQueryWTitle)+DFArr[FId]^.LName end;
function TQueryList.LastLine:longint; begin LastLine:=MaxCnt end;
procedure TQueryList.CorrectEnable;
 begin if WinCursor=LastLine
  then DisableCommands(TCommandSet([cmDelSortEl,cmToggle,cmChFldVal])) end;
function TQueryList.Line(l:longint):string;
 begin if l<LastLine
  then with QArr[l] do Line:=
   JustStr(FldListStr0(FId,FL),24)+VLChar+
   QRelStr(Rel)+VLChar+
   ' '+ClearSp(QValStr(FId,FL,Val))
  else Line:=BlankLine
 end;
procedure TQueryList.HandleEvent(var Event: TEvent);
 var FLCnt:byte; Fld:TFldRec;
 procedure SelRelForEl;
  begin with QArr[WinCursor] do begin
   FldListPtrE(FId,FL,FLCnt,Fld);
   Rel:=SelectRel(Rel,Fld.FType);
   ShowWCursor;
  end end;
 procedure ChFldVal;
  begin with QArr[WinCursor] do begin
   FldListPtrE(FId,FL,FLCnt,Fld);
   EditFirstFldValue(Fld,Val,1);
   ShowWCursor;
  end end;
 procedure AddQueryEl;
  var FldList:TFldList;
  begin if SelectFldList(FId,FldList) then with QArr[MaxCnt] do begin
   FL:=FldList; FldListPtrE(FId,FL,FLCnt,Fld);
   case Fld.FType of
    cfName, cfStr: Rel:=rcConts;
    else Rel:=rcEqual;
   end;
   FldListClear(FId,FL,Val);
   inc(MaxCnt); SetWCursor(MaxCnt-1);
   SelRelForEl; ChFldVal;
  end end;
 procedure DelQueryEl;
  var i:byte;
  begin
   if WinCursor<LastLine-1 then
    for i:=WinCursor to LastLine-2 do QArr[i]:=QArr[i+1];
   dec(MaxCnt); SetWCursor(WinCursor);
  end;
 var Handled:boolean;
 begin
  Handled:=True;
  case Event.What of
   evMouseDown:Handled:=Event.Double;
   evCommand:case Event.Command of
     cmCancel,cmClose:EndModal(Event.Command);
     cmAddSortEl:AddQueryEl;
     cmDelSortEl:DelQueryEl;
     cmToggle:SelRelForEl;
     cmChFldVal:ChFldVal;
     else Handled:=False
    end;
   else Handled:=False;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;

function SelectQueryList(aPtr:pointer; var PQL:PQueryList):boolean;
 var OK:boolean;
 begin
  New(PQL,Init(PFileBrouser(aPtr)^.MyId));
  SetInitEvent; OK:=Desktop^.ExecView(PQL)=cmClose;
  SelectQueryList:=OK and (PQL^.MaxCnt>0);
 end;

{------------------------------------------}

const
 MaxRecSize = 2000;
 SLI = SizeOf(longint);

function TQueryList.TestInd(aInd:longint):boolean;
 var P:PBlock; QL:TQueryLine; cQL,cFId:byte; OK:boolean;
 procedure TestAttempt;
  var cnt,cFld:byte; Fld:TFldRec; Ind:longint; c:word;
  function PosStr:byte;
   var s:string;
   begin
    s:=LoRecStr(QL.Val,Fld.Size);
    if s='' then PosStr:=1 else PosStr:=Pos(s,LoRecStr(P^[c],Fld.Size))
   end;
  begin
   cnt:=0; Ind:=aInd;
   repeat
    cFld:=QL.FL[cnt]; inc(cnt);
    with DFArr[cFId]^ do begin
     Data^.GetRec(Ind,P^);
     c:=FldPos(cFld);
     Fields^.GetRec(cFld,Fld);
    end;
    if QL.FL[cnt]<>$ff then begin Move(P^[c],Ind,SLI); cFId:=Fld.FPtr end;
   until (QL.FL[cnt]=$ff) or (Ind=-1);
   if Ind=-1 then OK:=False else case QL.Rel of
    rcEqual:OK:=FldEqual(Fld,P^[c],QL.Val);
    rcNoEqu:OK:=not FldEqual(Fld,P^[c],QL.Val);
    rcLessE:OK:=FldLess(Fld,P^[c],QL.Val);
    rcGreaE:OK:=FldLess(Fld,QL.Val,P^[c]);
    rcBegin:OK:=PosStr=1;
    rcConts:OK:=PosStr>0;
   end;
  end;
 begin
  GetMem(P,MaxRecSize);
  OK:=True; cQL:=0;
  while (cQL<MaxCnt) and OK do begin
   QL:=QArr[cQL]; cFId:=FId;
   TestAttempt; inc(cQL);
  end;
  TestInd:=OK;
  FreeMem(P,MaxRecSize);
 end;

procedure TFileVirtList.Sort(aPtr:pointer; PV:PView);
 var
  PSS:PSortSelector absolute aPtr;
  P1,P2:PBlock; x,w:longint; Depth:byte; s:string[20]; c:char;
 procedure Show;
  begin
   inc(w);
   if (w and $3f) = 0 then begin
    FreshCounter;
    case (w shr 6) and 3 of
     0:c:='|'; 1:c:='/'; 2:c:='-'; 3:c:='\' end;
    PV^.WriteChar(Depth-1,PV^.Size.Y-1,c,2,1)
   end;
  end;
 function Less(a,b:longint):boolean;
  var SL:TSortLine; cFId,cSL:byte; OK:boolean;
  function SortAttempt:boolean;
   var cnt,cFld:byte; Fld:TFldRec; a0,b0:longint; c:word;
   begin
    cnt:=0; a0:=a; b0:=b;
    repeat
     cFld:=SL.FL[cnt]; inc(cnt);
     with DFArr[cFId]^ do begin
      Data^.GetRec(a0,P1^); Data^.GetRec(b0,P2^);
      c:=FldPos(cFld); Fields^.GetRec(cFld,Fld);
     end;
     if SL.FL[cnt]<>$ff then
      begin Move(P1^[c],a0,SLI); Move(P2^[c],b0,SLI); cFId:=Fld.FPtr end;
    until (SL.FL[cnt]=$ff) or (a0=-1) or (b0=-1);
    if (a0=-1) then if (b0=-1)
     then else begin OK:=True; SortAttempt:=SL.Order end
     else if (b0=-1)
      then begin OK:=True; SortAttempt:=not SL.Order end
      else if not FldEqual(Fld,P1^[c],P2^[c]) then begin
       OK:=True;
       if SL.Order
        then SortAttempt:=FldLess(Fld,P1^[c],P2^[c])
        else SortAttempt:=FldLess(Fld,P2^[c],P1^[c])
      end;
   end;
  begin
   OK:=false; cSL:=0;
   while (cSL<PSS^.MaxCnt) and (not OK) do begin
    SL:=PSS^.SortArr[cSL]; cFId:=PSS^.FId; inc(cSL);
    Less:=SortAttempt;
   end;
   if not OK then Less:=a<=b;
   Show;
  end;
 procedure Quick_Sort(lo,hi:word);
  var i,j:word; k:longint;
  procedure swap;
   begin k:=PList^[i]; PList^[i]:=PList^[j]; PList^[j]:=k end;
  begin
   i:=lo; j:=hi;
   if j>i then if j=i+1
    then if Less(PList^[j],PList^[i]) then swap else begin end
    else begin
     x:=PList^[(i+j) div 2];
     repeat
      while not Less(x,PList^[i]) do inc(i);
      while not Less(PList^[j],x) do dec(j);
      if i<j then swap; if i<=j then begin inc(i); dec(j) end;
     until i > j;
     if lo < j then Quick_Sort(lo,j);
     if i < hi then Quick_Sort(i,hi);
    end
  end;
 begin
{$IFDEF Cir} s:=''; {$ENDIF}
{$IFDEF Lat} s:='Sorting'; {$ENDIF}
  PV^.WriteStr(3,PV^.Size.Y-1,s+'   ',2);
  Depth:=5+Length(s); w:=0;
  GetMem(P1,MaxRecSize); GetMem(P2,MaxRecSize);
  if ListCnt>1 then Quick_Sort(0,ListCnt-1);
  FreeMem(P1,MaxRecSize); FreeMem(P2,MaxRecSize);
 end; { FastSort }

{------------------------------------------}

const
 ByteMap:array[0..7] of byte = (1,2,4,8,16,32,64,128);

constructor TBigSet.Init(aSetSize:longint; var Sucess:boolean);
 var BSize:longint;
 begin
  SetSize:=aSetSize; BSize:=((SetSize-1) div 8)+1;
  if (MemAvail>BSize*2) and (MaxAvail>BSize) and (BSize<SizeOf(Block))
   then begin
    Size:=BSize; GetMem(Data,Size);
    FillChar(Data^,Size,chr(0));
   end
   else begin Size:=0; Data:=Nil; ErrNum(esNoMemForSet) end;
  Sucess:=Data<>Nil;
 end;
destructor TBigSet.Done;
 begin if Data<>Nil then FreeMem(Data,Size) end;
{$R+}
procedure TBigSet.AddEl(Ind:longint);
 var I0:word;
 begin
  I0:=Ind shr 3;
  Data^[I0]:=Data^[I0] or ByteMap[Ind and $07]
 end;
procedure TBigSet.DelEl(Ind:longint);
 var I0:word;
 begin
  I0:=Ind shr 3;
  Data^[I0]:=Data^[I0] and ($FF xor ByteMap[Ind and $07]);
 end;
function TBigSet.TestEl(Ind:longint):boolean;
 begin TestEl:=Data^[Ind shr 3] and ByteMap[Ind and $07] <> 0 end;
{$R-}

{------------------------------------------}

end.

