unit sk_types;

{$I options.pp}

interface

{$ifdef FPC}
uses linux;
{$endif}
{$ifdef Turbo}
{$endif}

const
 MaxWrd = 65000;

type
 Long = longint;
 Block = array[0..MaxWrd] of byte;
 PBlock = ^Block;
 Small = array[byte] of byte;
 PSmall = ^Small;
 StdString = string[255];
 SmallFName = string[8];
 FullFName  = string[80];

function min(x,y:Long):Long;
function max(x,y:Long):Long;
procedure StdError(s:StdString);
function equ(var o1,o2; count:Long):boolean;
function UpStr(s:StdString):StdString;
function FileDelete(FName:StdString):boolean;
function FileExists(FName:StdString):Boolean;

function blank(x:byte):string;
function RepChar(x:byte;c:char):string;
procedure RExpandStr(var str; x:byte; c:char);
procedure LExpandStr(var str; x:byte; c:char);
function RClearSp(s:string):string;
function LClearSp(s:string):string;
function  ClearSp(s:string):string;
function JustStr(s:string; x:byte):string;
function RecStr(var R; l:byte):string;
procedure StrRec(s:string; var R; l:byte);
procedure ReplStr(var sors:string; dest:string; x:byte);
function MixStr(sors,dest:string; x:byte):string;

function MacDosChar(w:byte):byte;
function DosWinChar(w:byte):byte;
function WinDosChar(w:byte):byte;

implementation

function min(x,y:Long):Long; begin if x<y then min:=x else min:=y end;
function max(x,y:Long):Long; begin if x<y then max:=y else max:=x end;
procedure StdError(s:StdString);
{$IFDEF Turbo}
 begin
  writeln; writeln(s);
  write('Press Enter to stop ! '); readln; Halt
 end;
{$endif}
{$ifdef FPC}
 begin writeln(StdErr,s); Halt(1) end;
{$ENDIF}
function equ(var o1,o2; count:Long):boolean;
 var b:boolean; i:Long;
 begin
  i:=0; b:=true;
  while (i<count) and b do begin b:=block(o1)[i]=block(o2)[i]; inc(i) end;
  equ:=b;
 end;
function UpStr(s:StdString):StdString;
 var w:StdString; i:byte;
 begin
  w[0]:=s[0];
  if length(s)>0 then for i:=1 to length(s) do w[i]:=UpCase(s[i]);
  UpStr:=w; 
 end;
function FileDelete(FName:StdString):boolean;
 begin FileDelete:=UnLink(FName) end;
function FileExists(FName:StdString):Boolean;
 var  fdes:longint;
 begin
   fdes:=fdOpen(FName,Open_RdOnly {+Open_Creat,$1FF});
   FileExists:=fdes>=0;
   if fdes>=0 then fdClose(fdes);
 end;

function blank(x:byte):string;
 begin blank:=RepChar(x,' ') end;
function RepChar(x:byte;c:char):string;
 var s:string; begin s[0]:=chr(x); FillChar(s[1],x,c); RepChar:=s end;
procedure RExpandStr(var str; x:byte; c:char);
 var i:byte; s:string absolute str;
 begin i:=length(s); if i<x then s:=s+RepChar(x-i,c) end;
procedure LExpandStr(var str; x:byte; c:char);
 var i:byte; s:string absolute str;
 begin i:=length(s); if i<x then s:=RepChar(x-i,c)+s end;
function RClearSp(s:string):string;
 var i:byte;
 begin
  i:=length(s); while (i>0) and (s[i]=' ') do dec(i);
  RClearSp:=copy(s,1,i);
 end;
function LClearSp(s:string):string;
 var i:byte;
 begin
  i:=1; while (i<=length(s)) and (s[i]=' ') do inc(i);
  LClearSp:=copy(s,i,length(s)+1-i);
 end;
function  ClearSp(s:string):string;
 begin ClearSp:=LClearSp(RClearSp(s)) end;
function JustStr(s:string; x:byte):string;
 var s1:string;
 begin s1:=copy(s,1,x); RExpandStr(s1,x,' '); JustStr:=s1 end;
function RecStr(var R; l:byte):string;
 var s:string;
 begin s[0]:=chr(l); Move(R,s[1],l); RecStr:=s end;
procedure StrRec(s:string; var R; l:byte);
 var s1:string;
 begin s1:=s; RExpandStr(s1,l,' '); Move(s1[1],R,l) end;
procedure ReplStr(var sors:string; dest:string; x:byte);
 var i,j:byte;
 begin
  i:=x; j:=1;
  while (i<=Length(sors)) and (j<=Length(dest)) do begin
   sors[i]:=dest[j]; inc(i); inc(j);
  end;
 end;
function MixStr(sors,dest:string; x:byte):string;
 var s:string;
 begin s:=sors; ReplStr(s,dest,x); MixStr:=s end;

function MacDosChar(w:byte):byte;
 begin
  MacDosChar:=w;
  if w in [$E0..$FE]
   then MacDosChar:=w-$40
   else case w of
    $DF:MacDosChar:=$BF; {  }
    $DC:MacDosChar:=$D5; {  }
    $D6:MacDosChar:=$F6; {  }
    $D2,$D3,$D7:MacDosChar:=$22; { " }
    $D4,$D5:MacDosChar:=$27; { ' }
   end;
 end;
function DosWinChar(w:byte):byte;
 begin
  DosWinChar:=w;
  if w in [$80..$BF]
   then DosWinChar:=w+$40
   else case w of
    $D5:DosWinChar:=ord('N'); {  }
    $F6:DosWinChar:=ord('-'); {  }
   end;
 end;
function WinDosChar(w:byte):byte;
 begin
  WinDosChar:=w;
  if w in [$C0..$FF]
   then WinDosChar:=w-$40
   else case w of
    $93, $94:WinDosChar:=$22; { " }
   end;
 end;


end.

