unit tv_sort;
interface

{$I options.pp}

{$IFDEF TVision}
uses Views;
{$ENDIF}
{$IFDEF NoTV}
uses crt;
{$ENDIF}

type
 cmp_fun=function (var o1,o2):boolean;
 TCntProc=procedure(n:word);

procedure Sort_File( FName: string; size:word;
                     less_or_equal:cmp_fun
                     {$IFDEF TVision}; PV:PView{$ENDIF});
procedure Merge_File(SorsFName,DestFName: string; size:word;
                     less_or_equal:cmp_fun;
                     EraseEquals:boolean;
                     CntProc:TCntProc);
function WordLess(var o1,o2):boolean;
procedure StdCntProc(n:word);

implementation

uses
{$IFDEF TVision}
 Info_def,
{$ENDIF}
 {$IFDEF Turbo} skl_defs, {$ENDIF}
 {$IFDEF FPC} sk_types, Trace, Date_lib, {$ENDIF}
 disk_rec, Str_def;

{$IFDEF Turbo} {$F+} {$ENDIF}
function WordLess(var o1,o2):boolean;
 var
  n1:word absolute o1;
  n2:word absolute o2;
 begin WordLess:=n1<=n2 end;
procedure StdCntProc(n:word);
 begin
 end;
{$IFDEF Turbo} {$F-} {$ENDIF}

procedure Sort_File(FName: string; size:word;
                    less_or_equal:cmp_fun
                    {$IFDEF TVision}; PV:PView{$ENDIF});
 var f:file; MaxBuf:word;

 procedure Sort_1(name:string);
  var f1:file; l:longint;

  procedure Sort_fast;
   const md = 64;
   var
    q,x:pointer; d:^block; n:word;
    Depth,D_y:byte; s:string[40];
   procedure Quick_Sort(lo,hi,delta:word);
    var i,j:word;
    procedure swap;
     begin Move(d^[i],q^,size); Move(d^[j],d^[i],size); Move(q^,d^[j],size) end;
    begin
     i:=lo; j:=hi;
     if j>i then if j=i+size
      then if less_or_equal(d^[j],d^[i]) then swap else begin end
      else begin
       if Delta>md then begin
{$IFDEF TVision}
        PV^.WriteChar(Depth,4,'>',1,1);
{$ENDIF}
{$IFDEF NoTV}
        gotoxy(Depth,D_y); write('>');
{$ENDIF}
        inc(Depth)
       end;
       Move(d^[lo+size*(delta div 2)],x^,size);
       repeat
        while not less_or_equal(x^,d^[i]) do inc(i,size);
        while not less_or_equal(d^[j],x^) do dec(j,size);
        if i<j then swap;
        if i<=j then begin inc(i,size); dec(j,size) end;
       until i > j;
       if lo < j then Quick_Sort(lo, j, (j-lo) div size);
       if i < hi then Quick_Sort(i, hi, (hi-i) div size);
       if Delta>md then begin
        Dec(Depth);
{$IFDEF TVision}
        PV^.WriteChar(Depth,4,' ',1,1)
{$ENDIF}
{$IFDEF NoTV}
        gotoxy(Depth,D_y); write(' ');
{$ENDIF}
       end;
      end;
    end;
   begin
{$IFDEF Cir} s:=' '+name; {$ENDIF}
{$IFDEF Lat} s:='Sorting ' +name; {$ENDIF}
{$IFDEF TVision}
    PV^.WriteStr(3,4,JustStr(s,25),1);
    Depth:=4+Length(s);
{$ENDIF}
{$IFDEF NoTV}
    Write(s+';  Mem=',MemAvail,' ');
    D_y:=WhereY; Depth:=2+Length(s);
{$ENDIF}
    GetMem(d,MaxBuf);
    BlockRead(f1,d^,l);
    GetMem(q,size); GetMem(x,size);
    n:=l-size; Quick_Sort(0,n,n div size);
    FreeMem(x,size); FreeMem(q,size);
    Seek(f1,0); BlockWrite(f1,d^,l);
    FreeMem(d,MaxBuf);
{$IFDEF NoTV}
    WriteLn;
{$ENDIF}
   end; { Sort_fast }

  procedure Split_file;
   var f2:file; l1,l2,i:longint; p:pointer; k:word; s:string[60];
   begin
{$IFDEF Cir} s:=' ' +name; {$ENDIF}
{$IFDEF Lat} s:='Split '+name; {$ENDIF}
{$IFDEF TVision}
    PV^.WriteStr(3,4,JustStr(s,25),1);
{$ENDIF}
{$IFDEF NoTV}
    WriteLn(s+';  Mem=',MemAvail);
{$ENDIF}
    GetMem(p,MaxBuf);
    l1:=l div size; l2:=l1 shr 1;
    seek(f1,l2*size);
    i:=l1-l2; k:=MaxBuf div size;
    assign(f2,name+'1'); rewrite(f2,1);
    while i>0 do begin
     if i>=k then dec(i,k) else begin k:=i; i:=0 end;
     BlockRead(f1,p^,k*size); BlockWrite(f2,p^,k*size)
    end;
    close(f2);
    seek(f1,l2*size); truncate(f1); close(f1);
    FileDelete(name+'0'); assign(f2,name); rename(f2,name+'0');
    FreeMem(p,MaxBuf);
   end;

  procedure Merge_file0;
   var q2,q3:pointer;
       out_1:TRecFileFastOut;
       in_2,in_3:TRecFileFastIn;
       f3_buf,f2_out:boolean;
       s:string[60];
   procedure f3_set;
    begin f3_buf:=not in_3.e_file; if f3_buf then in_3.GetNext(q3^) end;
   procedure f3_flow; begin out_1.PutNext(q3^); f3_set end;
   procedure o2; begin out_1.PutNext(q2^); f2_out:=true end;
   begin
{$IFDEF Cir} s:=' ' +name; {$ENDIF}
{$IFDEF Lat} s:='Merging '+name; {$ENDIF}
{$IFDEF TVision}
    PV^.WriteStr(3,4,JustStr(s,25),1);
{$ENDIF}
{$IFDEF NoTV}
    WriteLn(s+';  Mem=',MemAvail);
{$ENDIF}
    GetMem(q2,size); GetMem(q3,size); out_1.init(name,size);
    in_2.init(name+'0',size); in_3.init(name+'1',size);
    f3_set;
    while not in_2.e_file do begin
     in_2.GetNext(q2^); f2_out:=false;
     while not f2_out do if f3_buf
      then if less_or_equal(q2^,q3^) then o2 else f3_flow else o2;
    end;
    while f3_buf do f3_flow;
    in_2.Kill; in_3.Kill;
    FreeMem(q2,size); FreeMem(q3,size); out_1.done;
   end; { Merge_file }

  begin
   WrLogStr(CurDateTime+' Sort_1 begin ...');
{$IFDEF TVision}
   FreshCounter;
{$ENDIF}
   assign(f1,name); reset(f1,1);
   l:=FileSize(f1);
   if l<MaxBuf
    then begin if l>0 then Sort_fast; close(f1) end
    else begin
     Split_file;
     Sort_1(name+'0'); Sort_1(name+'1');
     Merge_file0;
    end;
   WrLogStr(CurDateTime+' Sort_1 end ...');
  end; { Sort_1 }

 begin
  if (MaxAvail>=MaxWrd+8) and (MemAvail>80000)
   then MaxBuf:=MaxWrd
   else if MaxAvail>10*Size+10000
    then MaxBuf:=Min(MaxWrd,MaxAvail-5*Size-2000)
    else begin
{$IFDEF TVision}
     ErrNum(esNoMemForSrt);
{$ENDIF}
{$IFDEF NoTV}
     Write(ErrStr(esNoMemForSrt)); readln;
{$ENDIF}
     Halt
    end;
  WrLogStr(CurDateTime+' MaxBuf=$'+HexLong(MaxBuf));
  WrLogStr('-------------- Starting sort for file '+FName);
  if FileExists(FName) then begin
     FileDelete('_'); assign(f,FName);
     rename(f,'_');
     WrLogStr(CurDateTime+' File rename to "_" OK');
     Sort_1('_');
     WrLogStr(CurDateTime+' Sort_1 for "_" OK');
     { This assign is for bug in FPC 0.99.5_3 }
     assign(f,'_'); rename(f,FName);
     WrLogStr(CurDateTime+' Rename back to '+FName+' OK');
  end;
  WrLogStr('-------------- Sort for file '+FName+' OK ...');
 end; { Sort_file }

{----------------------------------------------------------}

procedure Merge_File(SorsFName,DestFName: string; size:word;
                     less_or_equal:cmp_fun;
                     EraseEquals:boolean;
                     CntProc:TCntProc);
  var q1,q2,q3:pointer;
      out_1:TRecFileFastOut; f:file;
      in_2,in_3:TRecFileFastIn;
      f3_buf,f2_out:boolean;
      Cnt:word; NewRec:boolean;
  procedure f1_out(var R);
   begin if EraseEquals
    then if Equ(R,q1^,size)
     then NewRec:=False
     else begin
      if NewRec then begin inc(Cnt); CntProc(Cnt) end;
      out_1.PutNext(R); Move(R,q1^,size);
      NewRec:=True;
     end
    else out_1.PutNext(R);
   end;
  procedure f3_set;
   begin f3_buf:=not in_3.e_file; if f3_buf then in_3.GetNext(q3^) end;
  procedure f3_flow; begin f1_out(q3^); f3_set end;
  procedure o2; begin f1_out(q2^); f2_out:=true end;
  begin
   GetMem(q1,size); FillChar(q1^,size,$FF);
   GetMem(q2,size); GetMem(q3,size);
   out_1.init('MergeAlg.TMP',size);
   in_2.init(SorsFName,size); in_3.init(DestFName,size);
   f3_set;
   Cnt:=0; NewRec:=False;
   while not in_2.e_file do begin
    in_2.GetNext(q2^); f2_out:=false;
    while not f2_out do if f3_buf
     then if less_or_equal(q2^,q3^) then o2 else f3_flow else o2;
   end;
   while f3_buf do f3_flow;
   in_2.Kill; in_3.Kill;
   FreeMem(q1,size); FreeMem(q2,size); FreeMem(q3,size);
   out_1.Done; assign(f,'MergeAlg.TMP'); rename(f,DestFName);
  end; { Merge_file }

end.
