unit win_def;
interface

{$I options.pp}

uses
 {$IFDEF Turbo} skl_defs, {$ENDIF} 
 {$IFDEF FPC}   sk_types, {$ENDIF} 
 Tv_box,
 Views, Drivers, Objects;

{------------------------------------------}


const
 bwNoType = 0; { undefined brouse }
 bwFiles  = 1; { files root brouse }
 bwDesign = 2;
 bwURoot  = 3;
 bwUChois = 4;
 bwUIncl  = 5;
 bwUSet   = 6;
 bwFldSel = 7;

type
 PBrouseWindow = ^TBrouseWindow;
 TBrouseWindow = object(TSWindow)
  bwCase:byte; PData:pointer;
  MyCmdSet:set of byte;
  VScrollBar: PSVertSBar; ScrollPage:byte;
  DrawPos, DrawSize:TPoint; WinCursor,DeltaV:longint;
  BlankLine, HeadLine:string[80];
  SummLineExist:boolean;
  constructor Init(
   aBWCase:byte; aPData:pointer;
   aRect:TRect; aVstart, aVSize:byte; aHL:string; aSLE:boolean);
  procedure HeadTile; virtual;
  function LastLine:longint; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure Draw; virtual;
  procedure InitLimits; virtual;
  procedure SetWCursor(l:longint); virtual;
  procedure CorrectEnable; virtual;
  procedure ChangeWCursor(l:longint); virtual;
  procedure ShowWLine(l:longint); virtual;
  procedure SetState(AState: Word; Enable: Boolean); virtual;
  procedure ShowWCursor; virtual;
  procedure ShowCnt; virtual;
  procedure DrawData; virtual;
  procedure DrawLine(i:byte); virtual;
  procedure NewDataWin; virtual;
  function Line(l:longint):string; virtual;
 end;

{------------------------------------------}

const
 CListMax = 50;

type
 PChoisList = ^TChoisList;
 TChoisList = object
  List:array[0..CListMax] of String[60];
  LCnt,HMax,Cur:byte;
  constructor Init;
  procedure Insert(s:string);
  procedure SetCursor(i:byte);
{$IFDEF Turbo}
  destructor Chois(var result:byte);
{$ENDIF}
{$IFDEF FPC}
  procedure Chois(var result:byte);
  destructor Done;
{$ENDIF}
 end;

{------------------------------------------}

implementation

uses
 menu_cmd,
 App;

{------------------------------------------}

var BWR:TRect;

constructor TBrouseWindow.Init(
 aBWCase:byte; aPData:pointer;
 aRect:TRect; aVstart, aVSize:byte; aHL:string; aSLE:boolean);
 var SR:TRect;
 begin
  BWR:=aRect;
  inherited Init(aRect,'',wnNoNumber);
  bwCase:=aBWCase; PData:=aPData; SummLineExist:=aSLE;
  case bwCase of
   bwUSet:Palette:=wpBrownWindow;
   bwNoType,bwUChois,bwFldSel:Palette:=wpGrayWindow;
   bwFiles,bwURoot,bwUIncl,bwDesign:Palette:=wpBlueWindow;
  end;
  Flags:=Flags and ($FF xor (wfMove+wfGrow+wfClose+wfZoom));
  case bwCase of
   bwUIncl,bwUChois,bwURoot,bwUSet,bwDesign,bwFldSel:
    Flags:=Flags or (wfClose+wfMove);
  end;
  Options := Options or (ofFirstClick{+ofCentered});

  HeadLine:=copy(aHL,1,80); DeltaV:=0;
  DrawPos.X:=1; DrawPos.Y:=aVStart;
  DrawSize.X:=aRect.B.X-aRect.A.X-2; DrawSize.Y:=aVSize;
  if SummLineExist then Dec(DrawSize.Y,2);
  ScrollPage:=DrawSize.Y; Dec(ScrollPage,ScrollPage shr 2);

  SR.Assign(Size.X - 1, aVStart, Size.X, aVStart+DrawSize.Y);
  New(VScrollBar,Init(SR));
  { GetPalette func. must be redefined to correspond to Palette }
  Insert(VScrollBar);
  case bwCase of
   bwNoType,bwFiles,bwDesign:SetWCursor(LastLine);
  end;
  MyCmdSet:=[];
 end;
procedure TBrouseWindow.SetWCursor(l:longint);
 begin
  WinCursor:=l;
  InitLimits;
  DrawView;
 end;
procedure TBrouseWindow.InitLimits;
 begin
  with VScrollBar^ do begin
   SetParams(WinCursor,LastLine,ScrollPage);
   if LastLine<DrawSize.Y
    then begin DeltaV:=0; hide end else show;
  end;
 end;
function TBrouseWindow.LastLine:longint; begin LastLine:=0 end;
procedure TBrouseWindow.ShowCnt;
 begin
 end;
procedure TBrouseWindow.HeadTile;
 var i,c,k:byte; s:string;
 begin
  if GetState(sfDragging) then c:=3
   else if GetState(sfActive) then c:=2 else c:=1;
  s:=''; REXpandStr(s,DrawSize.X,''); s:=''+s+RTChar;
  k:=(ord(SummLineExist) shl 1);
  if SummLineExist
   then WriteStr(0,DrawPos.Y+DrawSize.Y,s,c);
  if DrawPos.Y+DrawSize.Y+k<Size.Y-1
   then WriteStr(0,DrawPos.Y+DrawSize.Y+k,s,c);
  if DrawPos.Y>3 then WriteStr(0,DrawPos.Y-3,s,c);
  if DrawPos.Y>1 then WriteStr(0,DrawPos.Y-1,s,c);
  { Columns }
  WriteStr(1,DrawPos.Y-2,HeadLine,c); BlankLine:='';
  if Length(HeadLine)>0 then for i:=1 to Length(HeadLine)
   do if HeadLine[i]=VLChar then begin
    WriteStr(i,DrawPos.Y-3,           '',c);
    WriteStr(i,DrawPos.Y-1,           '',c);
    if SummLineExist then
     WriteStr(i,DrawPos.Y+DrawSize.Y, '',c);
    WriteStr(i,DrawPos.Y+DrawSize.Y+k,'',c);
    BlankLine:=BlankLine+VLChar;
   end
   else BlankLine:=BlankLine+' ';
 end;
function TBrouseWindow.Line(l:longint):string; begin Line:='' end;
procedure TBrouseWindow.ShowWLine(l:longint);
 begin
  WriteStr(DrawPos.X,DrawPos.Y+l-DeltaV,JustStr(Line(l),DrawSize.X),1);
 end;
procedure TBrouseWindow.ShowWCursor;
 var Active:boolean;
 begin
  Active:=(State and (sfActive+sfFocused)) <> 0;
  if Active then begin EnableCommands(MyCmdSet); CorrectEnable end;
  WriteStr(DrawPos.X,DrawPos.Y+WinCursor-DeltaV,
   JustStr(Line(WinCursor),DrawSize.X),6+ord(Active));
 end;
procedure TBrouseWindow.SetState(AState: Word; Enable: Boolean);
begin
  inherited SetState(AState, Enable);
  if (AState and (sfFocused + sfActive)) <> 0 then begin
   if not Enable then begin
    DisableCommands(MyCmdSet);
    EnableCommands(TCommandSet([cmClose,cmCancel]));
   end;
   ShowWCursor;
  end;
end;
procedure TBrouseWindow.CorrectEnable; begin end;
procedure TBrouseWindow.ChangeWCursor(l:longint);
 begin
  if (l>=DeltaV) and (l<DeltaV+DrawSize.Y)
   then begin ShowWLine(WinCursor); WinCursor:=l; ShowWCursor end
   else begin WinCursor:=l; DrawData end;
 end;
procedure TBrouseWindow.NewDataWin; begin end;
procedure TBrouseWindow.DrawLine(i:byte);
 begin if WinCursor=i+DeltaV then ShowWCursor else ShowWLine(DeltaV+i) end;
procedure TBrouseWindow.DrawData;
 var i:byte;
 begin
  if WinCursor<DeltaV then begin
   DeltaV:=WinCursor;
   if DeltaV>=DrawSize.Y shr 2 then Dec(DeltaV,DrawSize.Y shr 2);
   NewDataWin;
  end;
  if WinCursor>=DeltaV+DrawSize.Y then begin
   DeltaV:=WinCursor-DrawSize.Y+DrawSize.Y shr 2;
   NewDataWin;
  end;
  for i:=0 to DrawSize.Y-1 do DrawLine(i);
 end;
procedure TBrouseWindow.Draw;
 begin
  inherited Draw;
  HeadTile; ShowCnt; DrawData;
 end;
procedure TBrouseWindow.HandleEvent(var Event: TEvent);
 var Mouse:TPoint; SelectMode:boolean;
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evMouseDown: begin
     SelectMode:=Event.Double;
     repeat
      MakeLocal(Event.Where, Mouse);
     until not MouseEvent(Event, evMouseMove);
     if (Mouse.X >= DrawPos.X) and
        (Mouse.X < DrawSize.X + DrawPos.X) and
        (Mouse.Y < DrawSize.Y + DrawPos.Y) and
        (Mouse.Y >= DrawPos.Y)
      then begin
       VScrollBar^.SetValue(DeltaV+Mouse.Y-DrawPos.Y);
       if SelectMode then Message(@Self,evCommand,cmBrouseDouble,@Self);
      end;
    end;
   evKeyDown:
    case Event.KeyCode of
     kbUp:if WinCursor>0
      then VScrollBar^.SetValue(WinCursor-1);
     kbDown:if WinCursor<LastLine
      then VScrollBar^.SetValue(WinCursor+1);
     kbPgUp:if WinCursor>ScrollPage
      then VScrollBar^.SetValue(WinCursor-ScrollPage)
      else VScrollBar^.SetValue(0);
     kbPgDn:if WinCursor+ScrollPage<LastLine
      then VScrollBar^.SetValue(WinCursor+ScrollPage)
      else VScrollBar^.SetValue(LastLine);
     kbCtrlPgUp:VScrollBar^.SetValue(0);
     kbCtrlPgDn:VScrollBar^.SetValue(LastLine);
     kbEsc:Message(@Self,evCommand,cmClose,@Self);
     else Exit;
    end;
   evCommand:
    case Event.Command of
     cmNoCommand:{ Must be erased leter };
     else Exit;
    end;
   evBroadcast:
    case Event.Command of
     cmScrollBarChanged:ChangeWCursor(VScrollBar^.Value);
     else Exit;
    end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

{------------------------------------------}

type
 PChoisWindow = ^TChoisWindow;
 TChoisWindow = object (TBrouseWindow)
  constructor Init(aPList:PChoisList; aR:TRect);
  procedure HandleEvent(var Event: TEvent); virtual;
  function LastLine:longint; virtual;
  function Line(l:longint):string; virtual;
 end;

constructor TChoisWindow.Init(aPList:PChoisList; aR:TRect);
 begin
  inherited Init(bwNoType,aPList,aR,1,aR.B.Y-2,'',false);
  { Flags:=Flags or wfClose;}
  Options := Options or ofCentered;
  HelpCtx:=hcChoisList;
  MyCmdSet:=TCommandSet([cmClose,cmCancel]);
 end;
procedure TChoisWindow.HandleEvent(var Event: TEvent);
 var Handled:boolean; Mouse:TPoint;
 procedure CloseSelf(Command:word);
  begin EndModal(Command); Handled:=True end;
 begin
  Handled:=False;
  case Event.What of
   evMouseDown:if Event.Double then begin
     MakeLocal(Event.Where, Mouse);
     if (Mouse.X >= DrawPos.X) and
        (Mouse.X < DrawSize.X + DrawPos.X) and
        (Mouse.Y < DrawSize.Y + DrawPos.Y) and
        (Mouse.Y >= DrawPos.Y) then CloseSelf(cmClose);
    end;
   evCommand:case Event.Command of
     cmCancel,cmClose:CloseSelf(Event.Command);
    end;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;
function TChoisWindow.Line(l:longint):string;
 var PList:PChoisList absolute PData;
 begin if l<=LastLine then Line:=PList^.List[l] else Line:=BlankLine end;
function TChoisWindow.LastLine:longint;
 var PList:PChoisList absolute PData;
 begin LastLine:=PList^.LCnt-1 end;

constructor TChoisList.Init;
 begin LCnt:=0; HMax:=0; Cur:=0 end;
procedure TChoisList.Insert(s:string);
 begin if LCnt<=CListMax then begin
  HMax:=Max(HMax,length(s));
  List[LCnt]:=s; inc(LCnt)
 end end;
procedure TChoisList.SetCursor(i:byte); begin if i<LCnt then Cur:=i end;
{$IFDEF Turbo}
destructor TChoisList.Chois(var Result:byte);
{$ENDIF}
{$IFDEF FPC}
destructor TChoisList.Done;
 begin end;
procedure TChoisList.Chois(var Result:byte);
{$ENDIF}
 var P:PChoisWindow; R:TRect;
 begin 
  if LCnt>1 then begin
   R.Assign(0,0,HMax+2,Min(20,LCnt+2));
   New(P,Init(@Self,R)); P^.SetWCursor(Cur);
   if Application^.ExecView(P)=cmClose
    then Result:=P^.WinCursor
    else Result:=$FF;
   Dispose(P,Done);
  end 
  else if LCnt=0 then Result:=$FF else Result:=0;
{$IFDEF FPC}
  dispose(PChoisList(@Self),Done);
{$ENDIF}
 end;

end.
